2005-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Version 2.1.

	* NEWS: Remove notice of yytname change, since it was never in an
	official release.
	* data/glr.c (yydestroyGLRState): Rename local var to avoid shadowing
	diagnostic.
	* src/output.c (prepare): Likewise.
	* data/lalr1.cc (YYERROR_VERBOSE_IF): New macro.
	(yysyntax_error_): Use it to avoid GCC warning when YYERROR_VERBOSE
	is not defined.  This is an awful hack, but it's enough for now.
	All callers changed.
	* tests/glr-regression-at (make_value): Args are const pointers now,
	to avoid GCC warning.
	(Duplicated user destructor for lookahead): New test.  Currently
	skipped.  It fails on my host but I'm not sure it'll always fail.

2005-09-16  Akim Demaille  <akim@epita.fr>

	* src/symtab.h (struct symbol): Declare the printer and destructor
	as const, to avoid accidental calls to free.
	(symbol_destructor_set, symbol_printer_set): Adjust.
	* src/symtab.c: Adjust.

2005-09-16  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_token_enums): New.
	(b4_token_defines): Rename as...
	(b4_token_enums_defines): this.
	(b4_token_defines): New, output only the #defines.
	* data/yacc.c, data/glr.c: Adjust.
	* data/lalr1.cc: Use b4_token_enums instead of b4_token_enums_defines.
	* data/c.m4 (b4_yydestruct_generate, b4_yysymprint_generate): Define
	as default values.

2005-09-16  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (yylex_): Remove, inline its code.
	(yyreport_syntax_error_): Remove, replaced by...
	(yysyntax_error_): this which returns a string and leaves to the
	caller the call to the users' error function.
	(yylooka_, yyilooka_, yylval, yylloc, yyerror_range_, yyval, yyloc):
	Move from members of the parser object...
	(yylooka, yyilooka, yylval, yylloc, yyerror_range, yyval, yyloc):
	to local variables of the parse function.

2005-09-16  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Calc++ Parser): Don't promote defining YYEOF
	since it's in Bison's name space.

2005-09-15  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yyresolveValue): Add default case to pacify
	gcc -Wswitch-default.  Problem reported by twlevo@xs4all.nl.

	* NEWS: Document when yyparse started to return 2.
	* doc/bison.texinfo (Parser Function): Document when yyparse
	returns 2.

	* data/lalr1.cc: Revert part of previous change, as it's incompatible.
	(b4_filename_type): Renamed back from b4_file_name_type.  All uses
	changed.
	(class position): file_name -> filename (reverting).  All uses changed.

2005-09-14  Paul Eggert  <eggert@cs.ucla.edu>

	* examples/calc++/Makefile.am ($(calc_sources_generated)): Don't
	do anything if $@ exists.  This reverts part of the 2005-07-07
	patch.

2005-09-11  Paul Eggert  <eggert@cs.ucla.edu>

	* Makefile.am (EXTRA_DIST): Do not distribute REFERENCES; it
	contains obsolete information and isn't worth distributing as a
	separate file anyway.
	* data/glr.c [defined YYSETJMP]: Don't include <setjmp.h>.
	(YYJMP_BUF, YYSETJMP, YYLONGJMP) [!defined YYSETJMP]: New macros.
	All uses of jmp_buf, setjmp, longjmp changed to use these instead.
	(yyparse): Abort if user code uses longjmp to throw an unexpected
	value.

2005-09-09  Paul Eggert  <eggert@cs.ucla.edu>

	* data/c.m4 (b4_identification): Define YYBISON_VERSION.
	Suggested by twlevo@xs4all.nl.

	* data/glr.c (YYCHK1): Do not assume YYE is in range.
	This avoids a diagnostic from gcc -Wswitch-enum.
	Problem reported by twlevo@xs4all.nl.

	* doc/bison.texinfo: Don't use "filename", as per GNU coding
	standards.  Use "file name" or "file" or "name", depending on
	the context.
	(Invocation): The output of "bison hack/foo.y" goes to foo.tab.c,
	not to hack/foo.tab.c.
	(Calc++ Top Level): 2nd arg of main is not const.
	* data/glr.c: b4_filename -> b4_file_name.
	* data/lalr1.cc: Likewise.  Also, b4_filename_type -> b4_file_name_type.
	All uses changed.
	(class position): filename -> file_name.  All uses changed.
	* data/yacc.c: b4_filename -> b4_file_name.
	* lib/bitset.h: filename -> file_name in local vars.
	* lib/bitset_stats.c: Likewise.
	* src/files.c: Likewise.
	* src/scan-skel.l ("@output ".*\n): Likewise.
	* src/files.c (file_name_split): Renamed from filename_split.
	* src/muscle_tab.c (muscle_init): Output b4_file_name, not b4_filename.

2005-09-08  Paul Eggert  <eggert@cs.ucla.edu>

	* lib/.cvsignore: Add pipe-safer.c, stdio--.h, unistd--.h,
	to accommodate latest gnulib.

	* tests/glr-regression.at (Duplicate representation of merged trees):
	Add casts to pacify g++.  Problem reported by twlevo@xs4all.nl.

	* bootstrap: Add comment as to why the AM_LANGINFO_CODESET hack is
	needed.

2005-08-26  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yydestroyGLRState): Renamed from yydestroyStackItem.
	All uses changed.  Invoke user destructor after an error during a
	split parse (trivial change from Joel E. Denny).

	* tests/glr-regression.at
	(User destructor after an error during a split parse):  New test case.
	Problem reported by Joel E. Denny in:
	http://lists.gnu.org/archive/html/bison-patches/2005-08/msg00029.html

2005-08-25  Paul Eggert  <eggert@cs.ucla.edu>

	* README-cvs: Give URLs for recommended tools.
	Mention Gzip version problem, and bootstrapping issues.
	Remove troubleshooting section, as it's somewhat obsolete.

	* bootstrap (no_cache): New var, to accommodate different wget
	variants.  Use it instead of '-C off'.  Problem reported by
	twlevo@xs4all.nl.

	* data/glr.c (yydestroyStackItem): New function.
	(yyrecoverSyntaxError, yyreturn): Use it to improve quality of
	debugging information.  Problem reported by Joel E. Denny.

2005-08-25  Akim Demaille  <akim@epita.fr>

	* tests/local.at (AT_COMPILE_CXX): Pass $LINKS too.

2005-08-24  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yyrecoverSyntaxError, yyreturn):
	Don't invoke destructor on unresolved entries.
	* tests/glr-regression.at
	(User destructor for unresolved GLR semantic value): New test case.
	Problem reported by Joel E. Denny in:
	http://lists.gnu.org/archive/html/bison-patches/2005-08/msg00016.html

2005-08-21  Paul Eggert  <eggert@cs.ucla.edu>

	* lib/.cvsignore: Remove realloc.c, strncasecmp.c, xstrdup.c.
	Add strnlen.c.
	* m4/.cvsignore: Remove codeset.m4, gettext.m4, lib-ld.m4,
	lib-prefix.m4, po.m4.

	* data/glr.c (yyreturn): Use "Cleanup:" rather than "Error:"
	in yydestruct diagnostic, since it might not be an error.
	Problem reported by Joel Denny near end of
	<http://lists.gnu.org/archive/html/help-bison/2005-07/msg00040.html>.
	* data/lalr1.cc (yyerturn): Likewise.
	* data/yacc.c (yyreturn): Likewise.
	* tests/calc.at (_AT_CHECK_CALC_ERROR): Adjust to the above change.

	* src/files.c: Remove obsolete FIXME comment.

	* data/glr.c (YY_SYMBOL_PRINT): Append a newline, for consistency
	with the other templates, and to fix bogus run-on messages such
	as the one reported at the end of
	<http://lists.gnu.org/archive/html/help-bison/2005-07/msg00040.html>.
	All callers changed to avoid the newline.
	(yyprocessOneStack): Output two lines rather than one, to accommodate
	the above change.  This changes the debug output format slightly.

	* data/glr.c (yyresolveValue): Fix redundant parse tree problem
	reported by Joel E. Denny in
	<http://lists.gnu.org/archive/html/bison-patches/2005-08/msg00004.html>
	(trivial change).
	* tests/glr-regression.at (Duplicate representation of merged trees):
	New test, from Joel E. Denny in:
	<http://lists.gnu.org/archive/html/help-bison/2005-07/msg00013.html>.
	* THANKS: Add Joel E. Denny.

	* configure.ac (AC_INIT): Bump to 2.0c.

2005-07-24  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Version 2.0b.

	* Makefile.am (SUBDIRS): Put examples before tests, so that
	"make check" doesn't finish with "All 1 tests passed".

	* tests/regression.at (Token definitions): Don't rely on
	AT_PARSER_CHECK for data that contains backslashes.  It currently
	uses 'echo', and 'echo' isn't portable if its argument contains
	backslashes.  Problem found on OpenBSD 3.4.  Also, do not assume
	that the byte '\0xff' is not printable in the C locale; it is,
	under OpenBSD 3.4 (!).  Luckily, '\0x80' through '\0x9e' are
	not printable, so use '\0x81' to test.

	* data/glr.c (YYOPTIONAL_LOC): Define even if it's not a recent
	version of GCC, since the macro is used with non-GCC compilers.

	Fix core dump reported by Pablo De Napoli in
	<http://lists.gnu.org/archive/html/bug-bison/2005-07/msg00053.html>.
	* tests/regression.at (Invalid inputs with {}): New test.
	* src/parse-gram.y (token_name): Translate type before using
	it as an index.

	* data/glr.c (ATTRIBUTE_UNUSED): Remove, since it infringes on
	the user's name space.  All uses changed to __attribute__
	((__unused__)).
	(yyFail, yyMemoryExhausted, yyreportAmbiguity):
	Add __attribute__ ((__noreturn__)).

	* etc/clcommit: Remove.  We weren't using it, and it failed
	"make maintainer-distcheck".
	* Makefile.maint: Merge from coreutils.
	(CVS_LIST, CVS_LIST_EXCEPT): New macros.
	(syntax-check-rules): Change list of rules as described below.
	(sc_cast_of_alloca_return_value, sc_dd_max_sym_length):
	(sc_file_system, sc_obsolete_symbols, sc_prohibit_atoi_atof):
	(sc_prohibit_jm_in_m4, sc_root_tests, sc_tight_scope):
	(sc_trailing_space): New rules.
	(sc_xalloc_h_in_src): Remove.
	(sc_cast_of_argument_to_free, sc_cast_of_x_alloc_return_value):
	(sc_space_tab, sc_error_exit_success, sc_changelog):
	(sc_system_h_headers, sc_sun_os_names, sc_unmarked_diagnostics):
	(makefile-check, po-check, author_mark_check):
	(makefile_path_separator_check, copyright-check):
	Use grep -n, to make it easier to find violations.
	Use CVS_LIST and CVS_LIST_EXCEPT.
	(header_regexp, h_re): Remove.
	(dd_c): New macro.
	(sc_dd_max_sym_length, .re-list, news-date-check): New rules.
	(my-distcheck): Use more-modern GCC flags.
	(signatures, %.asc): Remove.
	(rel-files, announcement): Remove signatures.
	Restore old updating code, even though we don't use it, so
	that we're the same as coreutils.
	(alpha, beta, major): Depend on news-date-check.
	Make the upload commands.

	* data/c.m4, data/lalr1.cc, data/yacc.c: Normalize white space.
	* lib/abitset.h, lib/bbitset.h, lib/bitset.h: Likewise.
	* lib/bitset_stats.c, lib/ebitset.h, lib/lbitset.c: Likewise.
	* lib/libitset.h, lib/timevar.c, lib/vbitset.h: Likewise.
	* src/Makefile.am, src/gram.c, src/muscle_tab.h: Likewise.
	* src/parse-gram.y, src/system.h, src/tables.c, src/vcg.c: Likewise.
	* src/vcg_defaults.h, tests/cxx-type.at, tests/existing.at: Likewise.
	* tests/sets.at: Likewise.

	* data/m4sugar/m4sugar.m4: Sync from Autoconf, except that
	we comment out the Autoconf version number.
	* doc/bison.texinfo (Calc++ Scanner): Don't use atoi, as
	it's error-prone and "make maintainer-distcheck" rejects it.

	* lib/subpipe.c: Include <fcntl.h> without checking for HAVE_FCNTL_H.
	Indent calls to "error" to pacify "make maintainer-distcheck",
	when the calls are not intended to be translated.
	* m4/subpipe.m4 (BISON_PREREQ_SUBPIPE): Don't check for fcntl.h.

	* src/Makefile.am (DEFS): Use +=, to pacify
	"make maintainer-distcheck".
	(bison_SOURCES): Add scan-skel.h.
	(sc_tight_scope): New rule, from coreutils.

	* src/files.c (src_extension, header_extension):
	Now static, not extern.
	* src/getargs.c (short_options): Likewise.
	* src/muscle_tab.c (muscle_table): Likewise.
	* src/parse-gram.y (current_class, current_type, current_prec):
	Likewise.
	* src/reader.c (grammar_end, previous_rule_end): Likewise.
	* src/getargs.h: Redo comments to pacify "make maintainer-distcheck".
	* src/main.c (main): Cast bindtextdomain and textdomain calls to
	void, to avoid warning when NLS is disabled.
	* src/output.c: Include scan-skel.h.
	(scan_skel): Remove decl, since scan-skel.h does this.
	(output_skeleton):
	Indent calls to "error" to pacify "make maintainer-distcheck".
	* src/print_graph.c: Don't include <obstack.h>, as system.h does this.
	* src/reader.h (gram_end, gram_lineno): New decls to pacify
	"make maintainer-distcheck".
	* src/scan-skel.l (skel_lex, skel_get_lineno, skel_get_in):
	(skel_get_out, skel_get_leng, skel_get_text, skel_set_lineno):
	(skel_set_in, skel_set_out, skel_get_debug, skel_set_debug):
	(skel_lex_destroy, scan_skel): Move these decls to...
	* src/scan-skel.h: New file.
	* src/uniqstr.c (uniqstr_assert):
	Indent calls to "error" to pacify "make maintainer-distcheck".

	* tests/Makefile.am ($(srcdir)/package.m4): Use $(VAR),
	not @VAR@.

	* tests/torture.at: Revamp to avoid misuse of atoi that
	"make maintainer-distcheck" complained about.

	* examples/extexi (message): Don't print a message more than once,
	and omit line-number decoration that makes Emacs compile think
	that informative messages are worth worrying about.

2005-07-22  Paul Eggert  <eggert@cs.ucla.edu>

	* configure.ac: Update version number.

	* Makefile.am (SUBDIRS): Add examples; somehow this got removed
	accidentally.
	* examples/calc++/calc++-parser.yy: Remove from CVS, as it's
	autogenerated by the maintainer.
	* examples/calc++/.cvsignore: Add *.yy.

	* lib/bitset.c (bitset_alloc): Don't cast xcalloc result.
	* lib/bitset_stats.c (bitset_stats_init): Likewise.
	* lib/bitsetv.c (bitsetv_alloc): Likewise.

	* po/POTFILES.in: Add lib/xalloc-die.c; remove lib/xmalloc.c.

	* src/relation.c (relation_transpose): Rewrite to avoid bogus complaint
	from maintainer-distcheck about casting the argument of 'free'.

	* NEWS: Mention recent yytname changes.
	* THANKS: Add Anthony Heading, twlevo@xs4all.nl.

	* bootstrap: For translations that have not yet been upgraded to
	the new runtime-po domain, prime the pump by extracting the
	relevant strings from the obsolete translations.  This code can be
	removed once the bison-runtime domain has been translated by each
	team.

	* src/scan-gram.l (<SC_PRE_CODE>.): Don't double-quote token names,
	now that token names are already quoted.

	Fix problem reported by Anthony Heading.
	* data/glr.c (YYTOKEN_TABLE): New macro.
	(yytname): Define if YYTOKEN_TABLE.
	* data/yacc.c (YYTOKEN_TABLE, yytname): Likewise.
	* data/lalr1.cc (YYTOKEN_TABLE, yytname_): Likewise.
	(YYERROR_VERBOSE): Define the same way the other skeletons do.
	* src/output.c (prepare_symbols): Output token_table_flag.

2005-07-21  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yyinitGLRStack, yyreturn): Don't call malloc
	again if the first call fails.

	* data/glr.c (yytnamerr): New function.
	(yyreportSyntaxError): Use it to dequote most string literals.
	* data/lalr1.c (yytname_): Renamed from yyname_, for compatibility
	with other skeletons.  All uses changed.
	(yytnameerr_): New function.
	(yyreport_syntax_error): Use it to dequote most string literals.
	* data/yacc.c (yytnamerr): New function.
	(yyerrlab): Use it to decode most string literals.
	* doc/bison.texinfo (Decl Summary, Calling Convention):
	Clarify quoting convention of yytname.
	* src/output.c (prepare_symbols): Quote all names.  This undoes
	the 2005-04-17 change, which is now accomplished (mostly) via
	changes in the parsers as described above.
	* tests/regression.at (Token definitions, Web2c Actions):
	Undo most 2005-04-17 change here, too.

2005-07-20  Paul Eggert  <eggert@cs.ucla.edu>

	Fix more problems reported by twlevo@xs4all.nl.
	* tests/cxx-type.at: Don't pipe output of ./types through sed to
	remove trailing spaces.  This loses the exit status of ./types,
	and isn't needed since ./types shouldn't be emitting trailing
	spaces.
	* data/glr.c (yyreturn): Don't pop stack if yyinitStateSet failed,
	as the stack isn't valid in that case.

	* src/scan-gram.l (gram_get_lineno, gram_get_in, gram_get_out):
	(gram_get_leng, gram_get_text, gram_set_lineno, gram_set_in):
	(gram_set_out, gram_get_debug, gram_set_debug, gram_lex_destroy):
	Add declarations to pacify "gcc -Wmissing-prototypes" when flex 2.5.31
	is used.
	* src/scan-skel.l (skel_get_lineno, skel_get_in, skel_get_out):
	(skel_get_leng, skel_get_text, skel_set_lineno, skel_set_in):
	(skel_set_out, skel_get_debug, skel_set_debug, skel_lex_destroy):
	Likewise.

	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Work even with
	overly-picky compilers that reject 'char *foo = "bar";'.

	* src/symtab.c (SYMBOL_ATTR_PRINT, symbol_print): Direct output
	to FILE * parameter, not to stderr.  This fixes a typo introduced
	in the 2005-07-12 change.

	* lib/subpipe.c (create_subpipe): Rewrite slightly to avoid
	warnings from GCC 4.

	* data/glr.c (yyexpandGLRStack, yyaddDeferredAction, yyexpandGLRStack):
	(yyglrShiftDefer, yysplitStack):
	Remove unused parameters b4_pure_formals.  All uses changed.
	(yyglrShift): Remove unused parameters b4_user_formals.
	All uses changed.
	(yyglrReduce): Removed unused parameter yylocp.  All uses changed.

2005-07-18  Paul Eggert  <eggert@cs.ucla.edu>

	Destructor cleanups and regularization among the three skeletons.
	* NEWS: Document the behavior changes.
	* data/glr.c (yyrecoverSyntaxError): Don't bother to pop the
	stack before failing, as the cleanup code will do it for us now.
	* data/lalr1.cc (yyerrlab): Likewise.
	* data/glr.c (yyparse): Pop everything off the stack before
	freeing it, so that destructors get called properly.
	* data/lalr1.cc (yyreturn): Likewise.
	* data/yacc.c (yyreturn): Pop and destroy the start symbol, too.
	This is more consistent.
	* doc/bison.texinfo (Destructor Decl): Mention more reasons
	why destructors might be called.  1.875 -> 2.1.
	(Destructor Decl, Decl Summary, Table of Symbols):
	Some English-language cleanups for %destructor.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR):
	Add output line for destructor of start symbol.
	* tests/calc.at (AT_CHECK_CALC): Add one to line counts,
	because of that same extra output line.

	* NEWS: Document minor wording changes in diagnostics of
	Bison-generated parsers.
	* data/glr.c (yyMemoryExhausted): Renamed from yyStackOverflow.
	Remove unused formals.  All uses changed.
	(yyreportAmbiguity): "ambiguity detected" -> "syntax is ambiguous".
	(yyparse): Rename yyoverflowlab to yyexhaustedlab.
	* data/yacc.c (yyparse): "parser stack overflow" -> "memory exhausted".
	Rename yyoverflowab to yyexhaustedlab.
	When memory exhaustion occurs during syntax-error reporting,
	report it separately rather than in a single diagnostic; this
	eases translation.
	* doc/bison.texinfo (Memory Management): Renamed from Stack Overflow.
	(Memory Exhausted): Renamed from Parser Stack Overflow.
	Revamp wording slightly to prefer "memory exhaustion".
	* tests/actions.at: "parser stack overflow" -> "memory exhausted".

	* data/c.m4 (b4_yysymprint_generate): Use YYFPRINTF, not fprintf.

	Add i18n support to the GLR skeleton.  Partially fix the C++
	skeleton; a C++ expert needs to finish this.  Remove debugging
	msgids; there's little point to having them translated, since they
	can be understood only by someone who can read the
	(English-language) source code.

	Generate runtime-po/bison-runtime.pot automatically, so that we
	don't have to worry about garbage getting in that file.  We'll
	make sure after the next official release that old msgids don't
	get lost.  See
	<http://lists.gnu.org/archive/html/bison-patches/2005-07/msg00119.html>.

	* runtime-po/Makefile.in.in, runtime-po/bison-runtime.pot: Remove.
	Now auto-generated.
	* PACKAGING: Don't claim that Gawk, GCC, Perl use this method yet.
	Fix typos in explanations of the runtime file.
	* bootstrap: Change gettext keyword from YYI18N to YY_.
	Use standard Makefile.in.in in runtime-po, since we'll arrange
	for backward-compatible bison-runtime.po files in a different way.
	* data/glr.c (YY_): New macro, from yacc.c.
	(yyuserAction, yyreportAmbiguity, yyreportSyntaxError, yyparse):
	Translate messages intended for users.
	(yyreportSyntaxError): Change "virtual memory" to "memory" to match
	the wording in the other skeletons.  We don't know that the memory
	is virtual.
	* data/lalr1.cc (YY_): Renamed from _.  All uses changed.
	Use same method that yacc.c uses.
	Don't translate debugging messages.
	(yy::yyreport_syntax_error): Put in a FIXME for the i18n stuff;
	it doesn't work (yet), and requires C++ expertise to fix.
	* data/yacc.c (YY_): Renamed from YY18N.  All uses changed.
	Move defn to a more logical place, to be consistent with other
	skeletons.
	Don't translate debugging messages.
	Don't assume line numbers fit in unsigned int; use unsigned long fmts.
	* doc/bison.texinfo: Mention <libintl.h>.  Change glibc cross reference
	to gettext cross reference.  Add indexing terms.  Mention YYENABLE_NLS.
	* runtime-po/POTFILES.in: Add data/glr.c, data/lalr1.cc.

	Fix yyerror / yylex test glitches noted by twlevo@xs4all.nl.
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Have yyerror return
	void, not int.
	* tests/glr-regression.at (Badly Collapsed GLR States):
	Likewise.
	(Improper handling of embedded actions and dollar(-N) in GLR parsers):
	yylex should return 0 at EOF rather than aborting.

	Improve tests for stack overflow in GLR parser.
	Problem reported by twlevo@xs4all.nl.
	* data/glr.c (struct yyGLRStack): Remove yyerrflag member.
	All uses removed.
	(yyStackOverflow): Just longjmp, but with value 2 so that caller
	can handle the problem.
	(YYCHK1): Use goto (a la yacc.c) rather than setting a flag.
	(yyparse): New local variable yyresult to record the result.
	Use result of setjmp to set it, rather than storing itinto
	struct.
	(yyDone): Remove label.
	(yyacceptlab, yyabortlab, yyoverflowlab, yyreturn): New labels,
	to mimic yacc.c.  Do not discard lookahead if it's EOF (possible
	if YYABORT is used).
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Exit with
	yyparse status; put status > 1 into diagnostic.
	Check that status==2 works.
	* tests/calc.at, tests/cxx-type.at, tests/glr-regression.at:
	Use exit status 3 for failure to open (which shouldn't happen).

2005-07-17  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/conflicts.at (%nonassoc and eof):  Don't exit with status
	1 on syntax error; just let yyparse do its thing.
	* tests/glr-regression.at (Badly Collapsed GLR States): Likewise.
	* tests/torture.at (AT_DATA_STACK_TORTURE): Likewise.
	(Exploding the Stack Size with Alloca):
	(Exploding the Stack Size with Malloc):
	Expect exit status 2, not 1, since the parser is supposed to blow
	its stack.  Problem reported by twlevo@xs4all.nl.

	* data/glr.c (yyparse): Don't assume that the initial calls
	to YYMALLOC succeed; in that case, yyparse incorrectly returned 0.
	Print a stack-overflow message and fail instead.
	Initialize the line-number information before creating the stack,
	so that the stack-overflow message can report line zero safely.

2005-07-14  Paul Eggert  <eggert@cs.ucla.edu>

	Fix problems reported by twlevo@xs4all.nl.
	* data/glr.c (YYSTACKEXPANDABLE): Don't define if already defined.
	(yyuserMerge): Provide a default case if b4_mergers is empty.
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Define YYSTACKEXPANDABLE.
	* tests/glr-regression.at
	(Improper handling of embedded actions and dollar(-N) in GLR parsers):
	Add casts to pacify C++ compilers.
	* tests/glr-regression.at (Improper merging of GLR delayed action
	sets): Declare yylex before using it.
	* tests/Makefile.am (maintainer-check-g++): Fix a stray
	$(GXX) that escaped the renaming of GXX to CXX.  Remove bogus
	test for valgrind; valgrind is independent of g++.
	(maintainer-check-posix): Add _POSIX2_VERSION=200112, to check
	for compatibility with POSIX 1003.1-2001 (if running coreutils).
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Port to stricter C++.
	Use a destructor, so that we can expand the stack.  Change
	YYSTYPE to char * so that we can free it.  Cast result of malloc.

2005-07-13  Paul Hilfinger  <hilfingr@CS.Berkeley.EDU>

	* data/glr.c (yyuserAction): Fix uninitialized variable that caused
	a valgrind failure.  Problem reported by twlevo@xs4all.nl.

2005-07-13  Paul Eggert  <eggert@cs.ucla.edu>

	* PACKAGING: New file, suggested by Bruno Haible and taken from
	similar wording in gettext's PACKAGING file.
	* NEWS: Mention PACKAGING.
	* Makefile.am (EXTRA_DIST): Add PACKAGING.

2005-07-12  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Document recent i18n improvements.
	* bootstrap: Get runtime translations into runtime-po.
	Create runtime-po files automatically, if possible.
	* configure.ac: Invoke BISON_I18N, so that we eat our own dog food.
	* data/yacc.c: Rewrite inclusion of <libintl.h> so that ENABLE_NLS
	does not infringe on the user's name space.
	(YYENABLE_NLS): Renamed from ENABLE_BISON_NLS.
	* doc/bison.texinfo (Internationalization): Revamp the English
	and Texinfo syntax a bit, to try to make it clearer.
	(Bison Options, Option Cross Key): Mention --print-localedir.
	* m4/bison-i18n.m4 (BISON_I18N): Rename ENABLE_BISON_NLS to
	YYENABLE_NLS.  Quote a bit more.
	* runtime-po/.cvsignore: New file.
	* runtime-po/Makefile.in.in (mostlyclean): Remove *.old.pot.
	* runtime-po/Rules-quot: Remove; now created by bootstrap.
	* runtime-po/quot.sed: Likewise.
	* runtime-po/boldquot.sed: Likewise.
	* runtime-po/en@quot.header: Likewise.
	* runtime-po/en@boldquot.header: Likewise.
	* runtime-po/insert-header.sin: Likewise.
	* runtime-po/remove-potcdate.sin: Likewise.
	* runtime-po/Makevars: Likewise.
	* runtime-po/LINGUAS: Likewise.
	* runtime-po/de.po: Likewise; we will rely on the translation project
	to maintain this, so "bootstrap" should get it.
	* src/getarg.c (PRINT_LOCALEDIR_OPTION): Let the C compiler determine
	its value.
	* src/main.c (main): Bind the bison-runtime domain, too.

2005-07-12  Bruno Haible  <bruno@clisp.org>

	* data/yacc.c: Include <libintl.h> when NLS is enabled.
	(YYI18N): Renamed from _. Use dgettext when NLS is enabled.
	* po/POTFILES.in: Remove autogenerated file src/parse-gram.c.
	* runtime-po: New directory.
	* runtime-po/Makefile.in.in: New file, copied from po/, with modified
	$(DOMAIN).pot-update rule, so that old messages are never dropped.
	* runtime-po/Rules-quot: New file, copied from po/.
	* runtime-po/quot.sed: Likewise.
	* runtime-po/boldquot.sed: Likewise.
	* runtime-po/en@quot.header: Likewise.
	* runtime-po/en@boldquot.header: Likewise.
	* runtime-po/insert-header.sin: Likewise.
	* runtime-po/remove-potcdate.sin: Likewise.
	* runtime-po/Makevars: New file.
	* runtime-po/POTFILES.in: New file.
	* runtime-po/LINGUAS: New file.
	* runtime-po/bison-runtime.pot: New file.
	* runtime-po/de.po: New file.
	* m4/bison.m4: New file.
	* Makefile.am (SUBDIRS): Add runtime-po.
	(aclocaldir, aclocal_DATA): New variables.
	* configure.ac: Add AC_CONFIG_FILES of runtime-po/Makefile.in.
	Define aclocaldir.
	* src/getargs.c (usage): Document --print-localedir option.
	(PRINT_LOCALEDIR_OPTION): New enum item.
	(long_options): Add --print-localedir option.
	(getargs): Handle --print-localedir option.
	* doc/bison.texinfo (Bison Parser): Remove paragraph about _().
	(Internationalization): New section.

2005-07-12  Akim Demaille  <akim@epita.fr>

	* src/symtab.h, src/symtab.c (symbol_print): Swap the arguments,
	for consistency with the rest of the code.
	* src/symlist.h, src/symlist.c (symbol_list_print): Ditto.
	Add separators.

2005-07-12  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y: Use %printer instead of YYPRINT.

2005-07-12  Akim Demaille  <akim@epita.fr>

	* src/symtab.h, src/symtab.c (symbol_print): New.
	* src/symlist.h, src/symlist.c (symbol_list_print): New.
	* src/symlist.c (symbol_list_n_type_name_get): Report the culprit.

2005-07-12  Akim Demaille  <akim@epita.fr>

	* data/glr.c (b4_syncline): Fix (swap) the definitions of
	b4_at_dollar and b4_dollar_dollar.

2005-07-11  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/bison.texinfo (Mystery Conflicts): Add reference to DeRemer
	and Pennello's paper.

2005-07-09  Paul Eggert  <eggert@cs.ucla.edu>

	* data/yacc.c (yyparse): Undo previous patch.  Instead,
	set yylsp[0] and yyvsp[0] only if the initial action
	sets yylloc and yylval, respectively.

	* data/yacc.c (yyparse): In the initial action, set
	yylsp[0] and yyvsp[0] rather than yylloc and yylval.
	This avoids the use of undefined variables if the initial
	action does not set yylloc and/or yylval.

2005-07-07  Paul Eggert  <eggert@cs.ucla.edu>

	* examples/calc++/calc++-driver.cc, examples/calc++/calc++-driver.hh:
	* examples/calc++/calc++-scanner.ll, examples/calc++/calc++.cc:
	Remove from CVS.  These files are automatically generated.
	* examples/extexi: Clarify that this file is now part of Bison,
	not GNU M4, and that it works with any POSIX-compatible Awk.
	* examples/calc++/Makefile.am (run_extexi): Remove; not used.
	($(calc_extracted)): Renamed from $(calc_sources_extracted),
	so that we also get calc++-parser.yy.  Geneate it.
	Use $(AWK), not gawk, since any conforming Awk will do.
	Put comment before action, since older 'make' can't handle comment
	in action.
	$(BUILT_SOURCES): List all built sources, not just some of them.
	$(MAINTAINERCLEANFILES): Remove *.stamp, and all built sources.
	$($(srcdir)/calc++-parser.stamp): Work even if POSIXLY_CORRECT.
	$($(calc_sources_generated)): Remove unnecessary test for existence
	of target.  (This had a shell syntax error anyway; a stray "x".)
	(calc_extracted): List $(srcdir)/calc++-parser.yy, not
	calc++-parser.yy.
	* examples/.cvsignore, examples/calc++/.cvsignore: New files.

	* bootstrap (gnulib_modules): Add gettext, now that it's no longer
	implied by the other modules.

2005-07-06  Akim Demaille  <akim@epita.fr>

	Bind examples/calc++ to the package.
	* examples/calc++/Makefile: Remove, replaced by...
	* examples/calc++/Makefile.am: ... this new file.
	* examples/calc++/test: Remove input.
	* examples/calc++/compile: Remove.
	* examples/Makefile.am: New.
	* configure.ac, Makefile.am: Adjust.
	* doc/Makefile.am (clean-local): New, for more recent texi2dvis.

2005-07-05  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yyFail): Drastically simplify; since the format argument
	never had any % directives, we can simply pass it to yyerror.
	(yyparse): Use "t a; a=b;" rather than "t a = b;" when a will
	be modified later, as that is the usual style in glr.c.
	Problems reported by Paul Hilfinger.

	Rewrite GLR parser to catch more buffer overrun, storage exhaustion,
	and size overflow errors.
	* data/glr.c: Include <stdio.h> etc. after user prolog, not before,
	in case the user prolog sets feature-test macros like _GNU_SOURCE.
	(YYSIZEMAX): New macro.
	(yystpcpy): New function, taken from yacc.c.
	(struct yyGLRStack.yyspaceLeft): Now size_t, not int.
	(yyinitGLRStack, yyfreeGLRstack): Remove unnecessary forward decls,
	so that we don't have to maintain their signatures.
	(yyFail): Check for buffer overflow, by using vsnprintf rather
	than vsprintf.  Allocate a bigger buffer if possible.
	Report an error if buffer allocation fails.
	(yyStackOverflow): New function.
	(yyinitStateSet, yyinitGLRStack): Return a boolean indicating whether
	the initialization was successful.  It might fail if storage was
	exhausted.
	(yyexpandGLRStack): Add more checks for storage allocation failure.
	Use yyStackOverflow to report failures.
	(yymarkStackDeleted, yyglrShift, yyglrShiftDefer, yydoAction):
	(yysplitStack, yyprocessOneStack, yyparse, yypstack):
	Don't assume stack number fits in int.
	(yysplitStack): Check for storage allocation failure.
	(yysplitStack, yyprocessOneStack): Add pure_formals, so that we
	can print diagnostics on storage allocation failure.  All callers
	changed.
	(yyresolveValue): Use yybool for boolean.
	(yyreportSyntaxError): Check for size-calculation overflow.
	This code is taken from yacc.c.
	(yyparse): Check for storage allocation errors when allocating
	the initial stack.

2005-07-05  Akim Demaille  <akim@epita.fr>

	Extract calc++ from the documentation.
	* doc/bison.texinfo (Calc++): Add the extraction marks.
	* examples/extexi: New, from the aborted GNU Programming 2E.
	Separate the different paragraph of a file with empty lines.
	* examples/Makefile: Use it to extract the whole calc++ example.

2005-06-24  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (C++ Parser Interface): Use defcv to define
	class typedefs.

2005-06-22  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (C++ Language Interface): First stab.
	(C++ Parsers): Remove.

2005-06-22  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (yylex_): Honor %lex-param.

2005-06-22  Akim Demaille  <akim@epita.fr>

	Start a set of simple examples.
	* examples/calc++/Makefile, examples/calc++/calc++-driver.cc,
	* examples/calc++/calc++-driver.hh,
	* examples/calc++/calc++-parser.yy,
	* examples/calc++/calc++-scanner.ll, examples/calc++/calc++.cc,
	* examples/calc++/compile, examples/calc++/test: New.

2005-06-09  Paul Eggert  <eggert@cs.ucla.edu>

	* data/yacc.c (malloc, free) [defined __cplusplus]: Wrap inside
	extern "C" {}.  This fixes a problem reported by Paul Hilfinger,
	which stems from the 2005-05-27 patch.

2005-06-06  Paul Hilfinger  <hilfingr@tully.CS.Berkeley.EDU>

	* data/glr.c: Modify treatment of unused parameters to permit use
	of g++ (which doesn't allow __attribute__ ((unused)) for parameters).

2005-05-30  Paul Eggert  <eggert@cs.ucla.edu>

	Fix infringement on user name space reported by Janos Zoltan Szabo.
	* data/yacc.c (yyparse): strlen -> yystrlen.

2005-05-30  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (_): New.
	Translate the various messages.

2005-05-27  Paul Eggert  <eggert@cs.ucla.edu>

	Fix infringement on user name space reported by Bruno Haible.
	* data/yacc.c (YYSIZE_T): Define first, so that later decls can use it.
	Prefer GCC's __SIZE_TYPE__ if available, so that we don't infringe on
	the user's name space.
	(alloca): Include <stdlib.h> to get it, if it's not built in.
	(YYMALLOC, YYFREE): Define only if needed.
	(malloc, free): Declare, but only if needed, as this infringes on
	the user name space.

2005-05-25  Paul Eggert  <eggert@cs.ucla.edu>

	Fix BeOS, FreeBSD, MacOS porting problems reported by Bruno Haible.
	* lib/bitset.c (bitset_print): Don't assume size_t can be printed
	with %d format.
	* lib/ebitset.c (min, max): Undef before defining.
	* lib/vbitset.c (min, max): Likewise.
	* lib/subpipe.c (create_subpipe): Save local variables in case
	vfork clobbers them.

2005-05-24  Bruno Haible  <bruno@clisp.org>

	* tests/synclines.at (AT_SYNCLINES_COMPILE): Add support for the
	error message syntax used by gcc-4.0.

2005-05-23  Paul Eggert  <eggert@cs.ucla.edu>

	* README: Mention m4 1.4.3.  Remove obsolete advice about
	Sun Forte Developer 6 update 2, VMS, and MS-DOS.

	* bootstrap: Remove workaround for problem I encountered with
	gettext 0.14.1; it seems to be fixed now.

2005-05-22  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Version 2.0a.

	* src/files.c: Include "stdio-safer.h"; this fixes a typo in
	the previous change.

	Various maintainer cleanups.
	* .cvsignore: Add a.exe, a.out, b.out,, conf[0-9]*, confdefs*,
	conftest*, for benefit of CVS commands run at the same time as
	"configure".  Add build-aux, since "bootstrap" now creates it and
	its subfiles.
	* Makefile.cfg (move_if_change): Remove.
	* Makefile.maint: Remove the update stuff; we now use "bootstrap".
	(ftp-gnu, www-gnu, move_if_change, local_updates, update):
	(po_repo, do-po-update, po-update, wget_files, get-targets):
	(config.guess-url_prefix, config.sub-url_prefix):
	(ansi2knr.c-url_prefix, texinfo.tex-url_prefix):
	(standards.texi-url_prefix, make-stds.texi-url_prefix, taget, url):
	($(get-targets), cvs-files, automake_repo, wget-update, cvs-update):
	Remove.
	* configure.ac (AC_CONFIG_AUX_DIR): Change from config to build-aux;
	this is now the recommended name.
	* config/.cvsignore: Remove config.guess, config.rpath, config.sub,
	depcomp, install-sh, mdate-sh, missing, mkinstalldirs, texinfo.tex,
	ylwrap.  These files now go into build-aux.
	* config/move-if-change: Remove.
	* config/prev-version.txt: Bump from 1.75 to 2.0.

	* bootstrap: Add stdio-safer, unistd-safer modules.
	Remove m4/glibc2.m4 (introduced by latest gnulib, but
	we don't need it).
	* lib/.cvsignore: Add dup-safer.c, fd-safer.c,
	fopen-safer.c, stdio-safer.h, unistd-safer.h.
	* lib/subpipe.c: Include "unistd-safer.h".
	(create_subpipe): Make sure all the newly-created
	file descriptors are > 2, so that diagnostics don't
	get sent down them (which might cause Bison to hang, in theory).
	* m4/.cvsignore: Add stdio-safer.m4, unistd-safer.m4.
	* src/files.c (xfopen): Use fopen_safer, not fopen.

	* data/lalr1.cc (yy::]b4_parser_class_name[::parse): Port
	yesterday's yacc.c fix.

2005-05-21  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c, data/lalr1.cc: Update copyright date.

	Fix a destructor bug reported by Wolfgang Spraul in
	<http://lists.gnu.org/archive/html/bug-bison/2005-05/msg00042.html>.
	* data/yacc.c (yyabortlab): Don't call destructor, and
	don't set yychar to EMPTY.
	(yyoverflowlab): Don't call destructor.
	(yyreturn): Call destructor, if yychar is neither YYEOF nor YYEMPTY.
	* tests/calc.at (AT_CHECK_CALC): Expect one fewer output lines,
	since we no longer output the message "discarding lookahead token
	end of input ()".

2005-05-20  Paul Hilfinger  <hilfingr@CS.Berkeley.EDU>

	* data/glr.c (YY_SYMBOL_PRINT): Don't print newline at end to
	fix a small glitch in debugging output.
	(yyprocessOneStack, yyrecoverSyntaxError, yyparse): Print newline
	after YY_SYMBOL_PRINT where needed.

	(struct yyGLRState): Add some comments.
	(struct yySemanticOption): Add some comments.
	(union yyGLRStackItem): Add comment.

	(yymergeOptionSets): Correct this to properly perform the union,
	avoiding infinite reported by Michael Rosien.
	Update comment.

	* tests/glr-regression.at: Add test for GLR merging error reported
	by M. Rosien.

2005-05-13  Paul Eggert  <eggert@cs.ucla.edu>

	* COPYING, ChangeLog, GNUmakefile, HACKING, Makefile.am,
	Makefile.cfg, Makefile.maint, NEWS, README, README-alpha,
	README-cvs, TODO, bootstrap, configure.ac, data/Makefile.am,
	data/README, data/c.m4, data/glr.c, data/lalr1.cc, data/yacc.c,
	data/m4sugar/m4sugar.m4, doc/Makefile.am, doc/bison.texinfo,
	doc/fdl.texi, doc/gpl.texi, doc/refcard.tex, lib/Makefile.am,
	lib/abitset.c, lib/abitset.h, lib/bbitset.h, lib/bitset.c,
	lib/bitset.h, lib/bitset_stats.c, lib/bitset_stats.h,
	lib/bitsetv-print.c, lib/bitsetv-print.h, lib/bitsetv.c,
	lib/bitsetv.h, lib/ebitset.c, lib/ebitset.h, lib/get-errno.c,
	lib/get-errno.h, lib/lbitset.c, lib/lbitset.h, lib/libiberty.h,
	lib/main.c, lib/subpipe.c, lib/subpipe.h, lib/timevar.c,
	lib/timevar.def, lib/timevar.h, lib/vbitset.c, lib/vbitset.h,
	lib/yyerror.c, m4/cxx.m4, m4/m4.m4, m4/subpipe.m4, m4/timevar.m4,
	m4/warning.m4, src/LR0.c, src/LR0.h, src/Makefile.am, src/assoc.c,
	src/assoc.h, src/closure.c, src/closure.h, src/complain.c,
	src/complain.h, src/conflicts.c, src/conflicts.h, src/derives.c,
	src/derives.h, src/files.c, src/files.h, src/getargs.c,
	src/getargs.h, src/gram.c, src/gram.h, src/lalr.c, src/lalr.h,
	src/location.c, src/location.h, src/main.c, src/muscle_tab.c,
	src/muscle_tab.h, src/nullable.c, src/nullable.h, src/output.c,
	src/output.h, src/parse-gram.c, src/parse-gram.h,
	src/parse-gram.y, src/print.c, src/print.h, src/print_graph.c,
	src/print_graph.h, src/reader.c, src/reader.h, src/reduce.c,
	src/reduce.h, src/relation.c, src/relation.h, src/scan-gram.l,
	src/scan-skel.l, src/state.c, src/state.h, src/symlist.c,
	src/symlist.h, src/symtab.c, src/symtab.h, src/system.h,
	src/tables.c, src/tables.h, src/uniqstr.c, src/uniqstr.h,
	src/vcg.c, src/vcg.h, src/vcg_defaults.h, tests/Makefile.am,
	tests/actions.at, tests/c++.at, tests/calc.at, tests/conflicts.at,
	tests/cxx-type.at, tests/existing.at, tests/glr-regression.at,
	tests/headers.at, tests/input.at, tests/local.at, tests/output.at,
	tests/reduce.at, tests/regression.at, tests/sets.at,
	tests/synclines.at, tests/testsuite.at, tests/torture.at:
	Update FSF postal mail address.

2005-05-11  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/local.at (AT_COMPILE_CXX): Treat LDFLAGS like AT_COMPILE does.
	Problem reported by Ralf Menzel.

2005-05-01  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/actions.at: Test that stack overflow invokes destructors.
	From Marcus Holland-Moritz.
	* data/yacc.c (yyerrlab): Move the code that destroys the stack
	from here....
	(yyreturn): to here.  That way, destructors are called properly
	even if the stack overflows, or the user calls YYACCEPT or
	YYABORT.  Stack-overflow problem reported by Marcus Holland-Moritz.
	(yyoverflowlab): Destroy the lookahead.

2005-04-24  Paul Eggert  <eggert@cs.ucla.edu>

	* data/yacc.c (YYSTACK_ALLOC_MAXIMUM): Add more-descriptive comment.

2005-04-17  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Bison-generated C parsers no longer quote literal strings
	associated with tokens.
	* src/output.c (prepare_symbols): Don't escape strings,
	since users don't want to see C escapes.
	* tests/calc.at (AT_CHECK_CALC): Adjust to lack of quotes
	in diagnostics.
	* tests/input.at (Torturing the Scanner): Likewise.
	* tests/regression.at (Token definitions, Web2c Actions): Likewise.

2005-04-16  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/torture.at (AT_INCREASE_DATA_SIZE): Skip the test if
	the data size is known to be too small and we can't increase it.
	This works around an HP-UX 11.00 glitch reported by Andrew Benham.

2005-04-15  Paul Eggert  <eggert@cs.ucla.edu>

	* src/parse-gram.y: Include quotearg.h.
	(string_as_id): Quote $1 before using it as a key, since the
	lexer no longer quotes it for us.
	(string_content): Don't strip quotes, since lexer no longer
	quotes it for us.
	* src/scan-gram.l: Include quotearg.h.
	("\""): Omit quote.
	("'"<SC_ESCAPED_CHARACTER>): Quote symbol before using it as
	a key, since the rest of the lexer doesn't quote it.
	* src/symtab.c (symbol_get): Don't quote symbol; caller does it now.
	* tests/regression.at (Token definitions): Check for backslashes
	in token strings.

	* data/yacc.c (YYSTACK_ALLOC_MAXIMUM): New macro.
	(YYSIZE_T): Define to unsigned long int when using an older compiler.
	(yyparse): Revamp code to generate long syntax error message, to
	make it easier to translate, and to avoid problems with arithmetic
	overflow.  Change "virtual memory" to "memory" in diagnostic, since
	we don't know whether the memory is virtual.

2005-04-13  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Bison-generated C parsers now use the _ macro to
	translate strings.
	* data/yacc.c (_) [!defined _]: New macro.
	All English strings wrapped inside this macro.
	* doc/bison.texinfo (Bison Parser): Document _.
	* po/POTFILES.in: Include src/parse-gram.c, since it now
	includes translateable strings that parse-gram.y doesn't.

2005-04-12  Paul Eggert  <eggert@cs.ucla.edu>

	* src/symtab.c (symbol_make_alias): Call symbol_type_set,
	reverting the 2004-10-11 change to this function.
	(symbol_check_alias_consistency): Don't call symbol_type_set
	if the type name is already correct.
	* tests/input.at (Typed symbol aliases): New test, from Tim Van Holder.

2005-03-25  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/regression.at (Token definitions): Don't use a token named
	c, as that generates a "#define c ..." that runs afoul of buggy
	stdlib.h that uses the identifier c as a member of struct
	drand48_data.  Problem reported by Horst Wente.

2005-03-21  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap: Change translation URL from
	http://www2.iro.umontreal.ca/~gnutra/po/maint/bison/ to
	http://www.iro.umontreal.ca/translation/maint/bison/ to avoid
	redirection glitches.  Problem reported by twlevo@xs4all.nl.

2005-03-20  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/local.at (AT_COMPILE, AT_COMPILE_CXX): Don't put options
	after operands; POSIX says this isn't portable for the c99 command.

2005-03-18  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/glr-regression.at (glr-regr2a.y): Try to dump core
	immediately if a data overrun has occurred; this may help us track
	down what may be a spurious failure on MacOS.

2005-03-17  Paul Eggert  <eggert@cs.ucla.edu>

	Respond to problems reported by twlevo@xs4all.nl.

	* bootstrap: Use "trap - 0" rather than the unportable "trap 0".

	* src/vcg.h: Comment fix.
	* src/vcg_defaults.h: Parenthesize macro bodies to make them safe.
	(G_CMAX): Change to -1 instead of INT_MAX.

	* data/yacc.c (yyparse): Omit spaces before #line.

2005-03-15  Paul Eggert  <eggert@cs.ucla.edu>

	* src/tables.c (state_number_to_vector_number): Put it inside an
	"#if 0", since it's not currently used.  Problem reported by
	Roland McGrath.

2005-03-06  Paul Eggert  <eggert@cs.ucla.edu>

	* src/output.c (escaped_output): Renamed from
	escaped_file_name_output, since we now use it for symbol tags as
	well.  All uses changed.
	(symbol_destructors_output, symbol_printers_output):
	Escape symbol tags too.
	Problem reported by Matyas Forstner in
	<http://lists.gnu.org/archive/html/bug-bison/2005-03/msg00009.html>.

	* src/muscle_tab.c (muscle_code_grow): Don't quote numbers; it's
	not needed.
	* src/output.c (user_actions_output, token_definitions_output,
	symbol_destructors_output, symbol_printers_output): Likewise.
	* src/reader.c (prologue_augment): Likewise.
	* src/scan-gram.l (handle_action_dollar, handle_action_at): Likewise.

	* src/vcg.c (output_edge): Don't quote linestyle arg.
	Problem reported by twlevo@xs4all.nl.

2005-02-28  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/bison.texinfo (Semantic Tokens): Fix scoping problem in
	example, reported by Derek M Jones.  Also, make the example even
	more outrageous, to better illustrate how bad the problem is.

2005-02-24  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/bison.texinfo (Mfcalc Symtab): Correct the prototype for
	putsym.  Typo reported by Sebastian Piping.

2005-02-23  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/bison.texinfo (Language and Grammar): some -> same
	(Epilogue): int he -> in the
	Typos reported by Sebastian Piping via Justin Pence.

2005-02-07  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/glr-regression.at (Improper handling of embedded actions
	and dollar(-N) in GLR parsers): Renamed from "Improper handling of
	embedded actions and $-N in GLR parsers", work around an Autoconf bug
	with dollar signs in test names.
	* tests/input.at (Invalid dollar-n): Renamed from "Invalid \$n",
	for a similar reason.

2005-01-28  Paul Eggert  <eggert@cs.ucla.edu>

	* src/vcg.c (output_graph): G_VIEW -> normal_view in case someone
	wants to redefine G_VIEW.

2005-01-27  Paul Eggert  <eggert@cs.ucla.edu>

	* src/vcg.c (get_view_str): Remove case for normal_view.
	Problem reported by twlevo@xs4all.nl.

2005-01-24  Paul Eggert  <eggert@cs.ucla.edu>

	* configure.ac (O0CFLAGS, O0CXXFLAGS): Fix quoting bug.
	Problem reported by twlevo@xs4all.nl.

	* doc/bison.texinfo: Change @dircategory from "GNU programming
	tools" to "Software development".  Requested by Richard Stallman
	via Karl Berry.

2005-01-23  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/c++.at (AT_CHECK_DOXYGEN): Don't use options after operands.
	Problem reported by twlevo@xs4all.nl.

2005-01-21  Paul Eggert  <eggert@cs.ucla.edu>

	* data/yacc.c (YYCOPY, yystpcpy, yyparse): Remove "register"
	keyword; it's not needed with modern compilers, and it doesn't
	affect correctness with older compilers.  Suggested by
	twlevo@xs4all.nl.

2005-01-17  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yyuserAction): Add "default: break;" case to pacify
	gcc -Wswitch-default.
	* data/lalr1.cc (yy::]b4_parser_class_name[::parse): Likewise.
	* data/yacc.c (yyparse): Likewise.

2005-01-12  Paul Eggert  <eggert@cs.ucla.edu>

	* src/system.h (OUTPUT_EXT, TAB_EXT): Define only if not defined
	already.  Let config.h define any nonstandard values.

2005-01-10  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/calc.at (_AT_DATA_CALC_Y): Use alarm (100), not alarm (10),
	for the benefit of slower hosts.  Problem reported by
	Nelson H. F. Beebe.

2005-01-07  Paul Eggert  <eggert@cs.ucla.edu>

	* data/yacc.c (yyparse): Pacify non-GCC compilers about yyerrorlab
	being defined and not used.
	* data/lalr1.cc (yyparse): Likewise.
	Use "if (false)" rather than "if (0)".

2005-01-05  Paul Eggert  <eggert@cs.ucla.edu>

	* TODO: Mention that we should allow NUL bytes in tokens.

2005-01-02  Paul Eggert  <eggert@cs.ucla.edu>

	* src/scan-skel.l (<<EOF>>): Don't close standard output.
	Problem reported by Hans Aberg.

2005-01-01  Paul Eggert  <eggert@cs.ucla.edu>

	* src/getargs.c (version): Happy new year; update overall
	program copyright date from 2004 to 2005.

	* src/scan-skel.l ("@output ".*\n): Don't close standard output.
	Problem reported by Hans Aberg.
	* tests/output.at (AT_CHECK_OUTPUT): New arg SHELLIO.
	(Output file names.): Add a test for the case when standard output
	is closed.

2004-12-26  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/bison.texinfo (@copying): Update FDL version number to 1.2,
	to fix an oversight in the Bison 2.0 manual.

2004-12-25  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Version 2.0.  Reformat the existing news items since
	1.875, so that related items are grouped together.
	* configure.ac (AC_INIT): Bump version to 2.0.
	* src/parse-gram.c, src/parse-gram.h: Regenerate with 2.0.

	* tests/torture.at (Exploding the Stack Size with Alloca): Set
	YYSTACK_USE_ALLOCA to 1 if __GNUC__ or alloca are defined;
	otherwise, we're not testing alloca.  Unfortunately there's no
	simple way to consult HAVE_ALLOCA here.

	* data/lalr1.cc (yydestruct_): Pacify unused variable warning
	for yymsg, too.

	* src/LR0.c (new_itemsets): Use memset rather than zeroing by
	hand.  This avoids a warning about comparing int to size_t when
	GCC warnings are enabled.

2004-12-22  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Bison-generated parsers no longer default to using the
	alloca function (when available) to extend the parser stack, due
	to widespread problems in unchecked stack-overflow detection.
	* data/glr.c (YYMAXDEPTH): Remove undef when zero.  It's the user's
	responsibility to set it to a positive value.  This lets the user
	specify a value that is not a preprocessor constant.
	* data/yacc.c (YYMAXDEPTH): Likewise.
	(YYSTACK_ALLOC): Define only if YYSTACK_USE_ALLOCA is nonzero.
	* doc/bison.texinfo (Stack Overflow): YYMAXDEPTH no longer needs
	to be a compile-time constant.  However, explain the constraints on it.
	Also, explain the constraints on YYINITDEPTH.
	(Table of Symbols): Explain that alloca is no longer the default.
	Explain the user's responsibility if they define YYSTACK_USE_ALLOCA
	to 1.

	* doc/bison.texinfo (Location Default Action): Mention that n must
	be zero when k is zero.  Suggested by Frank Heckenbach.

2004-12-22  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (parser::token_number_type, parser::rhs_number_type)
	(parser::state_type, parser::semantic_type, parser::location_type):
	Private, not public.
	(parser::parse): Return ints, not bool.
	Returning a bool introduces a problem: 0 corresponds to false, and
	it seems weird to return false on success.  Returning true changes
	the conventions for yyparse.
	Alternatively we could return void and send an exception.
	There is no clear consensus (yet?).
	(state_stack, semantic_stack, location_stack): Rename as...
	(state_stack_type, semantic_stack_type, location_stack_type): these.
	Private, not public.
	* tests/c++.at: New.
	* tests/testsuite.at, tests/Makefile.am: Adjust.

2004-12-21  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (parser::parse): Return a bool instead of an int.

2004-12-21  Akim Demaille  <akim@epita.fr>

	Don't impose std::string for filenames.

	* data/lalr1.cc (b4_filename_type): New.
	(position::filename): Use it.
	(parser.hh): Move the inclusion of stack.hh and location.hh below
	the user code, so that needed headers for the filename type can be
	included first.
	Forward declare them before the user code.
	* tests/Makefile.am (check-local, installcheck-local): Pass
	TESTSUITEFLAGS to the TESTSUITE.

2004-12-20  Akim Demaille  <akim@epita.fr>

	Use more STL like names: my_class instead of MyClass.

	* data/lalr1.cc (LocationStack, LocationType, RhsNumberType)
	(SemanticStack, SemanticType, StateStack, StateType)
	(TokenNumberType, Stack, Slice, Traits, Parser::location)
	(Parser::value): Rename as...
	(location_stack, location_type, rhs_number_type, semantic_stack)
	(semantic_type, state_stack, state_type, token_number_type, stack)
	(slice, traits, parser::yylloc, parser::yylval): these.

	* tests/calc.at, tests/regression.at, tests/actions.at: Adjust.

2004-12-19  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (YYLLOC_DEFAULT): Use GNU spacing conventions.
	* data/yacc.c (YYLLOC_DEFAULT): Likewise.

2004-12-17  Paul Eggert  <eggert@cs.ucla.edu>

	Remove uses of 'short int' and 'unsigned short int'.  This raises
	some arbitrary limits.  It uses more memory but nowadays that's
	not much of an issue.

	This change does not affect the generated parsers; that's a different
	task, as some users will want to conserve memory there.

	Ideally we should use size_t to represent all object counts, and
	something like ptrdiff_t to represent signed differences of object
	counts; but that will require more code-cleanup than I have the
	time to do right now.

	* src/LR0.c (allocate_itemsets, new_itemsets, save_reductions):
	Use size_t, not int or short int, to count objects.
	* src/closure.c (nritemset, closure): Likewise.
	* src/closure.h (nritemset, closure): Likewise.
	* src/nullable.c (nullable_compute): Likewise.
	* src/print.c (print_core): Likewise.
	* src/print_graph.c (print_core): Likewise.
	* src/state.c (state_compare, state_hash): Likewise.
	* src/state.h (struct state): Likewise.
	* src/tables.c (default_goto, goto_actions): Likewise.

	* src/gram.h (rule_number, rule): Use int, not short int.
	* src/output.c (prepare_rules): Likewise.
	* src/state.h (state_number, STATE_NUMBER_MAXIMUM, transitions,
	errs, reductions): Likewise.
	* src/symtab.h (symbol_number, SYMBOL_NUMBER_MAXIMUM, struct symbol):
	Likewise.
	* src/tables.c (vector_number, tally, action_number,
	ACTION_NUMBER_MINIMUM): Likewise.
	* src/output.c (muscle_insert_short_int_table): Remove.

2004-12-17  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: Extensive Doxygenation.
	(error_): Rename as...
	(error): this, since it is visible to the user.
	Adjust callers.
	(Parser::message): Now an automatic variable from...
	(Parser::yyreport_syntax_error_): here.
	* tests/actions.at, tests/calc.at, tests/regression.at: Adjust to
	Parser::error.
	* tests/input.at: Escape $.

2004-12-16  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (b4_lhs_value, b4_rhs_value, b4_rhs-location):
	Parenthesize rhs to avoid obscure problems with mistakes like
	"foo$$bar = foo$1bar;".  Problem reported by twlevo at xs4all.
	* data/lalr1.cc (b4_lhs_value, b4_rhs_value, b4_lhs_location,
	b4_rhs_location): Likewise.
	* data/yacc.c (b4_lhs_value, b4_rhs_value, b4_lhs_location,
	b4_rhs_location): Likewise.

2004-12-16  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (yyreport_syntax_error_): Catch up with glr.c and
	yacc.c: be sure to stay within yycheck_.
	* tests/actions.at: Re-enable C++ tests.

2004-12-16  Akim Demaille  <akim@epita.fr>

	* src/print_graph.c (print_graph): Remove layoutalgorithm uses for
	real.

2004-12-16  Akim Demaille  <akim@epita.fr>

	Use #define to handle the %name-prefix.

	* data/glr.c, data/yacc.c: Comment changes.
	* data/lalr1.cc (yylex): Use #define to select the name of yylex,
	so that one can refer to yylex in the parser file, and have it
	renamed, as is the case with other skeletons.

2004-12-16  Akim Demaille  <akim@epita.fr>

	Move lalr1.cc internals into yy*.

	* data/lalr1.cc (semantic_stack_, location_stack_, state_stack_)
	(semantic_stack_, location_stack_, pact_, pact_ninf_, defact_)
	(pgoto_, defgoto_, table_, table_ninf_, check_, stos_, r1_, r2_)
	(name_, rhs_, prhs_, rline_, token_number_, eof_, last_, nnts_)
	(empty_, final_, terror_, errcode_, ntokens_)
	(user_token_number_max_, undef_token_, n_, len_, state_, nerrs_)
	(looka_, ilooka_, error_range_, nerrs_):
	Rename as...
	(yysemantic_stack_, yylocation_stack_, yystate_stack_)
	(yysemantic_stack_, yylocation_stack_, yypact_, yypact_ninf_)
	(yydefact_, yypgoto_, yydefgoto_, yytable_, yytable_ninf_)
	(yycheck_, yystos_, yyr1_, yyr2_, yyname_, yyrhs_, yyprhs_)
	(yyrline_, yytoken_number_, yyeof_, yylast_, yynnts_, yyempty_)
	(yyfinal_, yyterror_, yyerrcode_, yyntokens_)
	(yyuser_token_number_max_, yyundef_token_, yyn_, yylen_, yystate_)
	(yynerrs_, yylooka_, yyilooka_, yyerror_range_, yynerrs_):
	these.

2004-12-15  Paul Eggert  <eggert@cs.ucla.edu>

	Fix some problems reported by twlevo at xs4all.
	* src/symtab.c (symbol_new): Report an error if the input grammar
	contains too many symbols.  This is better than calling abort() later.
	* src/vcg.h (enum layoutalgorithm): Remove.  All uses removed.
	(struct node, struct graph):
	Rename member expand to stretch.  All uses changed.
	(struct graph): Remove member layoutalgorithm.  All uses removed.
	* src/vcg.c (get_layoutalgorithm_str): Remove.  All uses removed.
	* src/vcg_defaults.h (G_STRETCH): Renamed from G_EXPAND.
	All uses changed.
	(N_STRETCH): Rename from N_EXPAND.  All uses changed.

2004-12-15  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: Normalize /** \brief ... */ to ///.
	Add more Doxygen comments.
	(symprint_, stack_print_, reduce_print_, destruct_, pop)
	(report_syntax_error_, translate_): Rename as...
	(yysymprint_, yystack_print_, yyreduce_print_, yydestruct_)
	(yypop_, yyreport_syntax_error_, yytranslate_): this.

2004-12-15  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (lex_): Rename as...
	(yylex_): this.
	Move the trace here.
	Take the %name-prefix into account.
	Reported by Alexandre Duret-Lutz.

2004-12-15  Akim Demaille  <akim@epita.fr>

	Simplify the C++ parser constructor.

	* data/lalr1.cc (debug_): Rename as...
	(yydebug_): so that the parser's internals are always in the yy*
	pseudo namespace.
	Adjust uses.
	(b4_parse_param_decl): Remove the leading comma as it is now only
	called as unique argument list.
	(Parser::Parser): Remove the constructor accepting a location and
	an initial debugging level.
	Remove from the other ctor the argument for the debugging level.
	(debug_level_type, debug_level, set_debug_level): New.

	* tests/actions.at, tests/calc.at, tests/regression.at: Adjust
	constructor calls.

2004-12-15  Akim Demaille  <akim@epita.fr>

	Remove b4_root related material: failure experiment
	(which goal was to allow to derive from a class).

	* data/lalr1.cc (b4_root, b4_param, b4_constructor): Remove
	definitions and uses.

2004-12-14  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (struct yyGLRStack): yyerror_range now has 3 items,
	not 2, since it's not portable to subtract 1 from the start of an
	array.  The new item 0 is never set or used.  All uses changed.

	(yyrecoverSyntaxError): Use YYLLOC_DEFAULT instead of assuming
	the default definition of YYLLOC_DEFAULT.  Problem reported
	by Frank Heckenbach.

2004-12-12  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (YYRHSLOC): Don't have two definitions, one for
	the normal case and one for the error case.  Just use the
	first one uniformly.  Problem reported by Frank Heckenbach.
	(YYLLOC_DEFAULT): Use the conventions of yacc.c, so we can
	use exactly the same macro in both places.
	(yyerror_range): Now of type yyGLRStackItem, not YYLTYPE,
	so that the normal-case YYRHSLOC works for the error case too.
	All uses changed.
	* data/yacc.c (YYRHSLOC): New macro, taken from glr.c.
	(YYLLOC_DEFAULT): Use the same macro as glr.c.
	* doc/bison.texinfo (Location Default Action): Don't claim that
	we have an array of locations.  Use the same macro for both glr
	and lalr parsers.  Mention YYRHSLOC.  Mention what happens when
	the index is 0.

2004-12-10  Paul Eggert  <eggert@cs.ucla.edu>

	* HACKING: Update email addresses to send announcements to.

	* configure.ac (AC_INIT): Bump version to 1.875f.

2004-12-10  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Version 1.875e.
	* src/parse-gram.c, src/parse-gram.h: Regenerate with 1.875e.

	* src/scan-skel.l: Include "complain.h", for "fatal".

	* src/relation.h (relation_print, relation_digraph):
	Relation sizes are of type relation_node, not size_t (this is
	merely a doc fix, since the two types are equivalent).
	(relation_transpose): Relation sizes are of type relation_node,
	not int.
	* src/relation.c: Likewise.
	(top, infinity): Now of type relation_node, not int.
	(traverse, relation_transpose): Use relation_node, not int.

	* data/glr.c (yyuserAction, yyrecoverSyntaxError): Mark args
	with ATTRIBUTE_UNUSED if they're not used, to avoid GCC warning.
	(yyparse): Remove unused local introduced in 2004-10-25 patch.

	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): New arg
	specifying whether the test should be skipped.  Use it tp
	specify that the [%defines %skeleton "lalr1.cc"] tests currently
	fail on some hosts, and should be skipped.

2004-12-08  Paul Eggert  <eggert@cs.ucla.edu>

	* src/system.h (CALLOC, MALLOC, REALLOC): Remove.  All callers
	changed to use xcalloc, xnmalloc, xnrealloc, respectively,
	unless otherwise specified below.

	* src/LR0.c (allocate_itemsets): Use xnmalloc, not xcalloc,
	to allocate kernel_base, kernel_items, kernel_size, since
	they needn't be initialized to 0.
	(allocate_storgae): Likewise, for shiftset, redset, shift_symbol.
	* src/closure.c (new_closure): Likewise, for itemset.
	* src/derives.c (derives_compute): Likewise, for delts, derives, q.
	* src/lalr.c (set_goto_map): Likewise, for temp_map.
	(initialize_F): Likewise, for reads, edge, reads[i], includes[i].
	(build_relations): Likewise for edge, states1, includes.
	* src/nullable.c (nullable_compute): Likewise, for squeue, relts.
	* src/reader.c (packgram): Likewise, for ritem, rules.
	* src/reduce.c (nonterminals_reduce): Likewise for nontermmap.
	* src/relation.c (relation_digraph): Likewise for VERTICES.
	(relation_transpose): Likewise for new_R, end_R.
	* src/symtab.c (symbols_token_translations_init): Likewise for
	token_translations.
	* src/tables.c (save_row): Likewise for froms, tos, conflict_tos.
	(token_actions): Likewise for yydefact, actrow, conflrow,
	conflict_list.
	(save_column): Likewise for froms[symno], tos[symno].
	(goto_actions): Likewise for state_count.
	(pack_table): Likewise for base, pos, check.
	(tables_generate): Likewise for width.

	* src/LR0.c (set_states): Don't reuse kernel_size and kernel_base
	for initial core.  Just have a separate core, so we needn't worry
	about whether kernel_size and kernel_base are initialized.

	* src/LR0.c (shift_symbol, redset, shiftset, kernel_base,
	kernel_size, kernel_items): Remove unnecessary initialization.
	* src/conflicts.c (conflicts): Likewise.
	* src/derives.c (derives): Likewise.
	* src/muscle_tablc (muscle_insert): Likewise.
	* src/relation.c (relation_digraph): Likewise.
	* src/tables.c (froms, tos, conflict_tos, tally, width, actrow, order,
	conflrow, conflict_table, conflict_list, table, check):
	Likewise.

	* src/closure.c (new_closure): Arg is of type unsigned int, not int.
	This is because all callers pass unsigned int.
	* src/closure.h (new_closure): Likewise.

	* src/lalr.c (initialize_F): Initialize reads[i] in all cases.
	(build_relations): Initialize includes[i] in all cases.
	* src/reader.c (packgram): Always initialize rules[ruleno].prec
	and rules[ruleno].precsym.  Initialize members in order.
	* src/relation.c (relation_transpose): Always initialize new_R[i]
	and end_R[i].
	* src/table.c (conflict_row): Initialize 0 at end of conflict_list.

	* src/output.c (prepare_actions): Pass 0 instead of conflict_list[0];
	conflict_list[0] was always 0, but now it isn't initialized.

	* src/table.c (table_grow): When conflict_table grew, the grown
	area wasn't cleared.  Fix this.

	* lib/.cvsignore: Add strdup.c, strdup.h.
	* m4/.cvsignore: Add strdup.m4.

2004-12-07  Paul Eggert  <eggert@cs.ucla.edu>

	* src/lalr.h (GOTO_NUMBER_MAXIMUM): New macro.
	* src/lalr.c (set_goto_map): Don't allow ngotos to equal
	GOTO_NUMBER_MAXIMUM, since we occasionally compute
	ngotos + 1 without checking for overflow.
	(build_relations): Use END_NODE, not -1, to denote end of edges.
	* src/lalr.c (set_goto_map, map_goto, initialize_F, add_loopback_edge,
	build_relations): Use goto_number, not int, for goto numbers.
	* src/tables.c (save_column, default_goto): Likewise.

2004-11-23  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (YYSTYPE): Define it as is done for C, instead
	of #defining from yystype.
	Don't typedef yystype, C++ does not need it.
	This lets it possible to forward declare it as union.

2004-11-23  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap (gnulib_modules): Add extensions.
	Problem reported by Jim Meyering.

2004-11-22  Paul Eggert  <eggert@cs.ucla.edu>

	* src/LR0.c, src/closure.c, src/derives.c, src/gram.c,
	src/lalr.c, src/nullable.c, src/relation.c, src/scan-skel.l,
	src/system.h, src/tables.c: XFREE -> free, to accommodate
	recent change to gnulib xalloc.h.
	Problem reported by Jim Meyering.

2004-11-17  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (symprint_): Use cdebug_ to avoid warnings.

2004-10-28  Akim Demaille  <akim@epita.fr>,
	    Alexandre Duret-Lutz <adl@gnu.org>

	* data/lalr1.cc (Parser::yycdebug_): New, a pointer, to allow
	changes.
	(YYCDEBUG): Adjust.
	Use it instead of cdebug_.
	(Parser::debug_stream, Parser::set_debug_stream): New.
	(Parser::symprint_): Define cdebug_ for temporary backward
	compatibility.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Use
	debug_stream ().

2004-11-17  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (Parser:print_): Remove, use %printer instead.
	* tests/regression.at (_AT_DATA_DANCER_Y): Adjust.
	* tests/calc.at (_AT_DATA_CALC_Y): Ditto.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Likewise.

2004-10-27  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yyloc_default): Remove; not used.
	Problem reported by Frank Heckenbach.

2004-10-25  Akim Demaille  <akim@epita.fr>

	* data/glr.c (YYRHSLOC): Move its definition next to its uses.
	Introduce another definition to address simple location arrays.
	(yyGLRStack): New member: yyerror_range.
	(yyrecoverSyntaxError, yyparse): Update it.
	(yyrecoverSyntaxError): Use it when shifting the error token to
	have an accurate range, equivalent to the one computed by both
	yacc.c and lalr1.cc.
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Change its yylex so
	that column numbers start at column 0, as per GNU Coding
	Standards, the others tests, and the doc.
	(_AT_RESOLVED_GLR_OUTPUT_WITH_LOC, _AT_AMBIG_GLR_OUTPUT_WITH_LOC):
	Adjust to the above change (first column is 0).
	And adjust the location of the "<error>", now covering the whole
	line.

2004-10-22  Akim Demaille  <akim@epita.fr>
	and Paul Eggert  <eggert@cs.ucla.edu>

	Remove some arbitrary limits on goto numbers and relations.
	* src/lalr.c (goto_map, ngotos, from_state, to_state): Omit
	initial values, since they're never used.
	(set_goto_map): ngotos is now unsigned, so test for overflow
	by seeing whether it wraps around to zero.
	* src/lalr.h (goto_number): Now size_t, not short int.
	(GOTO_NUMBER_MAXIMUM): Remove.
	* src/relation.c (relation_print, traverse, relation_transpose):
	Check for END_NODE rather than looking at sign.
	* src/relation.h (END_NODE): New macro.
	(relation_node): Now size_t, not short int.

2004-10-22  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/bison.texinfo (Language and Grammar): In example, "int" is a
	keyword, not an identifier.  Problem reported by Baron Schwartz in
	<http://lists.gnu.org/archive/html/bug-bison/2004-10/msg00017.html>.

2004-10-11  Akim Demaille  <akim@epita.fr>

	* src/symtab.c (symbol_check_alias_consistency): Also check
	type names, destructors, and printers.
	Reported by Alexandre Duret-Lutz.
	Recode the handling of associativity and precedence in terms
	of symbol_precedence_set.
	Accept no redeclaration at all, not even equal to the previous
	value.
	(redeclaration): New.
	Use it to factor redeclaration complaints.
	(symbol_make_alias): Don't set the type of the alias, let
	symbol_check_alias_consistency do it as for other features.
	* src/symtab.h (symbol): Add new member prec_location, and
	type_location.
	* src/symtab.c (symbol_precedence_set, symbol_type_set): Set them.
	* tests/input.at (Incompatible Aliases): New.

2004-10-09  Paul Eggert  <eggert@cs.ucla.edu>

	.cvsignore fixes to accommodate gnulib changes,
	and the practice of naming build directories "_build".
	* .cvsignore: Add "_*".  Sort.
	* lib/.cvsignore: Add getopt_.h, xalloc-die.c.
	* m4/.cvsignore: Add "*_gl.m4".

2004-10-06  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (add_param): Fix the truncation of trailing
	spaces.

2004-10-05  Akim Demaille  <akim@epita.fr>

	In Bison 1.875's yacc.c, YYLLOC_DEFAULT was called regardless
	whether the reducion was empty or not.  This leaves room to
	improve the use of YYLLOC_DEFAULT in such a case.
	lalr1.cc is still experimental, so changing this is acceptable.
	And finally, there are probably not many users who changed the
	handling of locations in GLR, so changing is admissible too.

	* data/glr.c, data/lalr1.cc, data/yacc.c (YYLLOC_DEFAULT): On an
	empty reduction, set @$ to an empty location ending the previously
	stacked symbol.
	Adjust uses to make sure the code is triggered on empty
	reductions.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Adjust the
	expected output: empty reductions have empty locations.

2004-09-29  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: Move towards a more standard C++ coding style
	for templates: Class < T > -> Class<T>.

2004-09-29  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: Reinstall the former ctor, for sake of
	compatibility, but warn it will be removed.
	Move towards a more standard C++ coding style (i.e., type *var ->
	type* var).

2004-09-27  Paul Eggert  <eggert@cs.ucla.edu>

	* src/parse-gram.y (add_param): Rewrite to avoid strchr,
	since it's less likely to work if NULs are involved in the future.

2004-09-27  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (YY_LOCATION_PRINT): Fix its default declaration.

2004-09-27  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (b4_parse_param_decl_1): New.
	(b4_parse_param_decl): Use it to have different names between attribute
	and argument names.
	(b4_cc_constructor_call): Likewise.

2004-09-24  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (add_param): Strip the leading and trailing
	blanks from a formal argument declaration.
	(YY_LOCATION_PRINT): New.

2004-09-24  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_yysymprint_generate): Move the YYINPUT invocation
	after the location.

2004-09-24  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Table of Symbols): Sort.

2004-09-21  Akim Demaille  <akim@epita.fr>

	* data/yacc.c, data/glr.c (b4_at_dollar, b4_dollar_dollar): Remove
	the useless parentheses.
	Suggested by Paul Eggert.

2004-09-20  Akim Demaille  <akim@epita.fr>

	Let the initial-action act on the look-ahead, and use it for the
	"initial push" (corresponding to an hypothetical beginning-of-file).
	And let lalr1.cc honor %initial-action.

	* doc/bison.texinfo (Initial Action Decl): Clarify, and add an
	example.
	* data/lalr1.cc (Parser::initlocation_): Remove, bad experiment.
	(Parser::Parser): Remove the ctor that used to initialize it.
	(Parser::parse): Like in the other skeletons, issue the "starting
	parse" message before any action.
	Honor %initial-action.
	Initialize the stacks with the lookahead.
	* data/yacc.c: Let $$ and @$ in %initial-action designate the
	look-ahead.
	Push them in the stacks.
	* tests/actions.at, tests/calc.at: Adjust the C++ ctor invocations.

2004-09-20  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Initial Action Decl): New.

2004-09-20  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (YY_LOCATION_PRINT): Use YYLTYPE_IS_TRIVIAL as a
	clearer criterion to define it.
	(parse): Initialize the initial location when YYLTYPE_IS_TRIVIAL.
	When reducing on an empty RHS, use the latest stacked location as
	location.
	yylloc is not always available.
	* data/glr.c: Likewise.
	Also, honor initial-actions.

2004-09-20  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (YY_LOCATION_PRINT): New.
	Define when we know YYLTYPE's structure, i.e., when the default
	YYLLOC_DEFAULT is used.
	* data/c.m4 (b4_yysymprint_generate): Use it.
	* data/lalr1.cc (YYLLOC_DEFAULT): Stop relying on the initial
	value of the result.
	(error_start_): Replace with...
	(error_range_): this location array.
	This allows to replace code relying on the implementation of
	locations by portable code.
	* data/yacc.c (yylerrsp): Replace with...
	(yyerror_range): this.
	Every time a token is popped, update yyerror_range[0], to have an
	accurate location for the error token.
	* data/glr.c (YY_LOCATION_PRINT): New.
	(yyprocessOneStack): Fix an invocation of YY_SYMBOL_PRINT:
	deference a pointer.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): No longer
	report the location in %printers.

	* src/scan-skel.l: Instead of abort, report error messages to ease
	understanding skeleton scanning failures.

2004-09-16  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (Stack::Iterator, Stack::ConstIterator): Rename as...
	(iterator, const_iterator): these, to be more in the C++ spirit.
	Also, return reverse iterators so that when displaying the stack
	we display its bottom first.
	(Parser::stack_print_, Parser::reduce_print_): Match the messages
	from yacc.c.
	We should probably use vector here though.

2004-09-16  Akim Demaille  <akim@epita.fr>

	Have more complete shift traces.

	* data/yacc.c, data/lalr1.c, data/glr.c: Use YY_SYMBOL_PRINT
	to report Shifts instead of ad hoc YYDPRINTF invocations,
	including for the error token.
	* data/lalr1.cc (symprint_): Output the location.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): In C++, don't
	output the location within the %printer.
	Activate GLR tests, at least to make sure they compile properly.
	They still don't pass though.
	* tests/calc.at: Adjust expect verbose output, since now "Entering
	state..." is on a different line than the "Shifting" message.

2004-09-08  Akim Demaille  <akim@epita.fr>

	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Move the
	Bison directive from the Bison file to the invocation of this
	macro, so that these directives are passed to
	AT_BISON_OPTION_PUSHDEFS to get correct help macros.
	Use these helping macros (e.g., AT_LOC, AT_VAL and so forth).
	Move the AT_SETUP/AT_CLEANUP outside, to report as test title
	the extra Bison directives instead of the whole series.
	Change the grammar so that there are recoverable errors, and
	unrecoverable errors.  Now we can have the parser give up before
	consuming the whole input.  As a result we now can observe that
	the lookahead is freed when needed.
	Change the parser source to parse argv[1] instead of a hard coded
	string.
	Simplify yylex, and give a value and location to EOF.
	Simplify some invocations of AT_CHECK_PRINTER_AND_DESTRUCTOR that
	passed directives already coded in the file.
	Add some tests to check the location of "error".
	For some tests, the C++ parser is correct, and not yacc.c.
	For other tests, they provide different, but unsatisfying, values,
	so keep the C++ value so that at least one parser is "correct"
	according to the test suite.
	(Actions after errors): Remove, this is subsumed by the
	AT_CHECK_PRINTER_AND_DESTRUCTOR series.

2004-09-06  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: Adjust the indentation of the labels.
	(Parser::pop): New.
	Use it.

2004-09-06  Akim Demaille  <akim@epita.fr>

	* data/yacc.cc, data/glr.cc (yydestruct): Accept an additional
	argument, an informative message.
	Call YY_SYMBOL_PRINT.
	Adjust all callers: integrate the associated YY_SYMBOL_PRINT.
	* data/lalr1.cc (destruct_): Likewise.
	In addition, no longer depend on b4_yysymprint_generate and
	b4_yydestruct_generate to generate these functions, do it "by
	hand".

2004-09-03  Akim Demaille  <akim@epita.fr>

	* data/glr.c, data/lalr1.cc, data/yacc.c: When YYABORT was
	invoked, yydestruct the lookahead.
	* tests/calc.at (Calculator $1): Update the expected lengths of
	traces: there is an added line for the discarded lookahead.
	* doc/bison.texinfo (Destructor Decl): Some rewording.
	Define "discarded" symbols.

2004-09-02  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (translate_, destruct_): No reason to be static.

2004-09-02  Akim Demaille  <akim@epita.fr>

	* data/glr.c, yacc.c (YYDSYMPRINT): Remove, not used.
	(YYDSYMPRINTF): Rename as...
	(YY_SYMBOL_PRINT): this.
	* data/lalr1.cc (YY_SYMBOL_PRINT): New, modeled after the previous
	two.
	Use it instead of direct symprint_ calls.
	(yybackup): Tweak the "Now at end of input" case to match yacc.c's
	one.

2004-09-02  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (b4_yysymprint_generate): New.
	(symprint_): New member function, defined when YYDEBUG.
	Use it consistently instead of token/nterm debugging output by
	hand.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Adjust
	%printer calls to use cdebug_ when using lalr1.cc.

2004-08-30  Florian Krohm  <florian@edamail.fishkill.ibm.com>

	* data/glr.c: Guard the declarations of yypstack and yypdumpstack
	with #ifdef YYDEBUG.

2004-08-26  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Implementing Loops): Rename as...
	(Implementing Gotos/Loops): this.

2004-08-13  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to latest gnulib.
	* bootstrap (gnulib_modules): Add xalloc-die.
	Set LC_ALL=C so that file names sort consistently.
	Prefer the gnulib copies of gettext.m4, glibc21.m4,
	inttypes_h.m4, lib-ld.m4, lib-prefix.m4, po.m4, stdint_h.m4,
	uintmax_t.m4, ulonglong.m4.
	(intl_files_to_remove): Add gettext.m4, lib-ld.m4, lib-prefix.m4,
	po.m4 since we are now using _gl.m4 instead.

2004-08-10  Florian Krohm  <florian@edamail.fishkill.ibm.com>

	* src/scan-action.l: Remove. Scanning of semantic actions is
	handled in scan-gram.l.

2004-08-07  Florian Krohm  <florian@edamail.fishkill.ibm.com>

	* src/scan-gram.l (handle_syncline): Use uniqstr_new not xstrdup.

	* src/location.h (struct): The file member is a uniqstr.
	(equal_boundaries): Use UNIQSTR_EQ for comparison.

2004-07-22  Paul Eggert  <eggert@cs.ucla.edu>

	Fix bug with non-%union parsers that have printers or destructors,
	which led to a Bison core dump.  Reported by Peter Fales in
	<http://lists.gnu.org/archive/html/bug-bison/2004-07/msg00014.html>.

	* data/c.m4 (b4_symbol_actions): Don't assume %union was used.
	* data/lalr1.cc (yystype) [defined YYSTYPE]: Define to YYSTYPE,
	not to our own type.
	* src/output.c (symbol_destructors_output, symbol_printers_output):
	Don't assume %union.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR,
	AT_CHECK_PRINTER_AND_DESTRUCTOR): New argument
	UNION-FLAG.  All callers changed.
	(_AT_CHECK_PRINTER_AND_DESTRUCTOR): Don't assume %union.
	Use type char, not unsigned int, when declaring an array of char;
	this lets us remove a cast.
	(Printers and Destructors): Add non-%union test cases.

2004-06-21  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/bison.texinfo: Minor editorial changes, mostly to the new
	GLR writeups.  E.g., avoid frenchspacing and the future tense,
	change "lookahead" to "look-ahead", and change "wrt" to "with
	respect to".

2004-06-21  Paul Hilfinger  <hilfingr@CS.Berkeley.EDU>

	* doc/bison.texinfo (Merging GLR Parses, Compiler Requirements):
	New sections, split off from the GLR Parsers section.  Put the new
	Simple GLR Parser near the start of the GLR section, for clarity.
	Rewrite connective text.

2004-06-21  Frank Heckenbach  <frank@g-n-u.de>

	* doc/bison.texinfo (Simple GLR Parsers): New section.

2004-06-21  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS, TODO, doc/bison.texinfo:
	Use "look-ahead" instead of "lookahead", to be consistent.
	* REFERENCES: Fix incorrect reference to DeRemer and Pennello,
	while we're fixing "look-ahead".
	* src/conflicts.c (shift_set): Renamed from shiftset.
	(look_ahead_set): Renamed from lookaheadset.
	* src/print.c: Likewise.
	* src/getargs.c (report_args): Add "look-ahead" as the new canonical
	name for "lookahead".
	(report_types, usage): Likewise.
	* src/getargs.h (report_look_ahead_tokens): Renamed from
	report_lookaheads.
	* src/lalr.c (compute_look_ahead_tokens): Renamed from
	compute_lookaheads.
	(state_look_ahead_tokens_count): Renamed from state_lookaheads_count.
	(look_ahead_tokens_print): Renamed from lookaheads_print.
	* src/state.c (state_rule_look_ahead_tokens_print): Renamed from
	state_rule_lookaheads_print.
	* src/state.h: Likewise.
	(reductions.look_ahead_tokens): Renamed from lookaheads.
	* tests/torture.at (AT_DATA_LOOK_AHEAD_TOKENS_GRAMMAR): Renamed from
	AT_DATA_LOOKAHEADS_GRAMMAR.

2004-06-03  Paul Eggert  <eggert@cs.ucla.edu>

	* README: Update location of patched M4 distribution.

2004-05-30  Albert Chin-A-Young  <china@thewrittenword.com>

	Don't assume the C++ compiler takes the same arguments as the C compiler
	(trivial change).
	* configure.ac (O0CXXFLAGS): New var.
	* tests/atlocal.in (CXXFLAGS): Use it.

2004-05-29  Paul Eggert  <eggert@cs.ucla.edu>

	Fix some "make check" problems with C++ reported by
	Albert Chin-A-Young for Tru64 C++ in this thread:
	http://lists.gnu.org/archive/html/bug-bison/2004-05/msg00049.html

	* m4/cxx.m4 (BISON_TEST_FOR_WORKING_CXX_COMPILER): Check for std::cerr.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR):
	Output to a .cc file for C++, not to a .c file.
	* tests/calc.at (AT_CHECK_CALC): Likewise.
	* tests/regression.at (AT_CHECK_DANCER): Likewise.
	* tests/local.at (AT_COMPILE_CXX): Default to OUTPUT.cc, not OUTPUT.c.

2004-05-28  Albert Chin-A-Young  <china@thewrittenword.com>

	* tests/calc.at, tests/actions.at: Workaround for SGI
	C++ compiler.  (trivial change)

2004-05-27  Paul Eggert  <eggert@cs.ucla.edu>

	Spent a few hours checking out which prerequisite versions the
	current sources actually require.  I went all the way back to
	Gettext 0.10.40, Automake 1.4, and Autoconf 2.57 and investigated
	a seemingly endless set of combinations of versions more recent
	than that.  The bottom line is that the current sources require
	fairly recent versions of the build tools, and it'll be some work
	to change this.
	* configure.ac (AC_PREREQ): Increase from 2.58 to 2.59.
	(AM_INIT_AUTOMAKE): Increase from 1.7 to 1.8.
	(AM_GNU_GETTEXT_VERSION): Increase from 0.11.5 to 0.12.
	Add comments explaining why those particular versions are
	currently needed.

	* src/parse-gram.y (lloc_default): Rewrite to avoid compiler bug
	in SGI MIPSpro 7.4.1m.  Problem reported by Albert Chin-A-Young in
	<http://lists.gnu.org/archive/html/bug-bison/2004-05/msg00037.html>.

	* configure.ac (AC_PREREQ): Bump to 2.58, since 2.57 doesn't work
	(it fails with a Autoconf-without-aclocal-m4 diagnostic).

2004-05-26  Paul Eggert  <eggert@cs.ucla.edu>

	* configure.ac (AM_GNU_GETTEXT_VERSION): Lower it from 0.14.1 to
	0.11.5.  Suggested by Bruno Haible.
	* bootstrap: Remove gettext version checking.

	* doc/bison.texinfo (Decl Summary): Also mention that %union
	can depend on prerequisite types.  Problem reported by Tim
	Van Holder.

2004-05-25  Paul Eggert  <eggert@cs.ucla.edu>

	* README: Mention GNU m4 1.4 bugs and Akim's patched version.
	* README-alpha: Don't tell people not to package this.

	* bootstrap: Don't assume $(...) works; use `...` instead.
	Problem reported by Paul Hilfinger.  Also, diagnose non-GNU
	gettext better.

	* doc/bison.texinfo (Decl Summary, Bison Options): Clarify what's
	put into the -d output file, and mention what to do if YYSTYPE is
	defined as a macro.

2004-05-24  Paul Eggert  <eggert@cs.ucla.edu>

	Undo change made earlier today: it caused autopoint to not bring
	in ABOUT-NLS.  Ouch.  Instead, substitute our own diagnostic for
	autopoint's.

	* bootstrap: Check that gettext version matches what's in
	configure.ac.  Warn users to ignore robots.txt ERROR 404.
	* bootstrap: Undo today's earlier change (logged below).
	* configure.ac (AM_GNU_GETTEXT_VERSION): Likewise.

	The gettext version checking is causing more trouble than it's
	curing; remove it.  Problem reported by Paul Hilfinger.

	* bootstrap: Issue a warning that one can expect a message
	'AM_GNU_GETTEXT is used, but not AM_GNU_GETTEXT_VERSION'.
	* configure.ac (AM_GNU_GETTEXT_VERSION): Remove.

2004-05-23  Paul Eggert  <eggert@cs.ucla.edu>

	Ensure that the C++ compiler used for testing actually works on a
	simple test program; if not, skip the C++-related tests.  Problem
	reported by Vin Shelton in:
	http://lists.gnu.org/archive/html/bug-bison/2004-05/msg00026.html

	* m4/cxx.m4: New file.
	* configure.ac (BISON_TEST_FOR_WORKING_CXX_COMPILER): Add.
	* tests/atlocal.in (BISON_CXX_WORKS): Add.
	* tests/local.at (AT_COMPILE_CXX): Use it.

2004-05-21  Paul Eggert  <eggert@cs.ucla.edu>

	* data/glr.c (yylloc): Output this macro even if locations are not
	being generated, as the GLR parser needs it even in that case.
	Problem reported by Troy A. Johnson
	<http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=195946>.

	* configure.ac (AC_INIT): Update to 1.875e.

2004-05-21  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Version 1.875d.
	* configure.ac (AC_INIT): Likewise.
	* src/parse-gram.c, src/parse-gram.h: Regenerate with 1.875d.

	* configure.ac (--enable-gcc-warnings): Do not enable -Wshadow,
	-Wmissing-prototypes, or -Wstrict-prototypes for C++.  The current
	lalr1.cc runs afoul of the first, and the last two are no longer
	supported by GCC 3.4.0.
	* README: Mention GNU m4 1.4 or later; mention m4 patches.
	* HACKING: Use ./bootstrap, not "make update" to import foreign files.

2004-05-06  Paul Eggert  <eggert@cs.ucla.edu>

	* src/muscle_tab.c (hash_muscle): Accept and return size_t, not
	unsigned int, for compatibility with latest gnulib hash module.
	* src/state.c (state_hash, state_hasher): Likewise.
	* src/symtab.c (hash_symbol, hash_symbol_hasher): Likewise.
	* src/uniqstr.c (hash_uniqstr): Likewise.

2004-05-03  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Unescaped newlines are no longer allowed in char & strings.

	* src/scan-gram.l (<SC_ESCAPED_STRING,SC_ESCAPED_CHARACTER,
	SC_CHARACTER,SC_STRING>): Reject unescaped newlines in
	character and string literals.
	(unexpected_end): New function.
	(unexpected_eof): Use it.
	(unexpected_newline): New function.
	(<INITIAL,SC_AFTER_IDENTIFIER,SC_PRE_CODE>): Coalesce duplicate
	actions.

	* NEWS: Document %expect-rr.

	* bootstrap (--gnulib-srcdir=*, --cvs-user=*):
	Fix typo by replacing $1 with $option.
	Remove more 'intl'-related files.
	Don't DEFUN AM_INTL_SUBDIR twice.

	* lib/.cvsignore: Add strndup.h.  Remove memchr.c, memcmp.c,
	memrchr.c, strcasecmp.c, strchr.c, strrchr.c, strspn.c, strtol.c,
	strtoul.c.
	* m4/.cvsignore: Add exitfail.m4, extensions.m4, gnulib.m4,
	hard-locale.m4, mbstate_t.m4, strerror_r.m4, strndup.m4,
	xstrndup.m4.  Remove glibc21.m4, intdiv0.m4, inttypes-pri.m4,
	inttypes.m4, inttypes_h.m4, isc-posix.m4, lcmessage.m4,
	stdint_h.m4, uintmax_t.m4, ulonglong.m4.
	* src/.cvsignore: Add *.output.

	* src/parse-gram.y: Put copyright notice inside %{ %} so it
	gets copied to the output file.

2004-04-28  Paul Eggert  <eggert@twinsun.com>

	Get files from the gnulib and po repositories, instead of relying
	on them being in our CVS.  Upgrade to latest versions of gnulib
	and Automake.

	* Makefile.am (SUBDIRS): Remove m4; Automake now does m4.
	* bootstrap: Bootstrap from gnulib and po repositories.
	Much of this code was stolen from GNU diff and GNU tar's bootstrap.
	* README-cvs: Document these changes.  Remove version numbers from
	mentions of build tools, since they change so often.  Mention Flex.

	* configure.ac (AC_CONFIG_MACRO_DIR): Add, with m4 as arg.
	(gl_USE_SYSTEM_EXTENSIONS): Add.
	(AC_GNU_SOURCE, AC_AIX, AC_MINIX):
	Remove; no longer needed, as gl_USE_SYSTEM_EXTENSIONS
	does this for us.
	(AC_ISC_POSIX): Remove; we no longer support this
	ancient OS, as it gets in the way of latest Autoconf & gnulib.
	(AC_HEADER_STDC): Remove: we now assume C89 or better.
	(AC_CHECK_HEADERS_ONCE): Use instead of AC_CHECK_HEADERS.
	Do not check for C89 headers, except for locale.h which is used
	by the Yacc library and must port to K&R hosts.
	(AC_CHECK_FUNCS_ONCE): Use instead of AC_CHECK_FUNCS.
	Do not check for C89 functions, except for setlocale which is
	used by the Yacc library.
	(AC_CHECK_DECLS, AC_REPLACE_FUNCS): Remove; no longer needed.
	(gl_DIRNAME, gl_ERROR, gl_FUNC_ALLOCA, gl_FUNC_MEMCHR,
	gl_FUNC_MEMRCHR, gl_FUNC_STPCPY, gl_FUNC_STRNLEN, gl_FUNC_STRTOL,
	gl_GETOPT, gl_HASH, gl_MBSWIDTH, gl_OBSTACK, gl_QUOTE,
	gl_QUOTEARG, gl_XALLOC, jm_FUNC_GLIBC_UNLOCKED_IO, jm_FUNC_MALLOC,
	AM_GNU_GETTEXT): Remove; now done by:
	(GNULIB_AUTOCONF_SNIPPET): Add.  "bootstrap" builds this for us.
	(AC_CONFIG_FILES): Remove m4/Makefile, as Automake now does this
	for us.

	* lib/Makefile.am: Include gnulib.mk, built for us by "bootstrap".
	(BUILT_SOURCES, EXTRA_DIST, MOSTLYCLEANFILES):
	Define to empty, as gnulib.mk will do the rest for us.
	($(libbison_a_OBJECTS), stdbool.h): Remove, as gnulib.mk does this
	for us.
	(libbison_a_SOURCES): Define to $(lib_SOURCES) now.
	(lib_SOURCES): New symbol, containing only the non-gnulib libs.

	* src/files.c: Include gnulib's xstrndup.h.

	* src/system.h (MALLOC): Use xnmalloc, for better overflow checking.
	(REALLOC): Use xnrealloc, for likewise.
	(xstrndup, stpcpy): Remove decls, as gnulib does this for us now.
	(strnlen, memrchr): Remove decls; functions no longer used.
	Include <stpcpy.h>.

	* config/depcomp, config/install-sh, lib/alloca.c, lib/argmatch.c,
	lib/argmatch.h, lib/basename.c, lib/dirname.c, lib/dirname.h,
	lib/error.c, lib/error.h, lib/getopt.c, lib/getopt.h,
	lib/getopt1.c, lib/gettext.h, lib/hash.c, lib/hash.h,
	lib/malloc.c, lib/mbswidth.c, lib/mbswidth.h, lib/memchr.c,
	lib/memcmp.c, lib/memrchr.c, lib/obstack.c, lib/obstack.h,
	lib/quote.c, lib/quote.h, lib/quotearg.c, lib/quotearg.h,
	lib/realloc.c, lib/stdbool_.h, lib/stpcpy.c, lib/strcasecmp.c,
	lib/strchr.c, lib/strncasecmp.c, lib/strnlen.c, lib/strrchr.c,
	lib/strspn.c, lib/strtol.c, lib/strtoul.c, lib/unlocked-io.h,
	lib/xalloc.h, lib/xmalloc.c, lib/xstrdup.c, lib/xstrndup.c,
	m4/Makefile.am, m4/alloca.m4, m4/dirname.m4, m4/dos.m4,
	m4/error.m4, m4/getopt.m4, m4/hash.m4, m4/malloc.m4,
	m4/mbrtowc.m4, m4/mbswidth.m4, m4/memchr.m4, m4/memcmp.m4,
	m4/memrchr.m4, m4/obstack.m4, m4/onceonly.m4, m4/prereq.m4,
	m4/quote.m4, m4/quotearg.m4, m4/realloc.m4, m4/stdbool.m4,
	m4/stpcpy.m4, m4/strnlen.m4, m4/strtol.m4, m4/strtoul.m4,
	m4/unlocked-io.m4, m4/xalloc.m4, po/LINGUAS, po/Makefile.in.in,
	po/Makevars, po/da.po, po/de.po, po/es.po, po/et.po, po/fr.po,
	po/hr.po, po/id.po, po/it.po, po/ja.po, po/ms.po, po/nl.po,
	po/pt_BR.po, po/ro.po, po/ru.po, po/sv.po, po/tr.po:
	Remove, as these files are now generated automatically
	by bootstrap or automake.

	* po/ChangeLog: Remove: all but one entry was a duplicate
	of this file, and I moved that 2000-11-02 entry here.

	* config/.cvsignore: Add Makefile, depcomp, install-sh.
	* lib/.cvsignore: Add alloca.c, alloca.h, alloca_.h, argmatch.c,
	argmatch.h, basename.c, dirname.c, dirname.h, error.c, error.h,
	exit.h, exitfail.c, exitfail.h, getopt.c, getopt.h, getopt1.c,
	getopt_int.h, gettext.h, gnulib.mk, hard-locale.c, hard-locale.h,
	hash.c, hash.h, malloc.c, mbswidth.c, mbswidth.h, memchr.c,
	memcmp.c, memrchr.c, obstack.c, obstack.h, quote.c, quote.h,
	quotearg.c, quotearg.h, realloc.c, stdbool_.h, stpcpy.c, stpcpy.h,
	strcasecmp.c, strchr.c, stripslash.c, strncasecmp.c, strndup.c,
	strnlen.c, strrchr.c, strspn.c, strtol.c, strtoul.c,
	unlocked-io.h, xalloc.h, xmalloc.c, xstrdup.c, xstrndup.c,
	xstrndup.h.
	* m4/.cvsignore: Remove Makefile, Makefile.in.  Add alloca.m4,
	dirname.m4, dos.m4, error.m4, getopt.m4, hash.m4, mbrtowc.m4,
	mbswidth.m4, obstack.m4, onceonly.m4, quote.m4, quotearg.m4,
	stdbool.m4, stpcpy.m4, strnlen.m4, unlocked-io.m4, xalloc.m4.
	* po/.cvsignore: Add *.po, LINGUAS, Makefile.in.in, Makevars.
	* src/.cvsignore: Remove *_.c.


	* Makefile.maint (GZIP_ENV): Don't use --rsyncable if gzip doesn't
	support it.  (The latest stable gzip doesn't.)

2004-04-27  Paul Eggert  <eggert@twinsun.com>

	* data/lalr1.cc (Parser::stos_) [! YYDEBUG]: Define even in this
	case, as stos_ is now used by destructors due to the 2004-02-09
	change.

	Remove more K&R C support.
	* lib/libiberty.y (PARAMS): Remove.  All uses removed.
	* lib/subpipe.c (errno): Remove decl.
	Include <stdlib.h> unconditionally.
	(EXIT_FAILURE): Remove macro.
	* src/complain.c (vfprintf, strerror): Remove.
	* src/system.h: Include limits.h, stdlib.h, string.h, locale.h
	unconditionally.
	(EXIT_FAILURE, EXIT_SUCCESS, setlocale): Remove defns.
	Use latest Autoconf recommendations for including inttypes.h, stdint.h.
	(strchr, strspn, memchr): Remove decls.
	* tests/calc.at (_AT_DATA_CALC_Y): Include stdlib.h, string.h
	unconditionally.  Do not declare perror.
	* tests/conflicts.at (%nonassoc and eof): Include stdlib.h
	unconditionally.

	* src/complain.c (_): Remove useless defn, as system.h defines this.

	* lib/bitset.h (__INT_TO_PTR): Remove; workaround no longer needed
	with latest obstack.h.
	* lib/ebitset.c (ebitset_elt_alloc): Don't bother to cast args
	to procedure types, as obstack.h now does that for us.
	* lib/lbitset.c (lbitset_elt_alloc): Likewise.

	* lib/subpipe.h [HAVE_SYS_TYPES_H]: Include <sys/types.h>,
	so that this include file can stand alone.
	* lib/subpipe.c: Do not include <sys/types.h>, as subpipe.h
	does this now.  Include subpipe.h first after config.h, to
	test whether it can stand alone.

	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Don't
	declare yyerror when using lalr.cc, as GCC 3.4.0 warns about the
	unused declaration.

	* tests/synclines.at (%union synch line): Put a dummy member in
	the union, because empty unions aren't allowed in C.  Caught
	by GCC 3.4.0.

2004-04-13  Jim Meyering  <jim@meyering.net>

	* src/conflicts.c (conflicts_print): Correct format string typo:
	use `%%' to produce literal `%'.  (trivial change)

2004-03-30  Paul Eggert  <eggert@twinsun.com>

	* src/getargs.c (version): Update copyright year to 2004.

	* data/c.m4 (b4_int_type): Use 'short int' rather than
	'short', and similarly for 'long', 'unsigned', etc.
	* data/glr.c (YYTRANSLATE, yyconfl, yySymbol, yyItemNum,
	yygetLRActions, yyprocessOneStack, yyrecoverSyntaxError,
	yy_yypstack, yydumpstack): Likewise.
	* data/lalr1.cc (user_token_number_max_, user_token_number_max_,
	translate_, seq_, [], pop, Slice, range_, operator+, operator+=):
	Likewise.
	* data/yacc.c (b4_int_type, yyss, YYSTACK_BYTES, yysigned_char,
	yy_stack_print, yyparse): Likewise.
	* doc/bison.texinfo (Prologue, Multiple Types): Likewise.
	* lib/bbitset.h (bitset_word, BITSET_WORD_BITS): Likewise.
	* lib/bitset.c (bitset_print): Likewise.
	* lib/bitset_stats.c (bitste_log_histogram_print): Likewise.
	* lib/bitsetv-print.c (bitsetv_matrix_dump): Likewise.
	* lib/bitsetv.c (bitsetv_dump): Likewise.
	* lib/ebitset.c (EBITSET_ELT_BITS, ebitset_elt_alloc): Likewise.
	* lib/lbitset.c (LBITSET_ELT_BITS, lbitset_elt_alloc, debug_lbitset):
	Likewise.
	* src/LR0.c (allocate_itemsets): Likewise.
	* src/gram.h (rule_number, rule): Likewise.
	* src/lalr.h (goto_number): Likewise.
	* src/nullable.c (nullable_compute): Likewise.
	* src/output.c (prepare_rules): Likewise.
	* src/relation.c (relation_print, relation_digraph): Likewise.
	* src/relation.h (relation_node): Likewise.
	* src/state.h (state_number, transitions, errs, reductions,
	struct state): Likewise.
	* src/symtab.h (symbol_number, struct symbol): Likewise.
	* src/tables.c (vector_number, tally, action_number,
	default_goto, goto_actions): Likewise.
	* tests/existing.at (GNU Cim Grammar): Likewise.
	* tests/regression.at (Web2c Actions): Likewise.

	* src/output.c (muscle_insert_short_int_table): Renamed from
	muscle_insert_short_table.  All uses changed.

2004-03-25  Paul Hilfinger  <hilfingr@tully.CS.Berkeley.EDU>

	* src/parse-gram.y: Define PERCENT_EXPECT_RR.
	(declaration): Replace expected_conflicts with expected_sr_conflicts.
	Add %expect-rr rule.

	* src/scan-gram.l: Recognize %expect-rr.

	* src/conflicts.h (expected_sr_conflicts): Rename from
	expected_conflicts.
	(expected_rr_conflicts): Declare.

	* src/conflicts.c (expected_sr_conflicts): Rename from
	expected_conflicts.
	(expected_rr_conflicts): Define.
	(conflicts_print): Check r/r conflicts against expected_rr_conflicts
	for GLR parsers.
	Use expected_sr_conflicts in place of expected_conflicts.
	Warn if expected_rr_conflicts used in non-GLR parser.

	* doc/bison.texinfo: Add documentation for %expect-rr.

2004-03-08  Paul Eggert  <eggert@gnu.org>

	Add support for hex token numbers.  Suggested by Odd Arild Olsen in
	<http://lists.gnu.org/archive/html/bison-patches/2004-03/msg00000.html>.

	* NEWS: Document hexadecimal tokens, no NUL bytes, %destructor
	in lalr1.cc.
	* doc/bison.texinfo (Token Decl): Add hexadecimal token numbers.
	* src/scan-gram.l (scan_integer): New function.
	({int}): Use it.
	(0[xX][0-9abcdefABCDEF]+): New pattern, to support hex numbers.
	(<SC_ESCAPED_STRING,SC_ESCAPED_CHARACTER>, \\x[0-9abcdefABCDEF]+,
	handle_action_dollar, handle_action_at, convert_ucn_to_byte):
	Say "long int", not "long", for uniformity with GNU style.

2004-02-25  Paul Eggert  <eggert@twinsun.com>

	* tests/local.at (AT_COMPILE, AT_COMPILE_CXX): Ignore stdout from
	compilers.  This fixes a problem with Intel's C++ compiler being
	chatty, reported by Guido Trentalancia in
	<http://lists.gnu.org/archive/html/bug-bison/2004-02/msg00030.html>.

2004-02-09  Alexandre Duret-Lutz  <adl@gnu.org>

	Support %destructor and merge error locations in lalr1.cc.

	* data/lalr1.cc (b4_cxx_destruct_def): New macro.
	(Parser::stos_): Define unconditionally.
	(Parser::destruct_): New method.  Generate its body with
	b4_yydestruct_generate.
	(Parser::error_start_): New attribute.
	(Parser::parse) <yyerrlab, yyerrlab1>: Call destruct_ on erroneous
	token which are discarded.
	(Parser::parse) <yyerrlab, yyerrorlab, yyerrlab1>: Update
	error_start_ when erroneous token are discarded.
	(Parser::parse) <yyerrlab1>: Compute the location of the error
	token so that it covers all the discarded tokens.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Adjust so
	it can be called with `%skeleton "lalr1.cc"', and do that.

2004-02-02  Paul Eggert  <eggert@twinsun.com>

	* src/Makefile.am (AM_CPPFLAGS): New macro.  It mentions
	$(top_srcdir)/lib and ../lib.  This fixes a bug reported
	by Paul Hilfinger; the old INCLUDES value didn't mention ../lib.
	There's no need to mention top_builddir since Automake does that
	for us.
	(INCLUDES): Remove, as Automake says it's obsolescent.
	Contents migrated into AM_CPPFLAGS as described above.
	* lib/Makefile.am (INCLUDES): Remove; obsolescent.

2004-01-14  Paul Hilfinger  <hilfingr@CS.Berkeley.EDU>

	* data/glr.c (yytokenName): Bullet-proof against YYEMPTY token.
	(yyreportSyntaxError): Handle case where lookahead token is
	YYEMPTY.

2004-01-13  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/glr.c: Put casts on uses of YYREALLOC and YYMALLOC so that
	resulting parsers are compilable with C++.

2003-12-23  Paul Eggert  <eggert@twinsun.com>

	* config/depcomp, config/install-sh: Sync with Automake 1.8.
	* src/output.c (output_skeleton): Rename local var.
	* tests/input.at (Torturing the Scanner): Don't use \x0 or \0 in
	Bison tokens, as this runs afoul of the 2003-10-07 change that
	disallowed NUL bytes in character constants or string literals.

	* tests/local.at: Require Autoconf 2.59's Autotest.
	* tests/testsuite.at: Don't include local.at, since we now assume
	Autoconf 2.59 or later.  Autoconf 2.59 had some problems with
	including it.
	* tests/Makefile.am ($(TESTSUITE)): Remove warning about ignoring
	multiple inclusion warnings.

2003-12-02  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (How Can I Reset the Parser): More about start
	conditions.
	From Bruno Haible.

2003-11-18  Alexandre Duret-Lutz  <adl@gnu.org>

	* doc/bison.texinfo (Bison Options): Escape `@' in `$@'.

2003-10-07  Paul Eggert  <eggert@twinsun.com>

	* tests/Makefile.am (clean-local): Don't run 'testsuite --clean'
	if testsuite doesn't exist.

	* doc/bison.texinfo (Symbols): NUL bytes are not allowed in string
	literals, unfortunately.
	* src/scan-gram.l (<SC_ESCAPED_STRING,SC_ESCAPED_CHARACTER>):
	Complain about NUL bytes in character constants or string literals.

2003-10-05  Paul Eggert  <eggert@twinsun.com>

	* NEWS: Don't document %no-default-prec, as it's still
	too experimental.
	* doc/bison.texinfo: Document %no-default-prec only if
	the defaultprec flag is set.  Normally it's not.

2003-10-04  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (b4_rhs_value, b4_rhs_location): Yield a
	non-modifiable lvalue, instead of a modifiable one.
	* doc/bison.texinfo (Actions): Document that $$ can
	be assigned to.  Do not claim that $$ and $N are
	array element references: user code should not rely on this.

2003-10-01  Paul Eggert  <eggert@twinsun.com>

	* src/parse-gram.h (PERCENT_NO_DEFAULT_PREC): New token.
	(grammar_declaration): Use it.
	* src/scan-gram.l: New token %no-default-prec.
	* tests/conflicts.at: Revamp tests to use %no-default-prec.
	* NEWS, doc/bison.texinfo: Document the above.

2003-10-01  Akim Demaille  <akim@epita.fr>

	VCG no longer supports long_straight_phase.

	* src/vcg.c, src/vcg.h: Remove the handling of long_straight_phase.
	* src/print_graph.c (print_graph): Adjust.

2003-09-30  Frank Heckenbach  <frank@g-n-u.de>
	and Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo (Decl Summary, Contextual Precedence,
	Table of Symbols): Document %default-prec.
	* src/parse-gram.y (PERCENT_DEFAULT_PREC): New token.
	(grammar_declaration): Set default_prec on %default-prec.
	* src/scan-gram.l (%default-prec): New token.
	* src/reader.h (default_prec): New flag.
	* src/reader.c: Likewise.
	(packgram): Handle it.
	* tests/conflicts.at (%default-prec without %prec,
	%default-prec with %prec, %default-prec 1): New tests.

2003-09-30  Paul Eggert  <eggert@twinsun.com>

	* tests/testsuite.at: Include local.at, not input.at, fixing
	a typo in the 2003-08-25 patch.

2003-08-27  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (yyparse) [__GNUC__]: "Use" yyerrorlab to pacify
	GCC warnings.

2003-08-26  Akim Demaille  <akim@epita.fr>

	* config/announce-gen (print_changelog_deltas): Neutralize "<#" as
	"<\#" to avoid magic from Gnus when posting parts of this script.

2003-08-26  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (Parser::report_syntax_error_): New, extracted from
	(Parser::parse): here.
	Adjust: nerrs and errstatus is now replaced by...
	(Parser::nerrs_, Parser::errstatus_): New.

2003-08-25  Akim Demaille  <akim@epita.fr>

	* config/announce-gen, Makefile.cfg: New.
	* Makefile.am: Adjust.
	* GNUmakefile, Makefile.maint: Update from CVS Autoconf, but
	keeping local WGET and WGETFLAGS modifications from Paul Eggert.

2003-08-25  Akim Demaille  <akim@epita.fr>

	When reducing initial empty rules, Bison parser read an initial
	location that is not defined.  This results in garbage, and that
	affects Bison's own parser.  Therefore we need (i) to extend Bison
	to support a means to initialize this location, and (ii) to use
	this CVS Bison to fix CVS Bison's parser.

	* src/reader.h, reader.c (epilogue_augment): Remove, replace
	with...
	* src/muscle_tab.h, src/muscle_tab.c (muscle_code_grow): this.
	* src/parse-gram.y: Adjust.
	(%initial-action): New.
	(%error-verbose): Since we require CVS Bison, there is no reason
	not to use it.
	* src/scan-gram.l: Adjust.
	* src/Makefile.am (YACC): New, to make sure we use our own parser.
	* data/yacc.c (yyparse): Use b4_initial_action.

2003-08-25  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Don't promote stdout for error messages.

2003-08-25  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (Parser::reduce_print_): Remove unused yyi.
	From Alexandre Duret-Lutz.

2003-08-25  Akim Demaille  <akim@epita.fr>

	Version 1.875c.

2003-08-25  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (Parser::stack_print_, YY_STACK_PRINT): New.
	Use them.

2003-08-25  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (Parser::reduce_print_): New.
	Use it.

2003-08-25  Akim Demaille  <akim@epita.fr>

	Have lalr1.cc catch with Paul Eggert's patch to fix the infinite
	error recovery loops.  This patch is based on
	<http://lists.gnu.org/archive/html/bison-patches/2003-06/msg00000.html>.
	Also, augment the similarity between lalr1.cc and yacc.c.
	Note: the locations of error recovery rules are not correct yet.

	* data/lalr1.cc: Comment changes to augment the similarity between
	lalr1.cc and yacc.c.
	(YYERROR): Goto to yyerrorlab, not yyerrlab1.
	(yyerrlab1): Remove, but where it used to be (now the bottom part of
	yyerrlab), when hitting EOF, pop the whole stack here instead of
	merely falling thru the default error handling mechanism.
	(yyerrorlab): New label, with the old contents of YYERROR,
	plus the following change: pop the stack of rhs corresponding
	to the production that invoked YYERROR.  That is how Yacc
	behaves (required by POSIX).
	* tests/calc.at (AT_CHECK_CALC_LALR1_CC): No longer expected to
	fail.

2003-08-25  Akim Demaille  <akim@epita.fr>

	Tune local.at so that people can "autom4te -l autotest calc.at -o
	calc" for instance, to extract a sub test suite.

	* tests/testsuite.at: Move the initialization, Autotest version
	requirement, and AT_TESTED invocation into...
	* tests/local.at: here.
	* tests/testsuite.at: Include it for compatibility with Autoconf
	2.57.
	* tests/Makefile.am ($(TESTSUITE)): Report that the warning should
	be ignore.

2003-08-04  Paul Eggert  <eggert@twinsun.com>

	Rework code slightly to avoid gcc -Wtraditional warnings.
	* data/glr.c (yyuserMerge): Return void, not YYSTYPE.
	The returned value is now stored in *YY0.  All callers changed.
	* src/output.c (merge_output): Adjust to the above change.

2003-07-26  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (YYASSERT): New macro.
	(yyfillin, yydoAction, yyglrReduce, yysplitStack,
	yyresolveStates, yyprocessOneStack):
	Use `YYASSERT (FOO);' rather than `if (! (FOO)) abort ();'.
	Derived from a suggestion by Frank Heckenbach.

2003-07-25  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yyglrReduce): Don't use C89 string concatenation,
	for portability to K&R C (after ansi2knr, presumably).  See
	<http://lists.gnu.org/archive/html/bison-patches/2003-06/msg00041.html>
	by Frank Heckenbach, though I have omitted the structure-initialization
	part of his glr-knr.diff patch since I recall that the Portable
	C Compiler didn't require that change.

	Let the user specify how to allocate and free memory.
	Derived from a suggestion by Frank Heckenbach in
	<http://lists.gnu.org/archive/html/bison-patches/2003-06/msg00041.html>.
	* data/glr.c (YYFREE, YYMALLOC, YYREALLOC): New macros.
	All uses of free, malloc, realloc changed to use these macros,
	and unnecessary casts removed.
	* data/yacc.c (YYFREE, YYMALLOC): Likewise.

2003-07-06  Matthias Mann  <MatthiasMann@gmx.de>

	* data/lalr1.cc (operator<<(std::ostream&, const Position&)):
	use s.empty() rather than s == "" to test for empty string; see
	<http://lists.gnu.org/archive/html/bison-patches/2003-07/msg00003.html>
	(trivial change)

2003-06-25  Akim Demaille  <akim@epita.fr>

	* config/depcomp, config/install-sh: Update from masters.

2003-06-20  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (YYLLOC_DEFAULT): Parenthesize arguments as needed,
	and return properly parenthesized result.
	* data/lalar1.cc (YYLLOC_DEFAULT): Likewise.
	* data/yacc.c (YYLLOC_DEFAULT): Likewise.
	Remove unnecessary parentheses from uses.
	* doc/bison.texinfo (Location Default Action): Describe the
	conventions for parentheses.

2003-06-19  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yyremoveDeletes, yy_reduce_print, yyglrReduce,
	yyreportTree): Do not assume that size_t is the same width as int,
	when printing sizes.  Print sizes using an unsigned format.
	Problem reported by Frank Heckenbach in
	<http://lists.gnu.org/archive/html/bison-patches/2003-06/msg00035.html>.

	Port to Forte Developer 7 C compiler.
	* data/glr.c (struct YYLTYPE): If locations are not being used,
	declare a single dummy member, as empty structs do not conform
	to the C standard.
	(YYERROR, YYBACKUP): Do not use "do { ...; return foo; } while (0)";
	the Forte Developer 7 C compiler complains that end-of-loop
	code is not reached.

2003-06-17  Paul Eggert  <eggert@twinsun.com>

	* lib/libiberty.h (PARAMS): Spell argument as Args, not as X, to
	avoid warnings from picky compilers about redefinition of PARAMS.

2003-06-17  Paul Eggert  <eggert@twinsun.com>

	Version 1.875b.

	* NEWS: Document 1.875b.

	* lib/bbitset.h: Do not include config.h; that's the includer's job.
	Do not include <sys/types.h>; shouldn't be needed on a C89 host.
	* lib/bitset.h (bitset_compatible_p): Indent as per GNU standard.
	Don't use 'index' in comments, as it's a builtin fn on some hosts.
	* lib/bitset_stats.c: Include gettext.h unconditionally, as
	per recent gettext manual's suggestion.
	* lib/ebitset.c (ebitset_resize, ebitset_unused_clear):
	Use prototypes, not old-style definitions.
	* lib/lbitset.c (lbitset_unused_clear): Likewise.
	* lib/vbitset.c (vbitset_resize, vbitset_ones, vbitset_zero,
	vbitset_empty_p, vbitset_copy1, vbitset_not, vbitset_equal_p,
	vbitset_subset_p, vbitset_disjoint_p, vbitset_and, vbitset_and_cmp,
	vbitset_andn, vbitset_andn_cmp, vbitset_or, vbitset_or_cmp,
	vbitset_xor, vbitset_xor_cmp, vbitset_and_or, vbitset_and_or_cmp,
	vbitset_andn_or, vbitset_andn_or_cmp, vbitset_or_and,
	vbitset_or_and_cmp, vbitset_copy): Likewise.

	* lib/libiberty.h: Do not include config.h; that's the includer's job.
	Do not include <stdlib.h>.
	(PARAMS): Define unconditionally for C89.
	(ATTRIBUTE_NORETURN): Remove.
	(ATTRIBUTE_UNUSED): Define unconditionally.

	Upgrade to 2003-06-08 libbitset, submitted by Michael Hayes in:
	<http://lists.gnu.org/archive/html/bison-patches/2003-06/msg00005.html>
	* lib/Makefile.am (bitsets_sources): Add vbitset.c, vbitset.h.
	* lib/vbitset.c, lib/vbitset.h: New files.
	* lib/abitset.c, lib/bbitset.h, lib/bitset.c, lib/bitset.h,
	lib/bitset_stats.c, lib/ebitset.c, lib/lbitset.c: Import
	from libbitset.

	* doc/bison.texinfo (How Can I Reset the Parser): Renamed from
	`How Can I Reset @code{yyparse}', since texinfo does not allow
	arbitrary @ in node names.

	* m4/Makefile.am (EXTRA_DIST): Add the following files, which
	shouldn't be needed according to the gettext 0.12.1 documentation
	but which seem to be needed anyway: codeset.m4 glibc21.m4
	intdiv0.m4 inttypes-pri.m4 inttypes.m4 inttypes_h.m4 isc-posix.m4
	lcmessage.m4 nls.m4 po.m4 stdint_h.m4 uintmax_t.m4 ulonglong.m4.
	* po/Makefile.in.in: Upgrade to gettext 0.12.1 version.

	* lib/.cvsignore: Add stdbool.h.
	* m4/.cvsignore: Add nls.m4, po.m4.

	Upgrade to CVS gnulib.
	* stdbool_.h: File renamed from stdbool.h.in.
	* configure.ac (AM_STDBOOL_H): Invoke this instead of
	AC_HEADER_STDBOOL.
	(AM_GNU_GETTEXT): Put brackets around args, as latest manual suggests.
	(AM_GNU_GETTEXT_VERSION): Update to 0.12.1.
	* lib/Makefile.am (EXTRA_DIST): Add stdbool_.h.
	(MOSTLYCLEANFILES): New var.
	($(libbison_a_OBJECTS)): Depend on $(STDBOOL_H).
	(stdbool.h): New rule.
	* lib/dirname.c, lib/dirname.h, lib/hash.c, lib/hash.h,
	lib/malloc.c, lib/obstack.h, lib/quote.c, lib/realloc.c,
	lib/strcasecmp.c, lib/xalloc.h, m4/alloca.m4, m4/onceonly.m4,
	m4/quote.m4: Upgrade to today's gnulib.

	* tests/calc.at (AT_CHECK_CALC): New option EXPECTED-TO-FAIL.
	(AT_CHECK_CALC_LALR1_CC): Use it, since the C++ LALR parser fails
	the tests right now.
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Ensure yylex and
	yyerror are declared before use; C99 requires this.

2003-06-09  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/glr.c (YYERROR): Update definition to reset yyerrState to 0
	first.
	(yyrecoverSyntaxError): Correct the logic for setting and testing
	yyerrState.
	Correct comment on handling EOF.
	Allow states with only a default reduction, rather than failing
	(I can't quite reconstruct why these were not allowed before).

	Fixes to avoid problem that $-N rules in GLR parsers can cause
	buffer overruns, corrupting state.

	* src/output.c (prepare_rules): Output max_left_semantic_context
	definition.
	* src/reader.h (max_left_semantic_context): New variable declaration.
	* src/scan-gram.l (max_left_semantic_context): Define.
	(handle_action_dollar): Update max_left_semantic_context.
	* data/glr.c (YYMAXLEFT): New definition.
	(yydoAction): Increase size of yyrhsVals by YYMAXLEFT.
	(yyresolveAction): Ditto.

	Fixes to problems with location handling in GLR parsers reported by
	Frank Heckenbach (2003/06/05).

	* data/glr.c (YYLTYPE): Make trivial if locations not used.
	(YYRHSLOC): Add parentheses, and define only if locations used.
	(YYLLOC_DEFAULT): Add parentheses, and give trivial definition if
	locations not used.
	(yyuserAction): Use YYLLOC_DEFAULT to set *yylocp.
	(yydoAction): Remove redundant initialization of *yyvalp and *yylocp.

	* tests/cxx-type.at: Exercise location information; update tests
	to differentiate output with and without locations.
	Remove forward declarations of yylex and yyerror---caused errors
	because default YYLTYPE not yet defined.
	Change semantic actions to compute strings, rather than printing
	them directly (to test proper passing of semantics values).  Change
	output to prefix notation and update test data and expected results.
	(yylex): Track locations.
	(stmtMerge): Return value rather than printing, and include arguments
	in value.

2003-06-03  Paul Eggert  <eggert@twinsun.com>

	Avoid warnings generated by GCC 2.95.4 when Bison is
	configured with --enable-gcc-warnings.
	* data/lalr1.cc (yy::]b4_parser_class_name[::parse,
	yy::]b4_parser_class_name[::translate_,
	yy::Stack::operator[] (unsigned),
	yy::Stack::operator[] (unsigned) const,
	yy::Slice::operator[] (unsigned),
	yy::Slice::operator[] (unsigned) const):
	Rename local vars to avoid warnings.
	* tests/glr-regression.at (Improper handling of embedded actions
	and $-N in GLR parsers): Remove unused local variable from yylex.
	* tests/regression.at (_AT_DATA_DANCER_Y): Declare yylex to take
	(void) as arg when not pure, since we now assume C89 when building
	Bison.  Pacify GCC by using parameter.

2003-06-02  Paul Eggert  <eggert@twinsun.com>

	* data/lalr1.cc (yy::Position::lines, yy::Position::columns,
	yy::Location::lines, yy::Location::columns): Rename arguments
	to avoid shadowing; this removes a warning generated by GCC 3.3.

2003-06-01  Paul Eggert  <eggert@twinsun.com>

	Don't pass C-only warning optins (e.g., -Wmissing-declarations)
	to g++, as GCC 3.3 complains if you do it.
	* configure.ac (WARNING_CXXFLAGS): New subst.  Set it to
	everything that WARNING_CFLAGS has, except omit warnings
	not suitable for C++.
	(AC_PROG_CXX): Use this instead of AC_CHECK_PROGS([CXX], [g++]).
	* tests/atlocal.in (CXXFLAGS): New var.
	* tests/local.at (AT_COMPILE_CXX): Use it instead of CFLAGS.

	Fix a GLR parser bug I reported in February; see
	<http://lists.gnu.org/archive/html/bison-patches/2003-02/msg00008.html>.
	The problem was that GLR parsers did not conform to the C standard,
	because actions like { $1 = $2 + $3; } expanded to expressions
	that invoked YYFILL in separate subexpressions, and YYFILL assigned
	to a local variable.  The C standard says that expressions
	like (var = f ()) + (var = f ()) have undefined behavior.
	Another problem was that GCC sometimes issues warnings that
	yyfill and its parameters are unused.

	* data/glr.c (yyfillin): Renamed from the old yyfill.  Mark
	as possibly unused.
	(yyfill): New function.
	(YYFILL): Use it.
	(yyuserAction): Change type of yynormal to bool, so that it matches
	the new yyfill signature.  Mark it as possibly unused.


	Follow up on a bug I reported in February, where a Bison-generated
	parser can loop.  Provide a test case and a fix for yacc.c.  I
	don't have a fix for lalr1.cc or for glr.c, unfortunately.
	The original bug report is in:
	<http://lists.gnu.org/archive/html/bison-patches/2003-02/msg00044.html>

	* data/yacc.c (YYERROR): Now just 'goto yyerrorlab', since the
	macro's size was becoming unwieldy.
	(yyerrlab): Do not discard an empty lookahead symbol, as this
	might destroy garbage.
	(yyerrorlab): New label, with the old contents of YYERROR,
	plus the following change: pop the stack of rhs corresponding
	to the production that invoked YYERROR.  That is how Yacc
	behaves, and POSIX requires this behavior.
	(yyerrlab1): Use YYPOPSTACK instead of its definiens.
	* tests/calc.at (_AT_DATA_CALC_Y): Include unistd.h if available.
	Define 'alarm' to do nothing if unistd.h is not available.
	Add a new rule "exp: '-' error;" to test the above change to
	data/yacc.c.  Use 'alarm' to abort any test taking longer than
	10 seconds, as it's probably looping.
	(AT_CHECK_CALC): Test recovery from error in new grammar rule.
	Also, the new yacc.c generates two fewer diagnostics for an
	existing test.

2003-05-24  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (YYSTACKEXPANDABLE): Do not evaluate
	YYSTYPE_IS_TRIVIAL or YYSTYPE_IS_TRIVIAL unless they are defined.
	This fixes a problem reported by John Bowman when the Compaq/HP
	Alpha cxx compiler happy (e.g. using cxx -D__USE_STD_IOSTREAM
	-ansi -Wall -gall).
	* data/yacc.c (union yyalloc): Likewise.
	(YYCOPY): Do not evaluate __GNUC__ unless it is defined.

	Switch from 'int' to 'bool' where that makes sense.

	* lib/abitset.c (abitset_test, abitset_empty_p, abitset_equal_p,
	abitset_subset_p, abitset_disjoint_p, abitset_and_cmp,
	abitset_andn_cmp, abitset_or_cmp, abitset_xor_cmp, abitset_and_or,
	abitset_and_or_cmp, abitset_andn_or_cmp, abitset_or_and_cmp):
	Return or accept bool, not int.  All callers changed.
	* lib/bbitset.h: (bitset_toggle_, bitset_copy_, bitset_and_or_cmp_,
	bitset_andn_or_cmp_, bitset_or_and_cmp_): Likewise.
	* lib/bitset.c (bitset_only_set_p, bitset_print, bitset_toggle_,
	bitset_copy_, bitset_op4_cmp, bitset_and_or_cmp_, bitset_andn_or_cmp_,
	bitset_or_and_cmp_): Likewise.
	* lib/bitset.h (bitset_test, bitset_only_set_p): Likewise.
	* lib/bitset_stats.c (bitset_stats_print, bitset_stats_toggle,
	bitset_stats_test, bitset_stats_empty_p, bitset_stats_disjoint_p,
	bitset_stats_equal_p, bitset_stats_subset_p, bitset_stats_and_cmp,
	bitset_stats_andn_cmp, bitset_stats_or_cmp, bitset_stats_xor_cmp,
	bitset_stats_and_or_cmp, bitset_stats_andn_or_cmp,
	bitset_stats_or_and_cmp): Likewise.
	* lib/ebitset.c (ebitset_elt_zero_p, ebitset_equal_p, ebitset_copy_cmp,
	ebitset_test, ebitset_empty_p, ebitset_subset_p, ebitset_disjoint_p,
	ebitset_op3_cmp, ebitset_and_cmp, ebitset_andn_cmp, ebitset_or_cmp,
	ebitset_xor_cmp): Likewise.
	* lib/lbitset.c (lbitset_elt_zero_p, lbitset_equal_p, lbitset_copy_cmp,
	lbitset_test, lbitset_empty_p, lbitset_subset_p, lbitset_disjoint_p,
	lbitset_op3_cmp, lbitset_and_cmp, lbitset_andn_cmp, lbitset_or_cmp,
	lbitset_xor_cmp): Likewise.
	* lib/bbitset.h: Include <stdbool.h>.
	(struct bitset_vtable): The following members now return bool, not
	int: toggle, test, empty_p, disjoint_p, equal_p, subset_p,
	and_cmp, andn_cmp, or_cmp, xor_cmp, and_or_cmp, andn_or_cmp,
	or_and_cmp).
	* src/conflicts.c (count_rr_conflicts): Likewise.
	* lib/bitset_stats.h (bitset_stats_enabled): Now bool, not int.
	All uses changed.
	* lib/ebitset.c (ebitset_obstack_init): Likewise.
	* lib/lbitset.c (lbitset_obstack_init): Likewise.
	* src/getargs.c (debug_flag, defines_flag, locations_flag,
	no_lines_flag, no_parser_flag, token_table_flag, yacc_flag,
	graph_flag): Likewise.
	* src/getargs.h (debug_flag, defines_flag, locations_flag,
	no_lines_flag, no_parser_flag, token_table_flag, yacc_flag,
	graph_flag): Likewise.
	* src/output.c (error_verbose): Likewise.
	* src/output.h (error_verbose): Likewise.
	* src/reader.c (start_flag, typed): Likewise.
	* src/reader.h (typed): Likewise.
	* src/getargs.c (LOCATIONS_OPTION): New constant.
	(long_options, getargs): Use it.
	* src/lalr.c (build_relations): Use bool, not int.
	* src/nullable.c (nullable_compute): Likewise.
	* src/print.c (print_reductions): Likewise.
	* src/tables.c (action_row, pack_vector): Likewise.
	* src/muscle_tab.h (MUSCLE_INSERT_BOOL): New macro.
	* src/output.c (prepare): Use it.
	* src/output.c (token_definitions_output,
	symbol_destructors_output, symbol_destructors_output): Use string,
	not boolean integer, to keep track of whether to output separator.
	* src/print_graph.c (print_core): Likewise.
	* src/state.c (state_rule_lookaheads_print): Likewise.

	* config/install-sh: Sync from automake 1.7.5.

2003-05-14  Paul Eggert  <eggert@twinsun.com>

	* src/parse-gram.y (rules_or_grammar_declaration): Require a
	semicolon after a grammar declaration, in the interest of possible
	future changes to the Bison input language.
	Do not allow a stray semicolon at the start of the grammar.
	(rhses.1): Allow one or more semicolons after any rule, including
	just before "|" as required by POSIX.
	* tests/input.at (Torturing the Scanner): Add tests for ";|" in a
	grammar.

2003-05-14  Alexandre Duret-Lutz  <adl@gnu.org>

	%parse-param support for lalr1.cc.

	* data/lalr1.cc (b4_parse_param_decl, b4_parse_param_cons,
	b4_cc_constructor_calls, b4_cc_constructor_call,
	b4_parse_param_vars, b4_cc_var_decls, b4_cc_var_decl): New m4
	definitions.
	(yy::b4_parser_class_name::b4_parser_class_name): Take extra
	parse-param arguments.
	(yy::b4_parser_class_name): Declare instance variables to
	hold parse-param arguments.
	* tests/calc.at: s/value/semantic_value/ because value clashes
	with a member of yy::b4_parser_class_name.  Adjust C++ code
	to handle %parse-param.  Enable %parse-param test in C++.

2003-05-12  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo (How Can I Reset @code{yyparse}): Reword the
	English a bit.  Fix fclose typo.  Change "const char" to "char
	const", and use ANSI C rather than K&R for "main".  Suggest
	YY_FLUSH_BUFFER over yyrestart (as that is what Flex recommends)
	and suggest yy_switch_to_buffer.

2003-05-05  Paul Eggert  <eggert@twinsun.com>

	* lib/bitset.h (__INT_TO_PTR): Define to a value that presumes
	C89.  This avoids a diagnostic on compilers that define __STDC__
	to 0, fixing a problem with Tru64 cc reported by Martin Mokrejs in
	<http://lists.gnu.org/archive/html/bug-bison/2003-04/msg00041.html>.

2003-05-03  Paul Eggert  <eggert@twinsun.com>

	* lib/bitset.h (BITSET_FOR_EACH, BITSET_FOR_EACH_REVERSE):
	Do not overrun array bounds.
	This should fix a bug reported today by Olatunji Oluwabukunmi in
	<http://lists.gnu.org/archive/html/bug-bison/2003-05/msg00004.html>.

2003-04-29  Akim Demaille  <akim@epita.fr>

	* src/gram.h, src/gram.c (pure_parser, glr_parser): Move to...
	* src/getargs.c, src/getargs.h: here, as bool, not int.
	(nondeterministic_parser): New.
	* src/parse-gram.y, src/scan-gram.l: Support
	%nondeterministic-parser.
	* src/output.c (prepare): Use nondeterministic_parser instead
	of glr_parser where appropriate.
	* src/tables.c (conflict_row, action_row, save_row)
	(token_actions, token_actions, pack_vector): Ditto.

2003-04-29  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (C++ Parsers, Implementing Loops): New.

2003-04-29  Akim Demaille  <akim@epita.fr>

	* tests/calc.at: Also test yacc.c and glr.c (but not lalr1.cc yet)
	with %pure-parser and %locations to exercise the patch from Yakov
	Markovitch below.

2003-04-28  Tim Van Holder <tim.van.holder@pandora.be>

	* data/yacc.c: (b4_lex_param): Corrected for the case where
	%lex-param is provided and %pure-parser isn't.

2003-04-27  Paul Eggert  <eggert@twinsun.com>

	Avoid gcc -Wundef warnings reported by Gerald Pfeifer in
	<http://lists.gnu.org/archive/html/bug-bison/2003-04/msg00044.html>.
	* data/yacc.c (YYSTACK_ALLOC): Don't evaluate YYSTACK_USE_ALLOCA
	if it is not defined.
	(YYMAXDEPTH): Don't evaluate YYMAXDEPTH if it is not defined.

2003-04-26  Paul Eggert  <eggert@twinsun.com>

	* data/lalr1.cc (yy::Parser::pact_ninf_, yy::Parser::table_ninf_):
	Declare to be of type suitable for the ninf value itself, not of
	type suitable for the corresponding table, since the latter might
	be unsigned but the ninf value might be negative.  This fixes a
	bug reported by Alexandre Duret-Lutz in
	<http://lists.gnu.org/archive/html/bug-bison/2003-04/msg00017.html>.

	* configure.ac (AC_FUNC_ERROR_AT_LINE): Remove, since gl_ERROR
	invokes it.  We shouldn't invoke it twice because it will attempt
	to put error.o in the archive twice.  This fixes a glitch reported
	by Martin Mokrejs in
	<http://lists.gnu.org/archive/html/bug-bison/2003-04/msg00041.html>.

2003-04-21  Paul Eggert  <eggert@twinsun.com>

	* m4/error.m4: Update from Bruno Haible's 2003-04-14 patch
	to gnulib.

2003-04-21  Yakov Markovitch <Markovitch@iso.ru>

	* data/glr.c (yyexpandGLRStack) [!YYSTACKEXPANDABLE]:
	Fix obvious typo that results in uncompilable GLR parsers
	when both %pure-parser and %locations are used.  (trivial change)

2003-04-17  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l: Add %option nounput, since we no longer use unput.
	(unexpected_eof): Renamed from unexpected_end_of_file, for brevity.
	Do not insert the expected token via unput, as this runs afoul
	of a POSIX-compatibility bug in flex 2.5.31.
	All uses changed to BEGIN the parent state,
	since we no longer insert the expected token via unput.
	* tests/regression.at (Invalid inputs): Remove cascaded diagnostic
	that is no longer emitted after the above change.

	* src/conflicts.c (set_conflicts): Resolve all conflicts, not just
	the first one.  This change is from Paul Hilfinger, and it fixes
	regression reported by Werner Lemberg in
	<http://lists.gnu.org/archive/html/bug-bison/2003-04/msg00026.html>.

	(resolve_sr_conflict): Don't invoke state_errs_set
	unless one or more tokens have been explicitly made errors.
	Otherwise, the above change causes Bison to abort.

	* tests/existing.at (GNU pic Grammar): New test case, taken from
	Lemberg's email.

2003-03-31  Akim Demaille  <akim@epita.fr>

	* doc/Makefile.am (AM_MAKEINFOFLAGS): Don't split the info file.

2003-03-31  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare_symbols): Avoid trailing spaces in the
	output.

2003-03-31  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Strings are Destroyed): s/losses/loses/.
	From Paul Hilfinger.

2003-03-29  Akim Demaille  <akim@epita.fr>

	* m4/error.m4: Do not put under dynamic conditions some code which
	expansion is under static control.

2003-03-29  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (How Can I Reset @code{yyparse}): New.

2003-03-29  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Strings are Destroyed): New.

2003-03-13  Paul Eggert  <eggert@twinsun.com>

	* .cvsignore: Add configure.lineno.
	* src/.cvsignore: Add yacc.
	* tests/.cvsignore: Add testsuite.log.
	* doc/fdl.texi: Sync with latest FSF version.

2003-03-12  Paul Eggert  <eggert@twinsun.com>

	* scan-gram.l (YY_USER_INIT): Initialize code_start, too.
	(<INITIAL><<EOF>>, <SC_PRE_CODE><<EOF>>): Set *loc to the scanner
	cursor, instead of leaving it undefined.  This fixes a bug
	reported by Tim Van Holder in
	<http://lists.gnu.org/archive/html/bug-bison/2003-03/msg00023.html>.
	* tests/input.at (Torturing the Scanner): Test the scanner on
	an empty input file, which was Tim Van Holder's test case.

	* m4/timevar.m4 (BISON_PREREQ_TIMEVAR): When checking whether
	<sys/resource.h> can be included, include sys/time.h and
	sys/times.h first, if available.  This works around the SunOS
	4.1.4 porting bug reported by Bruce Becker in
	<http://lists.gnu.org/archive/html/bug-bison/2003-03/msg00018.html>.

	* m4/subpipe.m4 (BISON_PREREQ_SUBPIPE): Don't
	AC_CHECK_HEADERS([sys/wait.h]), as this interferes with
	AC_HEADER_SYS_WAIT.

	Merge changes from gnulib.  This was prompted because the CVS
	snapshot didn't build on Solaris 7 due to strnlen problems.

	These changes need to be merged back into gnulib:
	* lib/hash.c: Include <stdbool.h> unconditionally.
	* m4/onceonly.m4 (m4_quote): New macro.
	(AC_CHECK_HEADERS_ONCE, AC_CHECK_FUNCS_ONCE, AC_CHECK_DECLS_ONCE):
	Quote AC_FOREACH variable-expansions properly.
	The 2003-01-03 obstack.h change also needs merging.
	{end of changes requiring merging}

	* lib/stdbool.h.in, m4/alloca.m4, m4/dirname.m4, m4/dos.m4,
	m4/getopt.m4, m4/hash.m4, m4/malloc.m4, m4/memchr.m4,
	m4/memrchr.m4, m4/obstack.m4, m4/onceonly.m4, m4/quote.m4,
	m4/quotearg.m4, m4/realloc.m4, m4/stpcpy.m4, m4/strnlen.m4,
	m4/strtol.m4, m4/strtoul.m4, m4/unlocked-io.m4, m4/xalloc.m4:
	New files, imported from gnulib.
	* m4/Makefile.am (EXTRA_DIST): Add the new m4/*.m4 files mentioned
	above.

	* lib/mbswidth.c, m4/error.m4, m4/mbrtowc.m4, m4/mbswidth.m4,
	m4/memcmp.m4, m4/prereq.m4, m4/stdbool.m4: Update to current
	gnulib sources.

	* configure.ac (gl_DIRNAME, gl_GETOPT, gl_HASH, gl_QUOTE, gl_XALLOC):
	Add.
	(gl_ERROR): New, replacing jm_PREREQ_ERROR.
	(gl_FUNC_ALLOCA): New, replacing AC_FUNC_ALLOCA.
	(gl_FUNC_STPCPY): New, replacing AC_REPLACE_FUNCS(stpcpy).
	(gl_FUNC_STRNLEN): New, replacing AC_FUNC_STRNLEN.
	(gl_MBSWIDTH): New, replacing jm_PREREQ_MBSWIDTH.
	(gl_OBSTACK): New, replacing AC_FUNC_OBSTACK.
	(gl_QUOTEARG): New, replacing jm_PREREQ_QUOTEARG.
	(jm_FUNC_GLIBC_UNLOCKED_IO, gl_FUNC_STPCPY, gl_FUNC_STRTOL): New.
	(jm_FUNC_MALLOC): New, replacing AC_FUNC_MALLOC.
	(jm_FUNC_REALLOC): New, replacing AC_FUNC_REALLOC.
	(jm_PREREQ_ARGMATCH): Remove.
	(AC_REPLACE_FUNCS): Remove memchr, memrchr, stpcpy, strtol, strtoul.
	* lib/Makefile.am (libbison_a_SOURCES): Add argmatch.c, argmatch.h.

	* src/system.h: Include <stdbool.h> unconditionally.

	* lib/bbitset.h: Include <limits.h> unconditionally.  We have been
	assuming at least C89 in the bitset code for some time now.

2003-03-03  Akim Demaille  <akim@epita.fr>

	* ro.po: New.

2003-03-02  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Table of Symbols): Reactivate the
	documentation for %lex-param, and %parse-param.

2003-03-02  Akim Demaille  <akim@epita.fr>

	* data/yacc.c, data/glr.c, data/lal1.cc: Use similar code to
	generate verbose error messages.
	Use the number of tokens as an upper bound in yytname, as it
	cannot be a non terminal.

2003-03-02  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (_AT_DATA_DANCER_Y): Fix the expected error
	message.

2003-03-02  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (_AT_DATA_DANCER_Y, AT_CHECK_DANCER): New.
	Use them to exercise yycheck overrun.
	Based on Andrew Suffield's grammar.

2003-03-02  Akim Demaille  <akim@epita.fr>

	Create tests/local.at for Bison generic testing macros.

	* tests/calc.at (AT_CHECK_PUSHDEFS, AT_CHECK_POPDEFS): Move to...
	* tests/local.at (AT_BISON_OPTION_PUSHDEFS, AT_BISON_OPTION_POPDEFS):
	This new file.
	* tests/calc.at (AT_CHECK_CALC): Adjust.
	* tests/testsuite.at (AT_DATA_GRAMMAR_PROLOGUE, AT_DATA_GRAMMAR)
	(AT_COMPILE, AT_COMPILE_CXX, AT_PARSER_CHECK): Move to...
	* tests/local.at: here.
	(AT_COMPILE_CXX): Tags the tests using it as c++.
	Ignore the test if CXX is not functional.

2003-03-01  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l (code_start): Initialize it to scanner_cursor,
	not loc->end, since loc->end might contain garbage and this leads
	to undefined behavior on some platforms.
	(id_loc, token_start): Use (IF_LINTed) initial values that do not
	depend on *loc, so that the reader doesn't give the the false
	impression that *loc is initialized.
	(<INITIAL>"%%"): Do not bother setting code_start, since its value
	does not survive the return.

2003-03-01  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (code_start): Always initialize it when entering
	into yylex, as SC_EPILOGUE is activated *before* the corresponding
	yylex invocation.  An alternative would be making it static, but
	then it starts with the second %%'s beginning, instead of its end.

2003-02-28  Paul Eggert  <eggert@twinsun.com>

	* lib/mbswidth.c: Include <wchar.h> before "mbswidth.h", to work
	around a UnixWare 7.1.1 porting bug reported by John Hughes in
	<http://lists.gnu.org/archive/html/bug-bison/2003-02/msg00030.html>.

2003-02-26  Paul Eggert  <eggert@twinsun.com>

	* README: Mention compiler bug in Sun Forte Developer 6 update 2.
	Remove Sequent/Pyramid discussion (nobody uses them any more).
	Merge VMS and MS-DOS discussion; these ports may well be dead
	but let's keep mentioning them for now.  Put <> around email
	addresses.  Add copyright notice.

2003-02-24  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yy_reduce_print): yylineno -> yylno,
	to avoid collision with flex use of yylineno.
	Problem reported by Bruce Lilly in
	<http://lists.gnu.org/archive/html/bug-bison/2003-02/msg00016.html>.
	* data/lalr1.cc (yy::]b4_parser_class_name[::parse): Likewise.
	* data/yacc.c (yy_reduce_print): Likewise.

	* config/depcomp: Sync with Automake 1.7.3.

2003-02-21  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: Use temporary variables instead of casts to
	change integer types.
	Suggested by Paul Eggert.

2003-02-21  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Use "location" consistently to refer to @n,
	to avoid confusions with lalr1.cc's notion of Position.
	Suggested by Paul Eggert.

2003-02-20  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (position.hh): Make sure "columns" never pushes
	before initial_columns.
	(location.hh): Use consistent variable names when defining the
	operator<<.
	Use "last" so that we subtract from Positions, not from unsigned.

2003-02-20  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (position.hh): New subfile, including the extended
	and Doxygen'ed documentation of class Position.
	(location.hh): Use it.
	Document a` la Doxygen.
	With the help of Benoit Perrot.

2003-02-20  Akim Demaille  <akim@epita.fr>

	* tests/calc.at (AT_CHECK_PUSHDEFS, AT_CHECK_POPDEFS): Define
	AT_YACC_IF.
	Redefine AT_YYERROR_SEES_LOC_IF using it.
	(_AT_DATA_CALC_Y): Don't declare yyerror when lalr1.cc, as it is
	not defined.
	Don't use the location in yy::Parser::error_ and
	yy::Parser::print_ when not %locations.
	Activate more lalr1.cc tests.

2003-02-19  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: When displaying a line number, be sure to make it
	an int.

2003-02-19  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (b4_stack_depth_init, yy::Parser::initdepth_):
	Remove, useless.
	(YYABORT, YYACCEPT, YYERROR): New.
	* tests/calc.at: Renable the lalr1.cc test.

2003-02-19  Akim Demaille  <akim@epita.fr>

	* tests/calc.at (AT_CHECK_CALC): Check different scenarios of
	error recovery, mixing with/without pops and discarding of the
	lookahead.
	Exercise YYERROR.
	Disable the lalr1.cc tests as currently it doesn't support YYERROR.

2003-02-17  Paul Eggert  <eggert@twinsun.com>

	* tests/atlocal.in (LDFLAGS, LIBS): New vars.
	* tests/testsuite.at (AT_COMPILE): Use them.
	This fixes the testsuite problem reported by Robert Lentz in
	<http://lists.gnu.org/archive/html/bug-bison/2003-02/msg00011.html>.

2003-02-12  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c (yyerrlab) [YYERROR_VERBOSE]:
	Avoid subscript error in yycheck.  Bug reported by Andrew Suffield in
	<http://lists.gnu.org/archive/html/bug-bison/2003-02/msg00003.html>.
	* data/glr.c (yyreportSyntaxError) [YYERROR_VERBOSE]: Likewise.
	Check for malloc failure, for consistency with yacc.c.
	(yytname_size): Remove, for consistency with yacc.c.

	The bug still remains in data/lalr1.cc, as I didn't have time
	to fix it there.

2003-02-06  Akim Demaille  <akim@epita.fr>

	* configure.ac (GXX): Rename as...
	(CXX): this, to keep the original Autoconf semantics.
	Require 2.57.
	* data/lalr1.cc: Fix b4_copyright invocations.
	If YYDEBUG is not defined, don't depend upon name_ being defined.
	(location.hh): Include string and iostream.
	(Position::filename): New member.
	(Position::Position ()): New.
	(operator<< (Position)): New.
	(operator- (Position, int)): New.
	(Location::first, Location::last): Rename as...
	(Location::begin, Location::end): these, to mock the conventional
	iterator names.
	(operator<< (Location)): New.
	* tests/atlocal.in (CXX): New.
	* tests/testsuite.at (AT_COMPILE_CXX): New.
	* tests/calc.at (_AT_DATA_CALC_Y): Adjust yyerror to report the
	locations in a more synthetic way.
	(AT_CHECK_PUSHDEFS): AT_YYERROR_SEES_LOC_IF is positive if
	lalr1.cc is used.
	Adjust the C locations to match those from Emacs: first column is
	column 0.
	Change all the expected results.
	Conform to the GCS: simplify the locations when applicable.
	(LOC, VAL, YYLLOC_FORMAL, YYLLOC_ARG, USE_YYLLOC, LEX_FORMALS)
	(LEX_ARGS, USE_LEX_ARGS, LEX_PRE_FORMALS, LEX_PRE_ARGS): Replace
	these CPP macros with the m4 macros new defined by...
	(AT_CHECK_PUSHDEFS): this, i.e.:
	(AT_LALR1_CC_IF, AT_PURE_LEX_IF, AT_LOC, AT_VAL, AT_LEX_FORMALS)
	(AT_LEX_ARGS, AT_USE_LEX_ARGS, AT_LEX_PRE_FORMALS, AT_LEX_PRE_ARGS)
	New macros.
	(AT_CHECK_POPDEFS): Undefine them.
	(AT_CHECK_CALC_LALR1_CC): New.
	Use it for the first lalr1.cc test.

2003-02-04  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc (YYLLOC_DEFAULT): Fix its definition: be based on
	Location as is defined.

2003-02-04  Akim Demaille  <akim@epita.fr>

	* data/lalr1.cc: If YYDEBUG is not defined, don't depend upon
	name_ being defined.

2003-02-03  Paul Eggert  <eggert@twinsun.com>

	* src/gram.h (start_symbol): Remove unused decl.

	Use more-consistent naming conventions for local vars.

	* src/derives.c (derives_compute): Change type of local var from
	int to rule_number.
	* src/gram.c (grammar_rules_partial_print): Likewise.
	* src/print.c (print_core): Likewise.
	* src/reduce.c (reduce_grammar_tables): Likewise.

	* src/gram.c (grammar_dump): Change name of item_number *
	local var from r to rp.
	* src/nullable.c (nullable_compute): Likewise.

	* src/gram.h (ISTOKEN, ISVAR): Use i, not s, for int var.

	* src/gram.h (symbol_number_as_item_number): Use sym, not s,
	for symbol or symbol_number var.
	* src/reader.c (grammar_start_symbol_set): Likewise.
	* src/reader.h (grammar_start_symbol_set, grammar_symbol_append):
	Likewise.
	* src/state.c (transitions_to): Likewise.
	* src/state.h: Likewise.
	* src/tables.c (symbol_number_to_vector_number): Likewise.

	* src/muscle_tab.h (MUSCLE_OBSTACK_SGROW): Use p, not s, for
	char * var.

	* src/parse-gram.y (lloc_default): Use loc, not r, for YYLTYPE
	var.

	* src/scan-gram.l (no_cr_read): Use bytes_read, not s, for size
	var.

	* src/system.h (xstrndup, strchr, strspn, strnlen, memchr, memrchr):
	Use str, not s, for char * var.  Use ch, not c, for character var.
	Use size for size var.

	* src/uniqstr.c (uniqstr_new, uniqstr_assert): Use str, not s, for
	char * var.
	(uniqstr_print, uniqst_print_processor): Use ustr, not s, for
	uniqstr var.
	* src/uniqstr.h: Likewise.

	* src/vcg.c (get_color_str, get_textmode_str, get_shape_str,
	get_layoutalgorithm_str, get_decision_str, get_orientation_str,
	get_node_alignment_str, get_arrow_mode_str, get_crossing_type_str,
	get_view_str, get_linestyle_str, get_arrowstyle_str): Rename
	param to have same name as that of enum, so that we don't use
	"s" to stand for a non-state.

2003-02-02  Akim Demaille  <akim@epita.fr>

	* src/scan-skel.l: Scan more than one inert character per yylex
	invocation.

2003-02-01  Paul Eggert  <eggert@twinsun.com>

	Version 1.875a.

	* po/LINGUAS: Add ms.

2003-01-30  Akim Demaille  <akim@epita.fr>

	* doc/Makefile.am (CLEANFILES): Add bison.fns for distcheck.

2003-01-29  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* tests/cxx-type.at: Correct apparent typo in Bison input: $$ instead
	of $1.

	Changes in response to error report by S. Eken: GLR mode does not
	handle negative $ indices or $ indices in embedded rules correctly.
	See <http://lists.gnu.org/archive/html/bug-bison/2003-01/msg00076.html>.

	* data/glr.c (b4_rhs_value): Change to use YYFILL macro.
	(b4_rhs_location): Ditto.
	(yyfill): New function to copy from stack tree into array
	incrementally.
	(yyuserAction): Modify to allow incremental move of semantic values
	to rhs array when in GLR mode.
	Define YYFILL to use in user-defined actions to fill semantic array
	as needed.
	Remove dummy use of yystack, as there is now a guaranteed use.
	(yydoAction): Modify to allow incremental move of semantic values
	to rhs array when in GLR mode.
	(yyresolveAction): Ditto.
	(yyglrShiftDefer): Update comment.
	(yyresolveStates): Use X == NULL for pointers, not !X.
	(yyglrReduce): Ditto.
	(yydoAction): Ditto

	* tests/glr-regr1.at: Rename to ...
	* tests/glr-regression.at: Add new regression test for the problems
	described above (adapted from S. Eken).
	Update copyright notice.
	* tests/testsuite.at: Rename glr-regr1.at to glr-regression.at.
	* tests/Makefile.am: Ditto.

2003-01-28  Paul Eggert  <eggert@twinsun.com>

	* data/lalr1.cc: Do not use @output_header_name@ unless
	b4_defines_flag is set.  This fixes two bugs reported by
	Tim Van Holder in
	<http://lists.gnu.org/archive/html/bug-bison/2003-01/msg00071.html>
	and <http://lists.gnu.org/archive/html/bug-bison/2003-01/msg00073.html>.

2003-01-21  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c (YYERROR): Move code from yyerrlab1 to here, so that
	we don't need to worry about yyerrlab1 being reported as an
	"unused label" by non-GCC C compilers.  The downside is that if
	locations are used then a couple of statements are duplicated each
	time YYERROR is invoked, but the upside is that the warnings
	should vanish.
	(yyerrlab1): Move code to YERROR.
	(yyerrlab2): Remove.  Change uses back to yyerrlab1.
	This reverts some of the 2002-12-27 change.

2003-01-17  Paul Eggert  <eggert@twinsun.com>

	* src/output.c (symbol_printers_output): Fix typo that led
	to core dump.  Problem reported by Antonio Rus in
	<http://lists.gnu.org/archive/html/bug-bison/2003-01/msg00058.html>.

2003-01-13  Akim Demaille  <akim@epita.fr>,
		Quoc Peyrot <chojin@lrde.epita.fr>,
		Robert Anisko <anisko_r@lrde.epita.fr>

	* data/lalr1.cc (parse::yyerrlab1): When popping the stack, stop
	when the stacks contain one element, as the loop would otherwise
	free the last state, and then use the top state (the one we just
	popped).  This means that the initial elements will not be freed
	explicitly, as is the case in yacc.c; it is not a problem, as
	these elements have fake values.

2003-01-11  Paul Eggert  <eggert@twinsun.com>

	* NEWS: %expect-violations are now just warnings, reverting
	to Bison 1.30 and 1.75 behavior.  This fixes the GCC 3.2
	bootstrapping problem reported by Matthias Klose; see
	<http://lists.gnu.org/archive/html/bug-bison/2003-01/msg00053.html>.
	* src/conflicts.c (conflicts_print): Likewise.
	* tests/conflicts.at (%expect not enough, %expect too much,
	%expect with reduce conflicts): Likewise.
	* doc/bison.texinfo (Expect Decl): Document this.  Also mention
	that the warning is enabled if the number of conflicts changes
	(not necessarily increases).

	* src/getargs.c (version): Update copyright year.

2003-01-09  Akim Demaille  <akim@epita.fr>

	* src/Makefile.am, lib/Makefile.am: Use $(VAR) instead of @VAR@.

2003-01-08  Paul Eggert  <eggert@twinsun.com>

	* Makefile.maint (WGETFLAGS):
	New macro, containing "-C off" to disable proxy caches.
	All uses of $(WGET) changed to $(WGET) $(WGETFLAGS).
	(rel-check): Use $(WGET) instead of wget.

2003-01-06  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo (Generalized LR Parsing): Add a reference to
	the GLR paper of Scott, Johnstone and Hussain.

2003-01-04  Paul Eggert  <eggert@twinsun.com>

	* configure.ac (AC_ARG_ENABLE): Add --disable-yacc.
	(YACC_SCRIPT, YACC_LIBRARY): New vars to AC_SUBST.
	* lib/Makefile.am (lib_LIBRARIES): liby.a -> @YACC_LIBRARY@.
	(EXTRA_LIBRARIES): New var, for liby.a.
	* src/Makefile.am (bin_SCRIPTS): yacc -> @YACC_SCRIPT@.
	(EXTRA_SCRIPTS): New var, for yacc.

	* data/yacc.c (yyerrlab1): Omit attribute if __cplusplus is defined,
	since GNU C++ (as of 3.2.1) does not allow attributes on labels.
	Problem reported by Nelson H. F. Beebe.

2003-01-03  Paul Eggert  <eggert@twinsun.com>

	* lib/obstack.h (__INT_TO_PTR) [__STDC__]: Cast result to
	(void *) to avoid diagnostic with native c89 on SGI IRIX 6.5
	when compiling Bison 1.875's `bitset bset = obstack_alloc
	(bobstack, bytes);'.  Problem reported by Nelson H. F. Beebe.

	* src/scan-skel.l (QPUTS): Omit redundant `;' from macro definition.
	([^@\n]): Renamed from [^@\n]+ so that the token buffer does not
	grow to a huge size with typical invocation.

	* lib/hash.c (_Bool, bool, false, true, __bool_true_false_are_defined):
	Use the pattern recommended by Autoconf 2.57, except also protect
	against double-definition.
	* src/system.h: Likewise.
	Portability issues reported by Nelson H. F. Beebe.

	* data/glr.c (yybool): Renamed from bool, to avoid collisions in C.
	All uses changed.  Provide a definition in both C and C++.
	(yytrue, yyfalse): Define even if defined (__cplusplus).

	* lib/bitset_stats.c (bitset_stats_list): Remove unused var.
	Reported by Nelson H. F. Beebe.

	* src/scan-skel.l ("@oline@"): Output lineno+1, not lineno.

2003-01-02  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c (yyerrlab1): Append `;' after attribute, to
	pacify the buggy "smart preprocessor" in MacOS 10.2.3.
	Bug reported by Nelson H. F. Beebe.

2003-01-01  Paul Eggert  <eggert@twinsun.com>

	* Version 1.875.

2002-12-30  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l (<INITIAL,SC_AFTER_IDENTIFIER,SC_PRE_CODE>","):
	Moved here from...
	(<INITIAL>","): Here.  This causes stray "," to be treated
	more uniformly.

	* src/scan-gram.l (<SC_BRACED_CODE>"}"): Output ";" before the
	last brace in braced code when not in Yacc mode, for compatibility
	with Bison 1.35.  This resurrects the 2001-12-15 patch to
	src/reader.c.

	* src/reader.h (YYDECL): Use YYSTYPE, not its deprecated alias
	yystype.  This follows up the 2002-12-24 YYSTYPE bug fix.

2002-12-28  Paul Eggert  <eggert@twinsun.com>

	* src/symtab.c (symbol_make_alias): Set type of SYMVAL to be
	that of SYM's type.  This fixes Debian bug 168069, reported by
	Thomas Olsson.

2002-12-28  Paul Eggert  <eggert@twinsun.com>

	Version 1.75f.

	Switch back to the Yacc style of conflict reports, undoing some
	of the 2002-07-30 change.
	* doc/bison.texinfo (Understanding): Use Yacc style for
	conflict reports.  Also, use new way of locating rules.
	* src/conflicts.c (conflict_report):
	Renamed from conflict_report_yacc, removing the old
	'conflict_report'.  Translate the entire conflict report at once,
	so that we don't assume that "," has the same interpretation in
	all languages.
	(conflicts_output): Use Yacc-style conflict report for each state,
	instead of our more-complicated style.
	(conflicts_print): Use Yacc-style conflict report, except print
	the input file name when not emulating Yacc.
	* tests/conflicts.at (Unresolved SR Conflicts, Defaulted
	Conflicted Reduction, %expect not enough, %expect too much,
	%expect with reduce conflicts): Switch to Yacc-style conflict reports.
	* tests/existing.at (GNU Cim Grammar): Likewise.
	* tests/glr-regr1.at (Badly Collapsed GLR States): Likewise.

	* src/complain.c (warn_at, warn, complain_at, complain, fatal_at,
	fatal): Don't invoke fflush; it's not needed and it might even be
	harmful for stdout, as stdout might not be open.
	* src/reduce.c (reduce_print): Likewise.

2002-12-27  Paul Eggert  <eggert@twinsun.com>

	Fix a bug where error locations were not being recorded correctly.
	This problem was originally reported by Paul Hilfinger in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00086.html>.

	* data/yacc.c (yyparse): New local var yylerrsp, to record the
	top of the location stack's error locations.
	(yyerrlab): Set it.  When discarding a token, push its location
	onto yylerrsp so that we don't lose track of the error's end.
	(yyerrlab1): Now is only the target of YYERROR, so that we can
	properly record the location of the action that failed.  For GCC
	2.93 and later, insert an __attribute__ ((__unused__)) to avoid
	GCC warning about yyerrlab1 being unused if YYERROR is unused.
	(yyerrlab2): New label, which yyerrlab now falls through to.
	Compute the error's location by applying YYLLOC_DEFAULT to
	the locations of all the symbols that went into the error.
	* doc/bison.texinfo (Location Default Action): Mention that
	YYLLOC_DEFAULT is also invoked for syntax errors.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR):
	Error locations include the locations of all the tokens that were
	discarded, not just the last token.

2002-12-26  Paul Eggert  <eggert@twinsun.com>

	* src/files.c: Include quote.h.
	(compute_output_file_names): Warn if we detect conflicting
	outputs to the same file.  This should catch the misunderstanding
	exemplified by Debian Bug 165349, reported by Bruce Stephens..

	* src/conflicts.c (conflicts_print): If the user specifies
	"%expect N", report an error if there are any reduce/reduce
	conflicts.  This is what the manual says should happen.
	This fixes Debian bug 130890, reported by Anthony DeRobertis.
	* tests/conflicts.at (%expect with reduce conflicts): New test.

	Don't use m4_include on relative file names, as it doesn't work as
	desired if there happens to be a file with that name under ".".

	* m4sugar/version.m4: Remove; it was included but it wasn't used.
	* data/Makefile.am (dist_m4sugar_DATA): Remove m4sugar/version.m4.
	* data/m4sugar/m4sugar.m4: Don't include m4sugar/version.m4.
	* data/glr.c, data/lalr1.cc, data/yacc.c: Don't include c.m4.
	* src/output.c (output_skeleton): Use full path names when
	specifying a file to include; don't rely on include path, as
	it's unreliable when the working file contains a file with
	that name.

2002-12-25  Paul Eggert  <eggert@twinsun.com>

	Remove obsolete references to bison.simple and bison.hairy.
	Problem mentioned by Aubin Mahe in
	<http://lists.gnu.org/archive/html/help-bison/2002-12/msg00010.html>.
	* data/glr.c: Comment fix.
	* doc/bison.1: Remove references.  Also, mention "yacc".

	* src/getargs.c (getargs) [MSDOS]: Don't assume optarg != NULL
	with -g option.

	* src/parse-gram.y (declaration): Use enum "report_states" rather
	than its numeric value 1.

	* src/scan-skel.l ("@output ".*\n): Close any old yyout before
	opening a new one.  This fixes Debian bug 165349, reported by
	Bruce Stephens.

2002-12-24  Paul Eggert  <eggert@twinsun.com>

	Version 1.75e.

	* Makefile.maint (cvs-update): Don't assume that the shell
	supports $(...), as Solaris sh doesn't.

	* src/parse-gram.y (lloc_default): Remove test for empty
	nonterminals at the end, since it didn't change the result.

2002-12-24  Paul Eggert  <eggert@twinsun.com>

	If the user does not define YYSTYPE as a macro, Bison now declares it
	using typedef instead of defining it as a macro.  POSIX requires this.
	For consistency, YYLTYPE is also declared instead of defined.

	%union directives can now have a tag before the `{', e.g., the
	directive `%union foo {...}' now generates the C code
	`typedef union foo { ... } YYSTYPE;'; this is for Yacc compatibility.
	The default union tag is `YYSTYPE', for compatibility with Solaris 9
	Yacc.  For consistency, YYLTYPE's struct tag is now `YYLTYPE'
	instead of `yyltype'.

	`yystype' and `yyltype' are now obsolescent macros instead of being
	typedefs or tags; they are no longer documented and will be
	withdrawn in a future release.

	* data/glr.c (b4_location_type): Remove.
	(YYSTYPE): Renamed from yystype.
	(YYSTYPE_IS_DECLARED): New macro, used to prevent double-typedef.
	(struct YYLTYPE): Renamed from struct yyltype.
	(YYLTYPE): Renamed from yyltype.
	(yyltype, yystype): New (and obsolescent) macros,
	for backward compatibility.
	* data/yacc.c: Likewise.

	* data/yacc.c (YYSTYPE): Declare as union YYSTYPE if the user
	does not specify a union tag.  This is for compatibility with
	Solaris 9 yacc.

	* src/parse-gram.y (add_param): 2nd arg is now char * not char
	const *, since it is now modified by stripping surrounding { }.
	(current_braced_code): Remove.
	(PERCENT_DESTRUCTOR, PERCENT_PRINTER, PERCENT_UNION,
	PERCENT_LEX_PARAM, PERCENT_PARSE_PARAM): Change names to include
	trailing " {...}".  Now of type <chars>.
	(grammar_declaration): Adjust to bundled tokens.
	(code_content): Remove; stripping is now done by add_param.
	(print_token_value): Print contents of bundled tokens.
	(token_name): New function.

	* src/reader.h (braced_code, current_braced_code): Remove.
	(token_name): New decl.

	* src/scan-gram.l (handle_dollar, handle_at): Now takes int
	token_type, not braced_code code_kind.  All uses changed.
	(SC_PRE_CODE): New state, for scanning after a keyword that
	has (or usually has) an immediately-following braced code.
	(token_type): New local var, to keep track of which token type
	to return when scanning braced code.
	(<INITIAL>"%destructor", <INITIAL>"%lex-param",
	<INITIAL>"%parse-param", <INITIAL>"%printer",
	<INITIAL>"%union"): Set token type and BEGIN SC_PRE_CODE
	instead of returning a token type immediately.
	(<INITIAL>"{"): Set token type.
	(<SC_BRACED_CODE>"}"): Use it.
	(handle_action_dollar, handle_action_at): Now returns bool
	indicating success.  Fail if ! current_rule; this prevents a core dump.
	(handle_symbol_code_dollar, handle_symbol_code_at):
	Remove; merge body into caller.
	(handle_dollar, handle_at): Complain in invalid contexts.

	* NEWS, doc/bison.texinfo: Document the above.
	* NEWS: Fix years and program names in copyright notice.

2002-12-17  Paul Eggert  <eggert@twinsun.com>

	* NEWS, doc/bison.texinfo (Parser Function, Pure Calling, Error
	Reporting, Table of Symbols): Omit mentions of %lex-param and
	%parse-param from the documentation for now.

2002-12-15  Paul Eggert  <eggert@twinsun.com>

	Undo most of the 2002-11-12 yychar -> yytoken patch, as it broke
	GCC 3.2.1 (which depends on yychar == YYEMPTY when there is no
	lookahead symbol, and which sets yychar in parser actions) and it
	disagreed with the Bison documentation.  Bug
	reported by Andrew Walrond.

	* data/yacc.c (YYTRANSLATE): Don't check for negative argument,
	as the caller now does that.
	(yyclearin, YYBACKUP, yyparse): Use yychar, not yytoken.
	(YYEMPTY): Parenthesize right hand side, since others use it.
	(yyparse): Don't assume that our generated code is the only code
	that sets yychar.

2002-12-13  Paul Eggert  <eggert@twinsun.com>

	Version 1.75d.

	POSIX requires a "yacc" command.
	* src/Makefile.am (bin_SCRIPTS): New macro, for yacc.
	(MOSTLYCLEANFILES): Add yacc.
	(yacc): New rule.
	* doc/bison.texinfo (Invocation, Bison Options): Mention yacc
	as an alias for bison y.

	* po/LINGUAS: Add da.

	* src/getargs.c (__GNU_LIBRARY__) [lint]: Define to work around
	problem with latest <getopt.h>.
	(HACK_FOR___GNU_LIBRARY___PROTOTYPE): New macro.

	* doc/fdl.texi: Upgrade to 1.2.
	* lib/alloca.c, lib/error.c, lib/getopt.c, lib/getopt.h
	lib/getopt1.c, lib/gettext.h, lib/memrchr.c, lib/obstack.c,
	lib/obstack.h, lib/strnlen.c, lib/unlocked-io.h: Sync with
	gnulib.
	* config/install-sh: Sync with autotools.

	Fix a bad interaction with flex 2.5.23 reported by Bruce Lilly in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00114.html>.
	* data/yacc.c (YYLTYPE, struct yyltype): Do not define unless
	locations are requested.
	(union yyalloc): Do not depend on YYLTYPE_IS_TRIVIAL unless
	locations are requested.

2002-12-12  Paul Eggert  <eggert@twinsun.com>

	Remove unportable casts and storage allocation tricks.
	While we're at it, remove almost all casts, since they
	usually aren't needed and are a sign of trouble.

	* configure.ac (AC_CHECK_TYPES): Check for uintptr_t.

	* src/derives.c (derives_compute): Do not subtract NTOKENS from
	the pointer DSET returned by malloc; this isn't portable.
	Instead, always use DSET[i - NTOKENS] rather than DSET[i].
	Similarly for DERIVES.
	* src/lalr.c (set_goto_map): Likewise, for GOTO_MAP and TEMP_MAP.
	* src/nullable.c (nullable_compute): Likewise, for RSETS and NULLABLE.
	* src/reduce.c (reduce_grammar_tables): Likewise, for nontermmap

	* src/derives.c (derives_compute): Do not bother invoking
	int_of_rule_number, since rule numbers are integers.

	* src/files.c (concat2, tr, compute_base_name): Use xmalloc (N)
	rather than XMALLOC (char, N).

	* src/files.c (filename_split): Rewrite to avoid cast.

	* src/gram.h (symbol_number_as_item_number,
	item_number_as_symbol_number, rule_number_as_item_number,
	item_number_as_rule_number):
	Now inline functions rather than macros, to avoid casts.
	* src/state.h (state_number_as_int): Likewise.
	* src/tables.c (state_number_to_vector_number,
	symbol_number_to_vector_number): Likewise.

	* src/gram.h (int_of_rule_number): Remove; no longer used.

	* src/lalr.c (add_lookback_edge): Use malloc rather than calloc,
	since the resulting storage is always stored into.

	* src/main.c (alloca) [C_ALLOCA]: Add decl here, the only place
	where it's needed.

	* src/muscle_tab.c (muscle_m4_output):
	Now inline.  Return bool, not int.
	* src/state.c (state_compare): Likewise.
	* src/symtab.c (symbol_check_defined,
	symbol_check_alias_consistency, symbol_pack, symbol_translation,
	hash_compare_symbol, hash_symbol):
	Likewise.
	* src/uniqstr.c (uniqstr_print): Likewise.
	* src/muscle_tab.c (muscle_m4_output_processor):
	New function, to avoid casts.
	* src/state.c (state_comparator, stage_hasher): Likewise.
	* src/symtab.c (symbol_check_defined_processor,
	symbol_check_alias_consistency_processor, symbol_pack_processor,
	symbol_translation_processor, hash_symbol_comparator,
	hash_symbol_hasher): Likewise.
	* src/uniqstr.c (uniqstr_print_processor): Likewise.
	* src/muscle_tab.c (muscles_m4_output):
	Use new functions instead of casting old functions unportably.
	* src/state.c (state_hash_new): Likewise.
	* src/symtab.c (symbols_new, symbols_do, symbols_check_defined,
	symbols_token_translations_init):
	Likewise.
	* src/uniqstr.c (uniqstrs_new, hash_initialize, uniqstrs_do): Likewise.

	* src/output.c (GENERATE_MUSCLE_INSERT_TABLE): Use long local
	var instead of casting to long, to avoid casts.
	(prepare_states): Use MALLOC rather than alloca, so that we don't
	have to worry about alloca.
	* src/state.c (state_hash_lookup): Likewise.

	* src/scan-gram.l (<SC_ESCAPED_CHARACTER>"'"): Use unsigned char
	local var instead of casting to unsigned char, to avoid casts.

	* src/state.c (TRANSITIONS_ALLOC, ERRS_ALLOC, REDUCTIONS_ALLOC,
	STATE_ALLOC): Remove.
	(transitions_new, errs_new, reductions_new, state_new): Use malloc
	rather than calloc, and use offsetof to avoid allocating slightly
	too much storage.
	(state_new): Initialize all members.

	* src/state.c (state_hash): Use unsigned accumulator, not signed.

	* src/symtab.c (symbol_free): Remove; unused.
	(symbol_get): Remove cast in lhs of assignment.
	(symbols_do): Now static.  Accept generic arguments, not
	hashing-related ones.

	* src/symtab.h: (NUMBER_UNDEFINED): Remove unnecessary cast.
	(symbol_processor): Remove.
	(symbols_do): Remove decl; now static.

	* src/system.h (alloca): Remove; decl no longer needed.
	(<stddef.h>): Include, for offsetof.
	(<inttypes.>, <stdint.h>): Include if available.
	(uintptr_t): New type, if system lacks it.
	(CALLOC, MALLOC, REALLOC): New macros.
	All uses of XCALLOC, XMALLOC, and XREALLOC changed to use these
	new macros.

	* src/tables.c (table_size): Now int, to pacify GCC.
	(table_grow, table_ninf_remap): Use signed table size.
	(save_row): Don't bother initializing locals when not needed.
	(default_goto, goto_actions, pack_vector): Remove unnecessary casts.
	* src/uniqstr.c (hash_compare_uniqstr):  Likewise.

	* src/vcg.h: Correct misspellings.

	* src/vcg_defaults.h (G_CMAX): Now INT_MAX.


	* src/getargs.c (getargs): Don't assume EOF == -1.

2002-12-09  Paul Eggert  <eggert@twinsun.com>

	Change identifier spellings to avoid collisions with names
	that are reserved by POSIX.

	Don't use names ending in _t, since POSIX reserves them.
	For consistency, remove _e and _s endings -- they're weren't
	needed to remove ambiguity.  All uses changed.
	* src/uniqstr.h (uniqstr): Renamed from uniqstr_t, which in
	turn was just renamed from struniq_t.
	* src/uniqstr.c (uniqstr_processor): Renamed from struniq_processor,
	which in turn was just renamed from struniq_processor_t.
	(hash_compare_uniqstr): Renamed from hash_compare_struniq, which
	in turn was renamed from hash_compare_struniq_t.
	* src/LR0.c (struct state_list): Renamed from struct state_list_s.
	(state_list): Renamed from state_list_t.
	* src/assoc.h (assoc): Renamed from assoc_t.
	* src/conflicts.c (enum conflict_resolution): Renamed from
	enum conflict_resolution_e.
	* src/derives.c (struct rule_list): Renamed from struct rule_list_s.
	(rule_list): Renamed from rule_list_t.
	* src/getargs.h (enum trace): Renamed from enum trace_e.
	(enum report): Renamed from enum report_e.
	* src/gram.h (item_number): Renamed from item_number_t.
	(rule_number): Renamed from rule_number_t.
	(struct rule_s): Remove the "rule_s" part; not used.
	(rule): Renamed from rule_t.
	(rule_filter): Renamed from rule_filter_t.
	* src/lalr.c (struct goto_list): Renamed from struct goto_list_s.
	(goto_list): Renamed from goto_list_t.
	* src/lalr.h (goto_number): Renamed from goto_number_t.
	* src/location.h (location): Renamed from location_t.
	* src/muscle_tab.c (muscle_entry): Renamed from muscle_entry_t,
	and moved here from:
	* src/muscle_tab.h (muscle_entry_t): here.
	* src/nullable.c (struct rule_list): Renamed from struct rule_list_s.
	(rule_list): Renamed from rule_list_t.
	* src/print_graph.c (static_graph): Renamed from graph.
	* src/reader.h (braced_code): Renamed from braced_code_t.
	Remove brace_code_e tag.
	* src/relation.h (relation_node): Renamed from relation_node_t.
	(relation_nodes): Renamed from relation_nodes_t.
	(relation): Renamed from relation_t.
	* src/state.h (state_number): Renamed from state_number_t.
	(struct state): Renamed from struct state_s.
	(state): Renamed from state_t.
	(transitions): Renamed from transitions_t.  Unused (and
	misspelled) transtion_s tag removed.
	(errs): Renamed from errs_t.  Unused errs_s tag removed.
	(reductions): Renamed from reductions_t.  Unused tag
	reductions_s removed.
	* src/symlist.h (symbol_list): Renamed from symbol_list_t.
	(struct symbol_list): Renamed from struct symbol_list_s.
	* src/symtab.h (symbol_number): Renamed from symbol_number_t.
	(struct symbol): Renamed from struct symbol_s.
	(symbol): Renamed from symbol_t.
	* src/tables.c (vector_number): Renamed from vector_number_t.
	(action_number): Renamed from action_t.
	* src/tables.h (base_number): Renamed from base_t.
	* src/vcg.h (enum color): Renamed from enum color_e.
	(enum textmode): Renamed from enum textmode_e.
	(enum shape): Renamed from enum shape_e.
	(struct colorentry): Renamed from struct colorentry_s.
	(struct classname): Renamed from struct classname_s.
	(struct infoname): Renamed from struct infoname_s.
	(enum layoutalgorithm): Renamed from enum layoutalgorithm_e.
	(enum decision): Renamed from enum decision_e.
	(enum orientation): Renamed from enum orientation_e.
	(enum alignment): Renamed from enum alignment_e.
	(enum arrow_mode): Renamed from enum arrow_mode_e.
	(enum crossing_type): Renamed from enum crossing_type_e.
	(enum view): Renamed from enum view_e.
	(struct node): Renamed from struct node_s.
	(node): Renamed from node_t.
	(enum linestyle): Renamed from enum linestyle_e.
	(enum arrowstyle): Renamed from enum arrowstyle_e.
	(struct edge): Renamed from struct edge.
	(edge): Renamed from edge_t.
	(struct graph): Renamed from struct graph_s.
	(graph): Renamed from graph_t.
	* tests/calc.at (_AT_DATA_CALC_Y, Simple LALR Calculator):
	Rename value_t -> value.
	* tests/input.at (Torturing the Scanner): Rename value_t -> value,
	value_t_as_yystype -> value_as_yystype.

	Don't include <errno.h> in the mainstream code, since it
	reserves E[A-Z0-9]* and we want to use symbols like 'EQUALS'.
	* lib/get-errno.c, lib/get-errno.h: New files.
	* lib/Makefile.am (libbison_a_SOURCES): Add get-errno.h,
	get-errno.c.
	* src/files.c (xfopen, xfclose): Use get_errno instead of errno.
	* src/output.c (output_skeleton): Likewise.
	* src/scan-gram.l (<INITIAL>{int}): Use set_errno and get_errno
	instead of errno.
	(<SC_ESCAPED_STRING,SC_ESCAPED_CHARACTER>\\x[0-9abcdefABCDEF]+):
	Likewise.
	(handle_action_dollar, handle_action_at): Likewise.
	* src/system.h: Do not include <errno.h>.
	(TAB_EXT): Renamed from EXT_TAB.
	(OUTPUT_EXT): Renamed from EXT_OUTPUT.

	Avoid str[a-z]*, since <string.h> reserves that name space.
	Change all instances of "struniq" in names to "uniqstr", and
	likewise for "STRUNIQ" and "UNIQSTR".
	* src/uniqstr.c: Renamed from src/struniq.c.
	* src/uniqstr.h: Renamed from src/struniq.h.
	* src/Makefile.am (bison_SOURCES): Adjust to these renamings.
	* src/files.c (strsuffix): Remove; unused.
	(concat2): Renamed from stringappend.  Now static.
	* src/files.h (strsuffix, stringappend): Remove; unused.
	* src/parse-gram.y (<chars>): Renamed from <string>.
	(<uniqstr>): Renamed from <struniq>.
	* src/scan-gram.l (obstack_for_string): Renamed from string_obstack.
	* src/vcg.h (struct node_s.expand): Renamed from struct node_s.stretch.
	(struct graph_s.expand): Renamed from struct graph_s.stretch.
	* src/vcg_defaults.h (G_EXPAND): Renamed from G_STRETCH.
	(G_LONG_STRAIGHT_PHASE): Renamed from G_STRAIGHT_PHASE.
	(N_EXPAND): Renamed from N_STRETCH.

	Avoid *_MAX and *_MIN, since <limits.h> reserves that name space.
	* data/yacc.c (YYSTACK_GAP_MAXIMUM): Renamed from YYSTACK_GAP_MAX.
	* src/gram.h (ITEM_NUMBER_MAX, ITEM_NUMBER_MIN, RULE_NUMBER_MAX):
	Remove; unused.
	* src/lalr.h (GOTO_NUMBER_MAXIMUM): Renamed from GOTO_NUMBER_MAX.
	* src/state.h (STATE_NUMBER_MAXIMUM): Renamed from STATE_NUMBER_MAX.
	* src/symtab.h (SYMBOL_NUMBER_MAXIMUM): Renamed from SYMBOL_NUMBER_MAX.
	* src/tables.c (VECTOR_NUMBER_MAX, VECTOR_NUMBER_MIN): Remove; unused.
	(BASE_MAXIMUM): Renamed from BASE_MAX.
	(BASE_MINIMUM): Renamed from BASE_MIN.
	(ACTION_MAX): Remove; unused.
	(ACTION_NUMBER_MINIMUM): Renamed from ACTION_MIN.
	Unnecessary casts removed from above defines.


	Fix misspelling in names.
	* src/vcg.h (enum_alignment_e): Renamed from enum_alignement_e.
	* src/vcg_defaults.h (G_NODE_ALIGNMENT): Renamed from
	G_NODE_ALIGNEMENT.


	* lib/timevar.c (timevar_report): Renamed from time_report,
	for consistency with other names.
	* lib/timevar.h (timevar_report): New decl.
	* src/system.h (time_report): Remove; decl is now in lib/timevar.h.


	Sort include-file uses.

	Reorder all include files under src to be in the order "system.h".
	then the ../lib include files in angle brackets (alphabetized),
	then the . include files in double-quotes (alphabetized).  Fix
	dependency breakages encountered in this process, as follows:
	* src/closure.h, src/derives.h, src/state.h: Include "gram.h".
	* src/complain.c: Don't include stdlib.h, string.h _LIBC stuff.
	* src/state.h: Include "symtab.h".

2002-12-08  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c, data/lalr1.cc, data/yacc.c: Do not use __file__,
	since this causes problems when __file__ contains character
	sequences like "@" that are treated specially by src/scan-skel.l.
	Instead, just use the file's basename.  This fixes the bug
	reported by Martin Mokrejs in
	<http://lists.gnu.org/archive/html/bug-bison/2002-12/msg00007.html>.

2002-12-06  Paul Eggert  <eggert@twinsun.com>

	Add support for rules that do not have trailing semicolons, as
	POSIX requires.  Improve the quality of locations in Bison
	diagnostics.

	* src/location.c: Include <quotearg.h>.
	(empty_location): Now const.
	(location_print): New function.  Follow the recommendation of the
	GNU Coding Standards for locations that span file boundaries.
	* src/location.h: Do not include <quotearg.h>; no longer needed.
	(boundary): New type.
	(location_t): Use it.  This allows locations to span file boundaries.
	All member uses changed: file -> start.file or end.file (as needed),
	first_line -> start.line, first_column -> start.column,
	last_line -> end.line, last_column -> end.column.
	(equal_boundaries): New function.
	(LOCATION_RESET, LOCATION_STEP): Remove.
	(LOCATION_PRINT): Remove.  All callers changed to use location_print.
	(empty_location): Now const.
	(location_print): New decl.
	* src/parse-gram.y (lloc_default): New function, which handles
	empty locations more accurately.
	(YYLLOC_DEFAULT): Use it.
	(%token COLON): Remove.
	(%token ID_COLON): New token.
	(rules): Use it.
	(declarations, rules): Remove trailing semicolon.
	(declaration, rules_or_grammar_declaration):
	Allow empty (";") declaration.
	(symbol_def): Remove empty actions; no longer needed.
	(rules_or_grammar_declaration): Remove trailing semicolon.
	(semi_colon.opt): Remove.
	* src/reader.h: Include location.h.
	(scanner_cursor): New decl.
	* src/reduce.c (nonterminals_reduce): Use warn_at rather than
	rolling our own.
	* src/scan-gram.l (YY_USER_INIT): Initialize scanner_cursor instead
	of *loc.
	(STEP): Remove.  No longer needed, now that adjust_location does
	the work.  All uses removed.
	(scanner_cursor): New var.
	(adjust_location): Renamed from extend_location.  It now sets
	*loc and adjusts the scanner cursor.  All uses changed.
	Don't bother testing for CR.
	(handle_syncline): Remove location arg; now updates scanner cursor.
	All callers changed.
	(unexpected_end_of_file): Now accepts start boundary of token or
	comment, not location.  All callers changed.  Update scanner cursor,
	not the location.
	(SC_AFTER_IDENTIFIER): New state.
	(context_state): Renamed from c_context.  All uses changed.
	(id_loc, code_start, token_start): New local vars.
	(<INITIAL,SC_AFTER_IDENTIFIER>): New initial context.  Move all
	processing of Yacc white space and equivalents here.
	(<INITIAL>{id}): Save id_loc.  Begin state SC_AFTER_IDENTIFIER
	instead of returning ID immediately, since we need to search for
	a subsequent colon.
	(<INITIAL>"'", "\""): Save token_start.
	(<INITIAL>"%{", "{", "%%"): Save code_start.
	(<SC_AFTER_IDENTIFIER>): New state, looking for a colon.
	(<SC_YACC_COMMENT>, <SC_COMMENT>, <SC_LINE_COMMENT>):
	BEGIN context_state at end, not INITIAL.
	(<SC_ESCAPED_STRING>"\"", <SC_ESCAPED_CHARACTER>"'",
	<SC_BRACED_CODE>"}", <SC_PROLOGUE>"%}", <SC_EPILOGUE><<EOF>>):
	Return correct token start.
	(<SC_BRACED_CODE,SC_PROLOGUE,SC_EPILOGUE>): Save start boundary when
	the start of a character, string or multiline comment is found.
	* tests/conflicts.at (S/R in initial, Defaulted Conflicted
	Reduction): Adjust reported locations to match the more-precise
	results now expected.
	* tests/input.at (Invalid $n, Invalid @n, Type Clashes): Likewise.
	* tests/reduce.at (Useless Rules, Reduced Automaton,
	Underivable Rules): Likewise.
	* tests/regression.at (Invalid inputs): No longer `expecting ";"
	or "|"' now that so many other tokens are allowed by the new grammar.

	* src/complain.h (current_file): Remove duplicate decl;
	current_file is now owned by files.h.
	* src/complain.c, src/scan-gram.l: Include files.h.

2002-12-06  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yy_reduce_print): Don't assume that yyrline[yyrule]
	promotes to int; it might be unsigned int.
	* data/yacc.c (yy_reduce_print): Likewise.

	* doc/bison.texinfo (Table of Symbols): YYERROR_VERBOSE should
	be #defined in the prologue, not in the Bison declarations.
	This fixes Debian Bug 102878, reported by Shaul Karl.

2002-12-02  Paul Eggert  <eggert@twinsun.com>

	* configure.ac (AC_REPLACE_FUNCS): Add strtoul.
	* lib/strtoul.c: New file, from gnulib.
	This fixes a porting bug reported by Peter Klein in
	<http://lists.gnu.org/archive/html/bug-bison/2002-12/msg00000.html>.

2002-11-30  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l (no_cr_read, extend_location): Move to epilogue,
	and put only a forward declaration in the prologue.  This is for
	consistency with the other scanner helper functions.

	Type clashes now generate warnings, not errors, since it
	appears that POSIX may allow some grammars with type clashes.
	* src/reader.c (grammar_current_rule_check): Warn about
	type clashes instead of complaining.
	* tests/input.at (Type Clashes): Expect warnings, not complaints.

	Add Yacc library, since POSIX requires it.
	* doc/bison.texinfo (Yacc Library): New node.  Regenerate top menu.
	* lib/Makefile.am (lib_LIBRARIES, liby_a_SOURCES): New macros.
	* lib/main.c, lib/yyerror.c: New files.

	gram_error can be static; it need not be extern.
	* src/reader.h (gram_error): Remove decl.
	* src/parse-gram.y (gram_error): Now static.  Add static decl.
	(print_token_value): Omit parameter names from forward decl,
	for consistency.

2002-11-29  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo: Emphasize that yylex and yyerror must
	be declared before being used.  E.g., one should typically
	declare them in the prologue.  Use GNU coding style in examples.
	Put "const" consistently after the type it modifies.  Mention
	that C99 supports "inline".  Mention that yyerror traditionally
	returns "int".

	%parse-param and %lex-param now take just one argument, the
	declaration; the argument name is deduced from the declaration.

	* doc/bison.texinfo (Parser Function, Pure Calling, Error
	Reporting, Table of Symbols): Document this.
	* src/parse-gram.y (add_param): New function.
	(COMMA): Remove.
	(declaration): Implement new rule for %parse-param and %lex-param.
	* src/scan-gram.l: "," now elicits a warning, rather than being
	a token; this is more compatible with byacc.
	* tests/calc.at (Simple LALR Calculator): Adopt new convention.

2002-11-27  Paul Eggert  <eggert@twinsun.com>

	Rename identifiers to avoid real and potential collisions.

	* data/c.m4 (b4_yysymprint_generate): yyout -> yyoutput,
	to avoid collision with lex macro described by Bruce Lilly in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00114.html>.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Likewise.
	* doc/bison.texinfo (Prologue, Tracing): yyprint -> print_token_value.
	* src/parse-gram.y (print_token_value): Renamed from yyprint.
	All uses changed.
	(YYPARSE_PARAM, YYLEX_PARAM, yycontrol): Remove.  All uses changed.
	The name "yycontrol" violates the name space rules, and this stuff
	wasn't being used anyway.
	(input): Remove action; this stuff wasn't being used.
	(gram_error): Rename local variable yylloc -> loc.
	* src/reader.h (struct gram_control_s, gram_control_t): Remove.
	(YY_DECL): Don't use "yy" at start of local variables.
	All uses changed, e.g., yylloc -> loc.
	* src/scan-gram.l (STEP): Renamed from YY_STEP.  All uses changed.
	(STRING_GROW): Renamed from YY_OBS_GROW.  All uses changed.
	(STRING_FINISH): Renamed from YY_OBS_FINISH.  All uses changed.
	(STRING_FREE): Renamed from YY_OBS_FREE.  All uses changed.

	* src/parse-gram.y (gram_error): loc is now const *.
	* src/reader.h (gram_error): Likewise.

2002-11-24  Paul Eggert  <eggert@twinsun.com>

	Version 1.75c.

	* tests/actions.at (Actions after errors): Use an output format
	more similar to that of the Printers and Destructors test.
	Test the position of the ';' token too.
	(Printers and Destructors): Likewise.
	(Printers and Destructors: %glr-parser): Remove for now, to avoid
	unnecessarily alarming people when the test fails.

	* data/yacc.c (yyerrlab1): Move this label down, so that the
	parser does not discard the lookahead token if the user code
	invokes YYERROR.  This change is required for POSIX conformance.

	* lib/error.c: Sync with gnulib.

2002-11-22  Paul Eggert  <eggert@twinsun.com>

	* lib/quotearg.c, lib/quotearg.h: Sync with gnulib.
	* lib/mbswidth.c, lib/mbswidth.h: Likewise.
	* lib/xmalloc.c: Likewise.

2002-11-20  Paul Eggert  <eggert@twinsun.com>

	* lib/argmatch.c, lib/argmatch.h: Sync with gnulib.

2002-11-20  Paul Eggert  <eggert@twinsun.com>

	Avoid use of <assert.h>, as the GNU Coding Standards hint that one
	should use `if (! x) abort ();' rather than `assert (x);', and
	anyway it's one less thing to worry about configuring.

	* data/glr.c, lib/hash.c, src/system.h: Do not include <assert.h>.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Likewise,
	and replace all instances of assert with abort.
	* tests/calc.at (_AT_DATA_CALC_Y): Likewise.
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Likewise.

	* data/glr.c (yydoAction, yyglrReduce, yysplitStack, yyresolveStates,
	yyresolveAction, yyprocessOneStack): Use abort rather than assert.
	* lib/hash.c (hash_lookup, hash_get_first, hash_get_next,
	hash_find_entry, hash_rehash, hash_insert): Likewise.
	* src/conflicts.c (resolve_sr_conflict): Likewise.
	* src/lalr.c (set_goto_map, map_goto): Likewise.
	* src/nullable.c (nullable_compute): Likewise.
	* src/output.c (prepare_rules, token_definitions_output): Likewise.
	* src/reader.c (packgram, reader): Likewise.
	* src/state.c (state_new, state_free, state_transitions_set,
	state_reduction_find): Likewise.
	* src/symtab.c (symbol_user_token_number_set, symbol_make_alias,
	symbol_pack): Likewise.
	* src/tables.c (conflict_row, pack_vector): Likewise.
	* src/vcg.c (get_color_str, get_textmode_str, get_shape_str,
	get_layoutalgorithm_str, get_decision_str, get_orientation_str,
	get_node_alignement_str, get_arrow_mode_str, get_crossing_type_str,
	get_view_str, get_linestyle_str, get_arrowstyle_str): Likewise.

	* lib/argmatch.h (ARRAY_CARDINALITY): Do not bother to #undef.
	(ARGMATCH_CONSTRAINT): New macro.
	(ARGMATCH_ASSERT): Use it.

	* src/system.h (verify): New macro.
	* src/getargs.c (trace_argmatch, report_argmatch): Use verify
	rather than assert.
	* src/tables.c (tables_generate): Likewise.

	* src/struniq.c (struniq_assert): Now returns void, and aborts
	if the assertion is false.
	(struniq_assert_p): Remove.
	* src/struniq.h: Likewise.

2002-11-18  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yygetLRActions): Replace `yyindex' with
	`yytable[yyindex]' to fix typo introduced in my 2002-11-09 patch.
	This fixes the regression with Sun ONE Studio 7 cc that I reported in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00077.html>.

2002-11-18  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Tracing): `yyprint' shouldn't prepend a
	space.
	From Tim Van Holder.

2002-11-17  Paul Eggert  <eggert@twinsun.com>

	Pacify Sun ONE Studio 7 lint.  Also, rename "ParseError"
	to "SyntaxError" for consistency with my 2002-11-15 change.

	* data/glr.c (YYDPRINTF, YYDSYMPRINT, YYDSYMPRINTF) [!YYDEBUG]: Do
	not define to {}, since this breaks the common use of `YYDPRINTF
	((...));' if a single statement is desired (e.g. before `else').
	Work around GCC warnings by surrounding corresponding calls with
	{} if needed.
	(yyhasResolvedValue): Remove unused function.
	(yymergeOptionSets, yyresolvStack): Use `continue;' for empty
	loop body.
	(yyreportSyntaxError): Renamed from yyreportParseError.
	(yyrecoverSyntaxError): Renamed from yyrecoverParseError.
	All uses changed.
	* tests/calc.at (_AT_DATA_CALC_Y): Make vars static instead of
	extern when possible.  Remove unused initializations.

2002-11-16  Akim Demaille  <akim@epita.fr>

	Augment the similarity between GLR and LALR traces.

	* data/yacc.c (yy_stack_print, YY_STACK_PRINT, yy_reduce_print)
	(YY_REDUCE_PRINT): New.
	(yyparse): Use them.
	* data/glr.c (yy_reduce_print): Use YYFPRINTF, no need for
	YYDPRINT here.
	(yyglrReduce, yyrecoverParseError, yyparse): Don't report the
	state reached after the reduction/recovery, since...
	(yyparse, yyprocessOneStack): Report the state we are entering in.

2002-11-16  Akim Demaille  <akim@epita.fr>

	* src/getargs.h, src/getargs.c (trace_e, trace_args, trace_types):
	Add support for --trace=skeleton.
	* src/scan-skel.l: %option debug.
	Scan strings of non-@ or \n instead of character by character.
	(scan_skel): Handle trace_skeleton.
	(QPUTS): New.
	(@output_parser_name@, @output_header_name@): ``Restore'' their
	support (used to be M4 macros).
	* data/yacc.c: Quote larger chunks, a la glr.c.
	* data/lalr1.cc: Likewise.
	The header guards are no longer available, so use some other
	string than `YYLSP_NEEDED'.

2002-11-16  Akim Demaille  <akim@epita.fr>

	Make the ``Printers and Destructors'' test more verbose, taking
	`yacc.c''s behavior as (possibly wrong) reference.

	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Use printf
	instead of fprint on stdout.
	Set and report the last_line of the symbols.
	Consistently display values and locations.

2002-11-16  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c: Avoid over-quoting of __line__ and __file__.

2002-11-15  Paul Eggert  <eggert@twinsun.com>

	* tests/actions.at (Actions after errors): New test case.

	* data/glr.c, data/lalr1.cc, data/yacc.cc, doc/bison.texinfo,
	src/conflicts.c, src/parse-gram.y, src/tables.c, src/tables.h,
	tests/action.at, tests/calc.at, tests/conflicts.at,
	tests/cxx-type.at, tests/regression.at:
	"parse error" -> "syntax error" for POSIX compatibility.
	"parsing stack overflow..." -> "parser stack overflow" so
	that code matches Bison documentation.

2002-11-15  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (declaration): Have %parse-param and %lex-param
	take two BRACED_CODE, not two string_content.
	Free the scanner's obstack when we are done.
	(code_content): New.
	* tests/calc.at: Adjust.
	* doc/bison.texinfo: Adjust.
	Also, make sure to include the `,' for these declarations.

2002-11-15  Tim Van Holder  <tim.van.holder@pandora.be>

	* m4/prereq.m4: Removed the commented jm_PREREQ_HASH
	definition; avoids potential autoreconf problems.

2002-11-15  Akim Demaille  <akim@epita.fr>

	Always check the value returned by yyparse.

	* tests/calc.at (_AT_DATA_CALC_Y): Have `main' exit with the value
	returned by yyparse.
	(_AT_CHECK_CALC_ERROR): Take the expected exit value as argument.
	Adjust calls.
	* tests/glr-regr1.at (glr-regr1.y): Have `main' exit with the value
	returned by yyparse.

2002-11-14  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/glr.c (yyFail): Always set yyerrflag.  Corrects regression
	on input.at test.

2002-11-14  Paul Eggert  <eggert@twinsun.com>

	* src/output.c (output_skeleton): Call xfopen instead of
	duplicating xfopen's body.

	Fix bugs reported by Nelson H. F. Beebe in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00078.html>.

	* tests/headers.at (AT_TEST_CPP_GUARD_H): Don't assume that
	"$CC -E foo.h" is allowed, as this doesn't work with the Portland
	Group compiler.  Instead, use "$CC -E bar.c".  Include the .h
	file twice in the grammar, as an extra check.

	* tests/input.at (Torturing the Scanner): Surround the
	backslash-newline tests with "#if 0", to make it less likely that
	we'll run into compiler bugs.  Bring back solitary \ inside
	comment, but add a closing comment to work around HP C bug.  Don't
	test backslash-newline in C character constant.

2002-11-14  Akim Demaille  <akim@epita.fr>

	* tests/synclines.at (AT_SYNCLINES_COMPILE): Ignore the exit
	status of the compiler.
	Calling `exit 1' is no longer needed.
	Reported by Nelson H. F. Beebe.

2002-11-14  Akim Demaille  <akim@epita.fr>

	* tests/atlocal.in (CPPFLAGS): We have config.h.
	* tests/testsuite.at (AT_DATA_GRAMMAR_PROLOGUE, AT_DATA_GRAMMAR):
	New.
	* tests/actions.at, tests/calc.at, tests/conflicts.at,
	* tests/cxx-type.at, tests/glr-regr1.at, tests/headers.at,
	* tests/regression.at, tests/torture.at: Use them for all the
	grammars that are to be compiled.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Rename as...
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): this.
	* doc/bison.texinfo (GLR Parsers): Document `inline'.

2002-11-14  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Various formatting changes (alignments in
	samples, additional @group/@end group, GCS in samples.
	Use @deffn instead of simple @table to define the directives,
	macros, variables etc.

2002-11-13  Paul Eggert  <eggert@twinsun.com>

	Fix some bugs reported by Albert Chin-A-Young in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00066.html>.

	* tests/input.at (Torturing the Scanner): Don't invoke "cc a.c b.c
	-o c"; the HP C compiler chatters during compilation.
	Instead, invoke "cc -c a.c -o a.o; cc -c b.c -o b.o; cc a.o b.o -o c".
	* tests/headers.at (export YYLTYPE): Likewise.

	* tests/input.at (Torturing the Scanner): Remove lines containing
	solitary backslashes, as they tickle a bug in the HP C compiler.

	* tests/glr-regr1.at (Badly Collapsed GLR States): Avoid //
	comments, since they're not portable.  Use GNU coding style.

2002-11-13  Akim Demaille  <akim@epita.fr>

	* data/yacc.c: Leave bigger chunks of quoted text.
	(YYDSYMPRINTF): New.
	Use it to report symbol activities.
	* data/glr.c (YYDSYMPRINTF): New.
	Use it.

2002-11-12  Paul Eggert  <eggert@twinsun.com>

	Version 1.75b.

	* data/glr.c (yydoAction): Return YYRESULTTAG, not int.
	(yyglrReduce): Return yyok, not 0.
	This should avoid the enumerated-type warnings reported
	by Nelson H. F. Beebe in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00057.html>.

	* lib/bbitset.h (BITSET_INLINE): Remove.
	* lib/bitset.h [! BITSET_INLINE]: Remove.
	(bitset_set, bitset_reset, bitset_test): Rename local vars
	to avoid shadowing warnings by GCC.

	* data/glr.c (inline): Remove #define.  It's the user's
	responsibility to #define it away, just like 'const'.
	This fixes one of the bugs reported by Nelson H. F. Beebe in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00058.html>.

	* Makefile.maint (po-check): Scan .l and .y files instead of the
	.c and the .h files that they generate.  This fixes the bug
	reported by Tim Van Holder in:
	<http://lists.gnu.org/archive/html/bison-patches/2002-11/msg00062.html>
	Look for N_ as well as for _.  Try to avoid matching #define for
	N_ and _.
	* po/POTFILES.in: Remove src/parse-gram.c, src/scan-gram.c,
	src/system.h.  Add src/parse-gram.y, src/scan-gram.l.
	* src/scan-gram.l: Revamp regular expressions so that " and '
	do not confuse xgettext.

	* src/struniq.h (struniq_new): Do not declare the return type
	to be 'const'; this violates the C standard.
	* src/struniq.c (struniq_new): Likewise.

2002-11-12  Albert Chin-A-Young <china@thewrittenword.com>

	* src/Makefile.am (LDADD): Link $(LIBINTL) last to avoid the
	duplicate definition of optind on Tru64 UNIX 4.0D with the Compaq
	linker.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* Makefile.maint: Sync with Autoconf:
	(local_updates): New.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* po/POTFILES.in (src/lalr.c, src/state.c): Remove

2002-11-12  Akim Demaille  <akim@epita.fr>

	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Display the
	locations.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_yysymprint_generate): Pass *yyvaluep to YYPRINT,
	not yyvalue.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* tests/actions.at (AT_CHECK_PRINTER_AND_DESTRUCTOR): New.
	Use it to test the GLR parser.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (input.y): s/YYEOF/MYEOF/, as the skeleton
	defines it.
	* data/glr.c (yystos): New.
	(b4_yysymprint_generate, b4_yydestruct_generate): Invoke.
	(YYDSYMPRINT): New.
	(yyval): Don't define it, it is handled via M4.
	(yyrecoverParseError): Free verbosely the discarded symbols.
	* data/yacc.c (yysymprint): Remove, rather...
	(b4_yysymprint_generate): invoke.
	* data/c.m4 (b4_yysymprint_generate): New.
	Accept pointers as arguments, as opposed to the version from
	yacc.c.
	(b4_yydestruct_generate): Likewise.
	* tests/cations.at (Printers and Destructors): Use Bison directives
	instead of CPP macros.
	Don't rely on internal details.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_yydestruct_generate, b4_symbol_actions): New.
	* data/yacc.c: Rename yychar1 as yytoken, as in glr.c.
	Don't work on yychar (i.e., do set it to YYEMPTY, don't match
	it against YYEMPTY and so forth), work on yytoken (i.e., set
	it to YYEMPTY etc.).
	(yydestruct): Replace with a b4_yydestruct_generate invocation.
	(b4_symbol_actions): Remove.
	* data/glr.c (YYTRANSLATE): As for yacc.c, if negative, it stands
	for 0, end-of-input.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Destructor Decl): New.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/tables.c (tables_generate): Use free for pointers that
	cannot be NULL, not XFREE.
	(pack_vector): Use assert, not fatal, for bound violations.
	* src/state.c (state_new): Likewise.
	* src/reader.c (reader): Likewise.
	* src/lalr.c (set_goto_map): Likewise.
	* src/location.h (LOCATION_PRINT): If first_line is 0, just issue
	the file name.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l, src/reader.h (scanner_last_string_free):
	Restore.
	* src/scan-gram.l (last_string): Is global to the file, not to
	yylex.
	* src/parse-gram.y (input): Don't append the epilogue here,
	(epilogue.opt): do it here, and free the scanner's obstack.
	* src/reader.c (epilogue_set): Rename as...
	(epilogue_augment): this.
	* data/c.m4 (b4_epilogue): Defaults to empty.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/getargs.c (long_options): Remove duplicates.
	* src/vmsgetargs.c, src/build.com, src/bison.cld, src/vmshlp.mar:
	Remove.
	* doc/bison.rnh: Remove.
	* doc/bison.texinfo (VMS Invocation): Remove.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/struniq.h, src/struniq.c (struniq_t): Is const.
	(STRUNIQ_EQ, struniq_assert, struniq_assert_p): New.

	Use struniq for symbols.

	* src/symtab.h (symbol_t): The tag member is a struniq.
	(symbol_type_set): Adjust.
	* src/symtab.c (symbol_new): Takes a struniq.
	(symbol_free): Don't free the tag member.
	(hash_compare_symbol_t, hash_symbol_t): Rename as...
	(hash_compare_symbol, hash_symbol): these.
	Use the fact that tags as struniqs.
	(symbol_get): Use struniq_new.
	* src/symlist.h, src/symlist.c (symbol_list_n_type_name_get):
	Returns a strniq.
	* src/reader.h (merger_list, grammar_currentmerge_set): The name
	and type members are struniqs.
	* src/reader.c (get_merge_function)
	(grammar_current_rule_merge_set): Adjust.
	(TYPE, current_type): Are struniq.

	Use struniq for file names.

	* src/files.h, src/files.c (infile): Split into...
	(grammar_file, current_file): these.
	* src/scan-gram.c (YY_USER_INIT, handle_syncline): Adjust.
	* src/reduce.c (reduce_print): Likewise.
	* src/getargs.c (getargs): Likewise.
	* src/complain.h, src/complain.c: Likewise.
	* src/main.c (main): Call struniqs_new early enough to use it for
	file names.
	Don't free the input file name.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/symtab.c (symbol_free): Remove dead deactivated code:
	type_name are properly removed.
	Don't use XFREE to free items that cannot be NULL.
	* src/struniq.h, src/struniq.c: New.
	* src/main.c (main): Initialize/free struniqs.
	* src/parse-gram.y (%union): Add astruniq member.
	(yyprint): Adjust.
	* src/scan-gram.l (<{tag}>): Return a struniq.
	Free the obstack bit that used to store it.
	* src/symtab.h (symbol_t): The 'type_name' member is a struniq.

2002-11-11  Paul Eggert  <eggert@twinsun.com>

	Revamp to fix many (but not all) of the C- and M4-related quoting
	problems.  Among other things, this fixes the Bison bug reported
	by Jan Hubicka when processing the Bash grammar; see:
	<http://lists.gnu.org/archive/html/bison-patches/2002-11/msg00039.html>

	Use new @ escapes consistently.  Represent brackets with @{ and @}
	rather than @<:@ and @:>@, since this works a bit better with dumb
	editors like vi.  Represent @ with @@, since @ is now consistently
	an escape.  Use @oline@ and @ofile@ rather than __oline__ and
	__ofile__, to avoid unexpected expansions.  Similarly, use @output
	rather than #output.

	* data/c.m4 (b4_copyright): Omit file name from comment, since
	the file name could contain "*/".
	(b4_synclines_flag): Don't quote the 2nd argument; it should already
	be quoted.  All uses changed.

	* data/glr.c: Use new @ escapes consistently.
	(b4_input_suffix, b4_output_parser_suffix, b4_output_parser_name,
	b4_output_header_suffix, b4_output_header_name, b4_header_guard):
	Remove, since they couldn't handle arbitrary characters in file
	names.
	* data/lalr1.cc: Likewise.
	* data/yacc.c: Likewise.

	* src/files.c (output_infix): Remove; all uses removed.
	* src/files.h: Likewise.

	* data/glr.c: Remove use of "#ifdef b4_header_guard", since it
	mishandled funny characters in file names, and anyway it isn't
	needed any more.
	* data/yacc.c: Likewise.
	* data/lalr1.cc: Use YYSLP_NEEDED instead of b4_header_guard.

	* data/glr.c (YYSTYPE_IS_TRIVIAL): Define when the .h file would.
	* data/yacc.c: Likewise.

	* src/muscle_tab.c: Include quotearg.h, since we need to quote C
	strings now.
	(muscle_init): Quote filename as a C string.
	* src/muscle_tab.h (MUSCLE_GROW_STRING_PAIR): Remove; unused.
	(MUSCLE_OBSTACK_SGROW, MUSCLE_INSERT_C_STRING): New macros.
	* src/output.c (escaped_file_name_output): New function.
	(prepare_symbols): Quote tokens for M4.
	(prepare): Don't insert output_infix, output_prefix,
	output_parser_name, output_header_name; this is now down by scan-skel.
	Insert skeleton as a C string.

	* src/output.c (user_actions_output, symbol_destructors_output,
	symbol_printers_output): Quote filenames for C and M4.
	* src/reader.c (prologue_augment, epilogue_set): Likewise.

	* src/scan-gram.l (<SC_CHARACTER>): Don't worry about any backslash
	escapes other than \\ and \'; this simplifies the code.
	(<SC_STRING>): Likewise, for \\ and \".
	(<SC_COMMENT,SC_LINE_COMMENT,SC_STRING,SC_CHARACTER,SC_BRACED_CODE,
	SC_PROLOGUE,SC_EPILOGUE>): Escape $ and @, too.
	Use new escapes @{ and @} for [ and ].

	* src/scan-skel.l (yylineno, yyoutname): Remove static vars, replacing
	them with auto vars.
	Switch to new escape scheme, where @ is the escape character uniformly.
	Abort if a stray escape character is found.  Avoid unbounded input
	buffer when parsing non-escaped text.

	* tests/input.at (Torturing the Scanner): Add tests that @oline@,
	__oline__, #output, $@, and @{ do not have unintended meanings.

2002-11-09  Paul Eggert  <eggert@twinsun.com>

	Fix the test failure due to GCC warnings described in
	<http://lists.gnu.org/archive/html/bug-bison/2002-11/msg00000.html>.
	* data/glr.c (yyis_pact_ninf, yyis_table_ninf): New macros, which
	evaluate to 0 if it's impossible for NINF to be in the respective
	table.
	(yygetLRActions, yyrecoverParseError): Use them.

	* src/scan-gram.l (unexpected_end_of_file): Fix bug: columns were
	counted in the token inserted at end of file.  Now takes
	location_t *, not location_t, so that the location can be
	adjusted.  All uses changed.

	* tests/regression.at (Invalid inputs): Adjust wording in
	diagnostic to match the new behavior.

	* tests/torture.at (AT_DATA_TRIANGULAR_GRAMMAR,
	AT_DATA_HORIZONTAL_GRAMMAR, AT_DATA_LOOKAHEADS_GRAMMAR,
	AT_DATA_STACK_TORTURE): Replace `assert (x);' with `if (! (x))
	abort ();'.  This reduces the runtime of the "Many lookaheads"
	test from 27.6 to 2.7 minutes on a 440 MHz Ultrasparc III running
	GCC 3.2.

2002-11-07  Paul Eggert  <eggert@twinsun.com>

	* src/parse-gram.y (CHARACTER): Remove unused token.
	All uses removed.

	* src/scan-gram.l: Remove stack option.  We no longer use the
	stack, since the stack was never deeper than 1; instead, use the
	new auto var c_context to record the stacked value.

	Remove nounput option.  At an unexpected end of file, we now unput
	the minimal input necessary to end cleanly; this simplifies the
	code.

	Avoid unbounded token sizes where this is easy.

	(unexpected_end_of_file): New function.
	Use it to systematize the error message on unexpected EOF.
	(last-string): Now auto, not static.
	(YY_OBS_FREE): Remove unnecessary do while (0) wrapper.
	(scanner_last_string_free): Remove; not used.
	(percent_percent_count): Move decl to just before use.
	(SC_ESCAPED_CHARACTER): Return ID at unexpected end of file,
	not the (never otherwised-used) CHARACTER.

2002-11-07  Akim Demaille  <akim@epita.fr>

	Let yyerror always receive the msg as last argument, so that
	yyerror can be variadic.

	* data/yacc.c (b4_yyerror_args): New.
	Use it when calling yyerror.
	* data/glr.c (b4_yyerror_args, b4_lyyerror_args): New.
	Use it when calling yyerror.
	* doc/bison.texinfo (Error Reporting): Adjust.
	* tests/calc.at (_AT_DATA_CALC_Y): Adjust.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Adjust.

2002-11-06  Akim Demaille  <akim@epita.fr>

	#line should have quoted strings.
	Ideally, this should be done by m4_quotearg.

	* src/scan-skel.l: Include quotearg.h.
	Quote __ofile__.
	* src/output.c (symbol_printers_output)
	(symbol_destructors_output): Quote the file name.

2002-11-06  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (Invalid inputs): Adjust to the recent
	messages.

2002-11-06  Akim Demaille  <akim@epita.fr>

	Restore --no-lines.
	Reported by Jim Kent.

	* data/c.m4 (b4_syncline): New.
	* data/glr.c, data/yacc.c, data/lalr1.cc: Use it.
	* src/reader.c (prologue_augment, epilogue_set): Use b4_syncline.
	* src/output.c (user_actions_output): Likewise.
	(prepare): Define 'b4_synclines_flag'.
	* src/muscle_tab.c (muscle_init): Don't define b4_linef.

2002-11-06  Akim Demaille  <akim@epita.fr>

	* src/main.c (main): Free `infile'.
	* src/scan-gram.l (handle_syncline): New.
	Recognize `#line'.
	* src/output.c (user_actions_output, symbol_destructors_output)
	(symbol_printers_output): Use the location's file name, not
	infile.
	* src/reader.c (prologue_augment, epilogue_set): Likewise.

2002-11-05  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* src/tables.c (matching_state): Don't allow states to match if
	either has GLR conflict entries.

2002-11-05  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l: Use more accurate diagnostics, e.g.
	"integer out of range" rather than "invalid value".
	* tests/input.at (Invalid $n, Invalid @n): Change expected wording
	accordingly.

	Scan <% and %> digraphs in C code as POSIX 1003.1-2001 requires.
	Also, remove one static variable in the scanner.

	* src/scan-gram.l (braces_level): Now auto, not static.
	Initialize to zero if the compiler is being picky.
	(INITIAL): Clear braces_level instead of incrementing it.
	(SC_BRACED_CODE): Treat <% and %> as { and } when inside C code,
	as POSIX 1003.1-2001 requires.
	* src/system.h (IF_LINT): New macro, taken from coreutils.
	* configure.ac: Define "lint" if --enable-gcc-warnings.

2002-11-05  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l: When it starts with `%', complain about the
	whole directive, not just that `invalid character: %'.

2002-11-04  Akim Demaille  <akim@epita.fr>

	* Makefile.maint: Update from Autoconf.
	(update, cvs-update, po-update, do-po-update): New.

2002-11-04  Akim Demaille  <akim@epita.fr>

	* tests/glr-regr1.at (Badly Collapsed GLR States): Prototype yylex
	and yyerror.
	Have yyerror `use' its arguments.
	* tests/calc.at (AT_CHECK_PUSHDEFS): AT_YYERROR_SEES_LOC_IF
	returns true when location & yacc & pure & parse-param.
	(_AT_DATA_CALC_Y): Let yyerror ``use'' its arguments.

2002-11-04  Akim Demaille  <akim@epita.fr>

	* src/location.h (LOCATION_PRINT): Use quotearg slot 3 to avoid
	clashes.
	* src/scan-gram.l: Use [\'] instead of ['] to pacify
	font-lock-mode.
	Use complain_at.
	Use quote, not quote_n since LOCATION_PRINT no longer uses the
	slot 0.

2002-11-03  Paul Eggert  <eggert@twinsun.com>

	* src/reader.c (get_merge_function, grammar_current_rule_check):
	Use consistent diagnostics for reporting type name clashes.
	Quote the types with <>, for consistency with Yacc.
	* tests/input.at (Type Clashes): Adjust to diagnostic changes.

2002-11-03  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_identification, b4_user_args, b4_parse_param):
	New.
	* data/yacc.m4 (b4_pure_args, b4_Pure_args): New.
	(b4_parse_param): Remove.
	Use b4_identification.
	Propagate b4_pure_args where needed to pass them to yyerror.
	* data/glr.m4 (b4_parse_param): Remove.
	(b4_user_formals, b4_pure_args, b4_pure_formals, b4_lpure_args)
	(b4_lpure_formals): New.
	Use b4_identification.
	(YY_USER_FORMALS, YY_USER_ARGS): Remove, replaced by
	b4_user_formals and b4_user_args.
	(yyexpandGLRStack, yyFail, yyaddDeferredAction, yyglrShiftDefer)
	(yyreportAmbiguity): When using a pure parser, also need
	the location, and the parse-params.
	Adjust callers.
	(yyuserAction, yyglrShift, yyreportParseError, yyrecoverParseError):
	When using a pure parser, also need the parse-params.
	Adjust callers.
	* tests/calc.at: Test pure (%pure-parser) and absolutely pure
	(%pure-parser + %parse-param) LALR and GLR parsers.
	(AT_CHECK_PUSHDEFS, AT_CHECK_POPDEFS): New, define AT_PARAM_IF,
	AT_LOCATION_IF, AT_PURE_IF, AT_GLR_IF, AAT_PURE_AND_LOC_IF,
	AT_GLR_OR_PARAM_IF, AT_YYERROR_ARG_LOC_IF, AT_YYERROR_SEES_LOC_IF.
	(_AT_DATA_CALC_Y): Equip for purity of yyerror.
	(_AT_CHECK_CALC_ERROR): Use AT_YYERROR_SEES_LOC_IF.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Equip for yyerror purity.
	* doc/bison.texinfo: Untabify the whole file.
	(Parser Function): Document %parse-param, deprecate YYPARSE_PARAM.
	(Pure Calling): Document %lex-param, deprecate YYLEX_PARAM.
	(Error Reporting): Adjust to these new directives.
	Document %error-verbose, deprecate YYERROR_VERBOSE.

2002-11-03  Akim Demaille  <akim@epita.fr>

	* tests/calc.at: Change all the AT_CHECK_CALC_LALR and
	AT_CHECK_CALC_GLR invocations to use % directives, instead of
	command line options.
	* tests/cxx-type.at: Formatting changes.

2002-11-03  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l: Revamp to fix POSIX incompatibilities,
	to count columns correctly, and to check for invalid inputs.

	Use mbsnwidth to count columns correctly.  Account for tabs, too.
	Include mbswidth.h.
	(YY_USER_ACTION): Invoke extend_location rather than LOCATION_COLUMNS.
	(extend_location): New function.
	(YY_LINES): Remove.

	Handle CRLF in C code rather than in Lex code.
	(YY_INPUT): New macro.
	(no_cr_read): New function.

	Scan UCNs, even though we don't fully handle them yet.
	(convert_ucn_to_byte): New function.

	Handle backslash-newline correctly in C code.
	(SC_LINE_COMMENT, SC_YACC_COMMENT): New states.
	(eols, blanks): Remove.  YY_USER_ACTION now counts newlines etc.;
	all uses changed.
	(tag, splice): New EREs.  Do not allow NUL or newline in tags.
	Use {splice} wherever C allows backslash-newline.
	YY_STEP after space, newline, vertical-tab.
	("/*"): BEGIN SC_YACC_COMMENT, not yy_push_state (SC_COMMENT).

	(letter, id): Don't assume ASCII; e.g., spell out a-z.

	({int}, handle_action_dollar, handle_action_at): Check for integer
	overflow.

	(YY_STEP): Omit trailing semicolon, so that it's more like C.

	(<SC_ESCAPED_STRING,SC_ESCAPED_CHARACTER>): Allow \0 and \00
	as well as \000.  Check for UCHAR_MAX, not 255.
	Allow \x with an arbitrary positive number of digits, as in C.
	Check for overflow here.
	Allow \? and UCNs, for compatibility with C.

	(handle_symbol_code_dollar): Use quote_n slot 1 to avoid collision
	with quote slot used by complain_at.

	* tests/input.at: Add tests for backslash-newline, m4 quotes
	in symbols, long literals, and funny escapes in strings.

	* configure.ac (jm_PREREQ_MBSWIDTH): Add.
	* lib/Makefile.am (libbison_a_SOURCES): Add mbswidth.h, mbswidth.c.
	* lib/mbswidth.h, lib/mbswidth.c: New files, from GNU gettext.
	* m4/Makefile.am (EXTRA_DIST): Add mbswidth.m4.
	* m4/mbswidth.m4: New file, from GNU coreutils.

	* doc/bison.texinfo (Grammar Outline): Document // comments.
	(Symbols): Document that trigraphs have no special meaning in Bison,
	nor is backslash-newline allowed.
	(Actions): Document that trigraphs have no special meaning.

	* src/location.h (LOCATION_COLUMNS, LOCATION_LINES): Remove;
	no longer used.

2002-11-02  Paul Eggert  <eggert@twinsun.com>

	* src/reader.c: Don't include quote.h; not needed.
	(get_merge_function): Reword warning to be consistent with
	type clash diagnostic in grammar_current_rule_check.

	* lib/quotearg.c (quotearg_buffer_restyled): Fix off-by-two
	bug in trigraph handling.

	* src/output.c (prepare_symbols): When printing token names,
	escape "[" as "@<:@" and likewise for "]".

	* src/system.h (errno): Remove declaration, as we are now
	assuming C89 or better, and C89 guarantees errno.

2002-10-30  Paul Eggert  <eggert@twinsun.com>

	* lib/bitset_stats.c (bitset_stats_read, bitset_stats_write):
	Check for close failures.
	* src/files.h (xfclose): Return void, not int, since it always
	returned zero.
	* src/files.c (xfclose): Likewise.  Report I/O error if ferror
	indicates one.
	* src/output.c (output_skeleton): Use xfclose rather than fclose
	and ferror.  xfclose now checks ferror.

	* data/glr.c (YYLEFTMOST_STATE): Remove.
	(yyreportTree): Use a stack-based leftmost state.  This avoids
	our continuing battles with bogus warnings about initializers.

2002-10-30  Akim Demaille  <akim@epita.fr>

	* src/system.h: Don't use #ifdef/#ifndef on HAVE_ values, only
	#if.

2002-10-29  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* tests/glr-regr1.at: New test for reported regressions.
	* tests/testsuite.at: Add glr-regr1.at test.
	* tests/Makefile.am: Add glr-regr1.at test.

2002-10-24  Paul Eggert  <eggert@twinsun.com>

	Version 1.75a.

	* tests/calc.at (_AT_DATA_CALC_Y): Remove unused strcat declaration.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Include stdlib.h, since
	we use malloc.  Don't assume 'A' through 'Z' are contiguous.
	Don't assume strdup exists; POSIX says its an XSI extension.
	Check for buffer overflow on input.

2002-10-24  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_skeleton): Don't disable M4sugar comments
	too soon: it results in comments being expanded.
	* data/yacc.c, data/glr.c, data/lalr1.cc: Do it right before the
	first output.

2002-10-24  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (m4_int_type): New.
	* data/c.m4 (m4_int_type): Don't use yysigned_char, but `signed
	char' as only yacc.c wants K&R portability.
	* data/glr.c (yysigned_char): Remove.
	* data/lalr1.cc: Rename the trailing b4_name as b4_parser_class_name.
	Reported by Quoc Peyrot.

2002-10-23  Paul Eggert  <eggert@twinsun.com>

	* src/main.c (main): With --trace=time, report times even if a
	non-fatal error occurs.  Formerly, the times were reported in some
	such cases but not in others.
	* src/reader.c (reader): Just return if a complaint has been issued,
	instead of exiting, so that 'main' can report times.

2002-10-22  Akim Demaille  <akim@epita.fr>

	* src/system.h: Include sys/types.
	Reported by Bert Deknuydt.

2002-10-23  Paul Eggert  <eggert@twinsun.com>

	* configure.ac (AC_PROG_LEX): Use instead of AM_PROG_LEX.
	Suggested by Art Haas.

2002-10-22  Paul Eggert  <eggert@twinsun.com>

	* src/complain.c (exit) [! (STDC_HEADERS || _LIBC)]: Remove exit
	decl; not needed any more.
	* src/main.c (main): Use return to exit, undoing yesterday's change.
	The last OS that we could find where this wouldn't work is
	SunOS 3.5, and that's too old to worry about now.

	* data/glr.c (struct yyltype): Define members even when not
	doing locations.  This is more consistent with yacc.c, and it
	works around the following bug reports:
	http://lists.gnu.org/archive/html/bug-bison/2002-10/msg00106.html
	http://lists.gnu.org/archive/html/bug-bison/2002-10/msg00111.html

	* doc/bison.texinfo: Minor spelling and typographical fixes.  Use
	@acronym consistently.  Standardize on "Yacc" instead of "YACC",
	"Algol" instead of "ALGOL".  Give a bit more history about BNF.

2002-10-22  Akim Demaille  <akim@epita.fr>

	* data/README: New.

2002-10-21  Paul Eggert  <eggert@twinsun.com>

	Be consistent about 'bool'; the old code used an enum in one
	module and an int in another, and this violates the C standard.
	* m4/stdbool.m4: New file, from coreutils 4.5.3.
	* configure.ac (AC_HEADER_STDBOOL): Add.
	* m4/Makefile.am (EXTRA_DIST): Add stdbool.m4.
	* src/muscle_tab.c (hash_compare_muscles): (a ? FALSE : TRUE) -> (! a)
	* src/symtab.c (hash_compare_symbol_t): Likewise.
	* src/system.h (bool, false, true): Use a definition consistent
	with ../lib/hash.c.  All uses changed.

	* src/complain.c (warning_issued): Renamed from warn_message_count,
	so that we needn't worry about integer overflow (!).
	Now of type bool.  All uses changed.
	(complaint_issued): Renamed from complain_message_count; likewise.

	* src/main.c (main): Use exit to exit with failure.

	* src/complain.c (fatal_at, fatal): Use EXIT_FAILURE and EXIT_SUCCESS
	rather than 1 and 0.
	* src/main.c (main): Likewise.
	* src/getargs.c (getargs): Likewise.
	* src/reader.c (reader): Likewise.

	* src/getarg.c (getargs): Remove duplicate code for
	"Try `bison --help'".

	* src/files.c (xfopen, xfclose): Use EXIT_FAILURE rather than 2.
	What was that "2" for?

	* src/complain.h (fatal, fatal_at): Add __attribute__((__noreturn__)).
	* src/getargs.c (usage): Likewise.

	* src/getargs.c (getargs): When there are too few operands, report
	the last one.  When there are too many, report the first extra
	one.  This is how diffutils does it.

2002-10-20  Paul Eggert  <eggert@twinsun.com>

	Remove K&R vestiges.
	* configure.ac (AC_C_CONST, AM_C_PROTOTYPES): Remove.
	* src/complain.c (VA_START): Remove.  Assume prototypes.
	(vfprintf) [! (HAVE_VPRINTF || defined vfprintf)]: New macro.
	(private_strerror, warn_at, warn, complain_at, complain, fatal_at,
	fatal): Assume prototypes.
	* src/complain.h: Assume prototypes.
	* src/system.h (PARAMS): Remove.
	Include <limits.h> unconditionally, since it's guaranteeed even
	for a freestanding C89 compiler.
	(SHRT_MIN, SHRT_MAX): Remove, since C89 guarantees them.
	* src/vmsgetargs.c (getargs, cli_present, cli_get_value): Prototype.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.c (muscle_grow): Remove trailing debugging code.
	* data/glr.c (YY_USER_FORMALS, YY_USER_ARGS): New.
	(yyuserAction, yydoAction, yyglrReduce, yyresolveValue)
	(yyresolveStates, yyresolveAction, yyresolveStack)
	(yyprocessOneStack): Use them.
	(yy_reduce_print): New.
	* tests/calc.at (_AT_DATA_CALC_Y): Exercise %parse-param.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_c_ansi_args): Recognize functions with no
	arguments and output `void'.
	(b4_c_function): Rename as...
	(b4_c_function_def): this.
	(b4_c_function_decl, b4_c_ansi_function_def)
	(b4_c_ansi_function_decl): New.
	Change the interpretation of the arguments: before `int, foo', now
	`int foo, foo'.
	* data/yacc.c (yyparse): Prototype and define thanks to these.
	Adjust b4_c_function_def uses.
	* data/glr.c (yyparse): Likewise, but ANSI only.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare): Move the definition of `tokens_number',
	`nterms_number', `undef_token_number', `user_token_number_max'
	to...
	(prepare_tokens): Here.
	(prepare_tokens): Rename as...
	(prepare_symbols): this.
	(prepare): Move the definition of `rules_number' to...
	(prepare_rules): here.
	(prepare): Move the definition of `last', `final_state_number',
	`states_number' to...
	(prepare_states): here.
	* data/yacc.c, data/lalr1.cc, data/glr.c: Normalize `>' into `<'.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/tables.h, src/tables.c, src/output.c: Comment changes.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* data/yacc.c, data/yacc.c (b4_location_if, b4_pure_if): Move to...
	* data/c.m4: here.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare): Use MUSCLE_INSERT_STRING.
	* src/muscle_tab.c (muscle_pair_list_grow): Rename `val as
	`pair'.
	(muscle_init): Move the `b4_ltype', `b4_maxdepth', `b4_initdepth',
	`name' to...
	* data/glr.c, data/lalr1.cc, data/yacc.c (b4_location_type)
	(b4_stack_depth_init, b4_stack_depth_max, b4_parser_class_name):
	These.

2002-10-19  Paul Eggert  <eggert@twinsun.com>

	Do not create a temporary file, as that involves security and
	cleanup headaches.  Instead, use a pair of pipes.
	Derived from a suggestion by Florian Krohm.
	* lib/subpipe.c, lib/subpipe.h, m4/subpipe.m4: New files.
	* lib/mkstemp.c, lib/readpipe.c, lib/tempname.c, m4/mkstemp.m4: Remove.
	* configure.ac (UTILS_FUNC_MKSTEMP, jm_PREREQ_TEMPNAME): Remove.
	(BISON_PREREQ_SUBPIPE): Add.
	* lib/Makefile.am (libbison_a_SOURCES): Remove readpipe.c.
	Add subpipe.h, subpipe.c.
	* m4/Makefile.am (EXTRA_DIST): Remove mkstemp.m4.  Add subpipe.m4.
	* po/POTFILES.in: Add lib/subpipe.c.
	* src/output.c: Include "subpipe.h".
	(m4_invoke): Remove decl.
	(scan_skel): New decl.
	(output_skeleton): Use pipe rather than temporary file for m4 input.
	Check that m4sugar.m4 is readable, to avoid deadlock.
	Check for pipe I/O error.
	* src/scan-skel.l (readpipe): Remove decl.
	(scan_skel): New function, to be used in place of m4_invoke.
	Read from stream rather than file.

	* lib/timevar.c (TICKS_TO_MSEC, CLOCKS_TO_MSEC): Do not cast to
	float, as this generates a warning on Solaris 8 + GCC 3.2 with
	--enable-gcc-warnings.  Instead, divide into 1.0 rather than 1;
	this generates a more-accurate value anyway.

	* lib/timevar.c (timervar_accumulate): Rename locals to
	avoid confusion with similarly-named more-global.
	* src/muscle_tab.c (muscle_pair_list_grow): Likewise.

	* src/output.c (prepare): Use xstrdup to convert char const *
	to char *, to avoid GCC warning.

2002-10-19  Akim Demaille  <akim@epita.fr>

	* tests/calc.at (_AT_DATA_CALC_Y): Define VAL, LOC, LEX_FORMALS,
	LEX_PRE_FORMALS, LEX_ARGS, LEX_PRE_ARGS, USE_LEX_ARGS.
	Use them to have `calc.y' ready for %pure-parser.
	* data/yacc.c (YYLEX): Pass a yylex return type to
	b4_c_function_call.

2002-10-19  Akim Demaille  <akim@epita.fr>

	Prototype support of %lex-param and %parse-param.

	* src/parse-gram.y: Add the definition of the %lex-param and
	%parse-param tokens, plus their rules.
	Drop the `_' version of %glr-parser.
	Add the "," token.
	* src/scan-gram.l (INITIAL): Scan them.
	* src/muscle_tab.c: Comment changes.
	(muscle_insert, muscle_find): Rename `pair' as `probe'.
	* src/muscle_tab.h (MUSCLE_INSERT_PREFIX): Remove unused.
	(muscle_entry_s): The `value' member is no longer const.
	Adjust all dependencies.
	* src/muscle_tab.c (muscle_init): Adjust: use
	MUSCLE_INSERT_STRING.
	Initialize the obstack earlier.
	* src/muscle_tab.h, src/muscle_tab.c (muscle_grow)
	(muscle_pair_list_grow): New.
	* data/c.m4 (b4_c_function_call, b4_c_args): New.
	* data/yacc.c (YYLEX): Use b4_c_function_call to honor %lex-param.
	* tests/calc.at: Use %locations, not --locations.
	(AT_CHECK_CALC_GLR): Use %glr-parser, not %glr_parser.

2002-10-19  Akim Demaille  <akim@epita.fr>

	* src/getargs.c (usage): Take status as argument and exit
	accordingly.
	Report the traditional `Try ... --help' message when status != 0.
	(usage, version): Don't take a FILE * as arg, it is pointless.
	(getargs): When there is an incorrect number of arguments, make it
	an error, and report it GNUlically thanks to `usage ()'.

2002-10-18  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yyreportParseError): Don't assume that sprintf
	yields the length of the printed string, as this is not true
	on SunOS 4.1.4.  Reported by Peter Klein.

	* tests/calc.at (_AT_DATA_CALC_Y): #undef memcmp and realloc.
	* tests/conflicts.at (%nonassoc and eof): Likewise.
	Fixes SunOS 4.1.4 test failure reported by Peter Klein.

2002-10-17  Akim Demaille  <akim@epita.fr>

	* src/getargs.h (trace_e): Add trace_scan, and trace_parse.
	* src/getargs.c (trace_types, trace_args): Adjust.
	* src/reader.c (grammar_current_rule_prec_set)
	(grammar_current_rule_dprec_set, grammar_current_rule_merge_set):
	Standardize error messages.
	And s/@prec/%prec/!
	(reader): Use trace_flag to enable scanner/parser debugging,
	instead of an adhoc scheme.
	* src/scan-gram.l: Remove trailing debugging code.

2002-10-16  Paul Eggert  <eggert@twinsun.com>

	* src/muscle_tab.h (MUSCLE_TAB_H_): Was misspelled as
	MUSCLE_TAB_H.

	* NEWS: Officially drop support for building Bison with K&R C,
	since it didn't work anyway and it's not worth worrying about.
	* Makefile.maint (wget_files): Remove ansi2knr.c.
	(ansi2knr.c-url_prefix): Remove.
	* lib/.cvsignore: Remove ansi2knr, ansi2knr.*.
	* lib/Makefile.am (AUTOMAKE_OPTIONS): Remove.
	* src/Makefile.am (AUTOMAKE_OPTIONS): Remove.

2002-10-15  Paul Eggert  <eggert@twinsun.com>

	Stop using the "enum_" trick for K&R-style function definitions;
	it confused me, and I was the author!  Instead, assume that people
	who want to use K&R C compilers (when using these modules in GCC,
	perhaps?) will run ansi2knr.

	* lib/bbitset.h: (enum_bitset_ops, enum_bitset_type): Remove.
	All uses of "enum_" changed to "enum ".
	* lib/ebitset.c (enum_ebitset_find_mode): Likewise.
	* lib/lbitset.c (enum_lbitset_find_mode): Likewise.

	* lib/abitset.c (abitset_and, abitset_and_cmp, abitset_and_or,
	abitset_and_or_cmp, abitset_andn, abitset_andn_cmp,
	abitset_andn_or, abitset_andn_or_cmp, abitset_bytes, abitset_copy,
	abitset_copy1, abitset_disjoint_p, abitset_empty_p,
	abitset_equal_p, abitset_init, abitset_list, abitset_list_reverse,
	abitset_not, abitset_ones, abitset_or, abitset_or_and,
	abitset_or_and_cmp, abitset_or_cmp, abitset_reset, abitset_set,
	abitset_size, abitset_small_list, abitset_subset_p, abitset_test,
	abitset_unused_clear, abitset_xor, abitset_xor_cmp, abitset_zero):
	Use function prototypes; this removes the need for declaring
	static functions simply to provide their prototypes.
	* lib/bitset.c (bitset_alloc, bitset_and_or_, bitset_and_or_cmp_,
	bitset_andn_or_, bitset_andn_or_cmp_, bitset_bytes, bitset_copy_,
	bitset_count_, bitset_create, bitset_dump, bitset_first,
	bitset_free, bitset_init, bitset_last, bitset_next,
	bitset_obstack_alloc, bitset_obstack_free, bitset_only_set_p,
	bitset_op4_cmp, bitset_or_and_, bitset_or_and_cmp_, bitset_prev,
	bitset_print, bitset_release_memory, bitset_toggle_,
	bitset_type_choose, bitset_type_get, bitset_type_name_get,
	debug_bitset): Likewise.
	* lib/bitset.h (bitset_set, bitset_reset, bitset_test): Likewise.
	* lib/bitset_stats.c (bitset_log_histogram_print,
	bitset_percent_histogram_print, bitset_stats_and,
	bitset_stats_and_cmp, bitset_stats_and_or,
	bitset_stats_and_or_cmp, bitset_stats_andn, bitset_stats_andn_cmp,
	bitset_stats_andn_or, bitset_stats_andn_or_cmp, bitset_stats_copy,
	bitset_stats_count, bitset_stats_disable, bitset_stats_disjoint_p,
	bitset_stats_dump, bitset_stats_empty_p, bitset_stats_enable,
	bitset_stats_equal_p, bitset_stats_free, bitset_stats_init,
	bitset_stats_list, bitset_stats_list_reverse, bitset_stats_not,
	bitset_stats_ones, bitset_stats_or, bitset_stats_or_and,
	bitset_stats_or_and_cmp, bitset_stats_or_cmp, bitset_stats_print,
	bitset_stats_print_1, bitset_stats_read, bitset_stats_reset,
	bitset_stats_set, bitset_stats_size, bitset_stats_subset_p,
	bitset_stats_test, bitset_stats_toggle, bitset_stats_type_get,
	bitset_stats_write, bitset_stats_xor, bitset_stats_xor_cmp,
	bitset_stats_zero): Likewise.
	* lib/bitsetv.c (bitsetv_alloc, bitsetv_create, bitsetv_free,
	bitsetv_zero, bitsetv_ones, bitsetv_transitive_closure,
	bitsetv_dump, debug_bitsetv): Likewise.
	* lib/ebitset.c (ebitset_and, ebitset_and_cmp, ebitset_andn,
	ebitset_andn_cmp, ebitset_bytes, ebitset_copy, ebitset_copy_,
	ebitset_copy_cmp, ebitset_disjoint_p, ebitset_elt_add,
	ebitset_elt_alloc, ebitset_elt_calloc, ebitset_elt_find,
	ebitset_elt_free, ebitset_elt_last, ebitset_elt_remove,
	ebitset_elt_zero_p, ebitset_elts_grow, ebitset_empty_p,
	ebitset_equal_p, ebitset_free, ebitset_init, ebitset_list,
	ebitset_list_reverse, ebitset_not, ebitset_ones, ebitset_op3_cmp,
	ebitset_or, ebitset_or_cmp, ebitset_release_memory, ebitset_reset,
	ebitset_set, ebitset_size, ebitset_subset_p, ebitset_test,
	ebitset_weed, ebitset_xor, ebitset_xor_cmp, ebitset_zero):
	Likewise.
	* lib/lbitset.c (debug_lbitset, lbitset_and, lbitset_and_cmp,
	lbitset_andn, lbitset_andn_cmp, lbitset_bytes, lbitset_copy,
	lbitset_copy_cmp, lbitset_disjoint_p, lbitset_elt_alloc,
	lbitset_elt_calloc, lbitset_elt_find, lbitset_elt_free,
	lbitset_elt_link, lbitset_elt_unlink, lbitset_elt_zero_p,
	lbitset_empty_p, lbitset_equal_p, lbitset_free, lbitset_init,
	lbitset_list, lbitset_list_reverse, lbitset_not, lbitset_ones,
	lbitset_op3_cmp, lbitset_or, lbitset_or_cmp, lbitset_prune,
	lbitset_release_memory, lbitset_reset, lbitset_set, lbitset_size,
	lbitset_subset_p, lbitset_test, lbitset_weed, lbitset_xor,
	lbitset_xor_cmp, lbitset_zero): Likewise.

2002-10-14  Akim Demaille  <akim@epita.fr>

	Version 1.75.

2002-10-14  Akim Demaille  <akim@epita.fr>

	* tests/Makefile.am (maintainer-check-posix): New.

2002-10-14  Akim Demaille  <akim@epita.fr>

	* data/glr.c [YYDEBUG] (YYLEFTMOST_STATE): Initialize the yyloc
	member.

2002-10-14  Akim Demaille  <akim@epita.fr>

	* src/tables.c (table_ninf_remap): base -> tab.
	Reported by Matt Rosing.

2002-10-14  Paul Eggert  <eggert@twinsun.com>

	* tests/action.at, tests/calc.at, tests/conflicts.at,
	tests/cxx-type.at, tests/headers.at, tests/input.at,
	tests/regression.at, tests/synclines.at, tests/torture.at:
	Say "bison -o foo.c foo.y", not "bison foo.y -o foo.c",
	so that the tests still work even if POSIXLY_CORRECT is set.
	* doc/bison.texinfo (Rpcalc Compile, Invocation): Likewise.

	* data/c.m4 (b4_int_type): Use yysigned_char instead of signed char,
	for portability to K&R hosts.  Fix typo: signed char is guaranteed
	only to 127, not to 128.
	* data/glr.c (yysigned_char): New type.
	* data/yacc.c (yysigned_char): Likewise.
	* tests/regression.at (Web2c Actions): signed char -> yysigned_char.

2002-10-13  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c (yyparse): Rewrite to avoid "comparison is always
	true due to limited range of data type" warning from GCC.

	* data/c.m4 (b4_token_defines): Protect against double-inclusion
	by wrapping enum yytokentype's definition inside #ifndef
	YYTOKENTYPE.  This undoes a bug I introduced on 2002-10-12.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* data/glr.c (yyglrShiftDefer, yyaddDeferredAction, yydoAction):
	Un yy- yyrhs to avoid the name clash with the global YYRHS.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* Makefile.maint: Update from Autoconf 2.54.
	* m4/strerror_r.m4 (AC_FUNC_STRERROR_R): Remove, shipped with 2.54.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* src/print.c (print_state): Separate the list of solved conflicts
	from the other items.
	* tests/conflicts.at (Resolved SR Conflicts): Adjust.

2002-10-13  Akim Demaille  <akim@epita.fr>

	Let nondeterministic skeletons be usable with deterministic
	tables.

	With the patch, GAWK compiled by GCC without -O2 passes its test
	suite using a GLR parser driven by LALR tables.  It fails with -O2
	because `struct stat' gives two different answers on my machine:
	88 (definition of an auto var) and later 96 (memset on this var).
	Hence the stack is badly corrumpted.  The headers inclusion is to
	blame: if I move the awk.h inclusion before GLR's system header
	inclusion, the two struct stat have the same size.

	* src/tables.c (pack_table): Always create conflict_table.
	(token_actions): Always create conflict_list.
	* data/glr.c (YYFLAG): Remove, unused.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* configure.ac (AC_GNU_SOURCE): Use it instead of hand written code.
	(O0FLAGS): New.
	(VALGRIND, GXX): New.
	* tests/atlocal.in (CFLAGS): Use O0FLAGS.
	* tests/bison.in: Run $PREBISON a pre-command.
	* tests/Makefile.am (maintainer-check, maintainer-check-valgrind)
	(maintainer-check-g++): New.
	* Makefile.am (maintainer-check): New.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* data/glr.c: Formatting changes.
	Tweak some trace messages to match yacc.c's.

2002-10-13  Akim Demaille  <akim@epita.fr>

	GLR parsers sometimes raise parse errors instead of performing the
	default reduction.
	Reported by Charles-Henry de Boysson.

	* tests/calc.at (_AT_CHECK_CALC, _AT_CHECK_CALC_ERROR): Don't
	check the length of the	traces when %glr.
	(_AT_CHECK_CALC_ERROR): Also skip `^Stack' lines, coming from
	GLR's traces.
	(AT_CHECK_CALC_LALR, AT_CHECK_CALC_GLR): New.
	Test GLR parsers.
	* data/glr.c (YYLEFTMOST_STATE): Fix its value.
	(yyltype): Remove the yy prefix from the member names.
	(yytable): Complete its comment.
	(yygetLRActions): Map error action number from YYTABLE from
	YYTABLE_NINF to 0.
	(yyisErrorAction): No longer compare YYACTION to YYPACT_NINF
	(which was a bug: it should have been YYTABEL_NINF, and yet it was
	not satisfying as we could compare an YYACTION computed from
	YYDEFACT to YYTABLE_NINF although they are unrelated): 0 is the
	only value for error actions.
	(yyreportParseError): In verbose parse error messages, don't issue
	`error' in the list of expected tokens.
	* data/yacc.c (yyparse) <yybackup>: Rewrite the decoding of the
	next action to perform to match glr.c's decoding.
	(yytable): Complete its comment.

2002-10-13  Paul Eggert  <eggert@twinsun.com>

	Fix problem reported by Henrik Grubbstroem in
	<http://lists.gnu.org/archive/html/bug-bison/2002-10/msg00098.html>:
	"nonterm: { $$ = 123; } { $$ = $1; };" was wrongly rejected,
	because the Bison parser reads the second action before reducing
	the first one.
	* src/scan-gram.l (rule_length): New static var.
	Use it to keep track of the rule length in the scanner, since
	we can't expect the parser to be in lock-step sync with the scanner.
	(handle_action_dollar, handle_action_at): Use this var.
	* tests/actions.at (Exotic Dollars): Test for the problem.

2002-10-12  Paul Eggert  <eggert@twinsun.com>

	* lib/timevar.c [! IN_GCC && HAVE_SYS_TIME_H]: Include <sys/time.h>.
	* m4/timevar.m4 (BISON_PREREQ_TIMEVAR): Check for <sys/time.h>.
	Include <sys/time.h> when checking for clock_t and struct tms.
	Use same include order as source.
	This is for the SunOS 4.1.4 porting bug reported by Peter Klein in
	<http://lists.gnu.org/archive/html/bug-bison/2002-10/msg00016.html>.

	* lib/timevar.c: Update copyright date and clarify comments.
	(get_time) [IN_GCC]: Keep the GCC version for reference.

	* lib/timevar.c, lib/timevar.h, lib/timevar.def: Import
	GCC version as of today, then merge Bison's changes.
	Change "GCC" to "Bison" in copyright notice.  timevar.def's
	author is Akim, so change that too.

	* src/reader.c (grammar_current_rule_check):
	Don't worry about the default action if $$ is untyped.
	Prevents bogus warnings reported by Jim Gifford in
	<http://lists.gnu.org/archive/html/bug-bison/2002-10/msg00015.html>.

	* data/c.m4 (b4_token_enum): Do not define YYTOKENTYPE.
	* data/glr.c, data/lalr1.cc, data/yacc.c:
	Output token definitions before the first part of user declarations.
	Fixes compatibility problem reported by Jim Gifford for kbd in
	<http://lists.gnu.org/archive/html/bug-bison/2002-10/msg00014.html>.

2002-10-11  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c (yyreport_parse_error): Remove, putting its body into...
	(yyparse): here.  This undoes some of the 2002-07-25 change.
	Compatibility problem reported by Ralf S. Engelschall with
	OSSP cfg <http://www.ossp.org/pkg/lib/cfg/>.

2002-10-11  Akim Demaille  <akim@epita.fr>

	* tests/regression.at Characters Escapes): New.
	* src/scan-gram.l (SC_ESCAPED_CHARACTER): Accept \' in strings and
	characters.
	Reported by Jan Nieuwenhuizen.

2002-10-11  Akim Demaille  <akim@epita.fr>

	* po/id.po: New.

2002-10-10  Paul Eggert  <eggert@twinsun.com>

	Portability fixes for bitsets; this also avoids several GCC
	warnings.

	* lib/abitset.c: Include <stddef.h>, for offsetof.
	* lib/lbitset.c: Likewise.

	* lib/abitset.c (abitset_bytes): Return a size that is aligned
	properly for vectors of objects.  Do not assume that adding a
	header size to a multiple of a word size yields a value that is
	properly aligned for the whole union.
	* lib/bitsetv.c (bitsetv_alloc): Likewise.

	* lib/bitset_stats.c (bitset_stats_bytes): Adjust to new,
	unique names for structures.
	* lib/ebitset.c (ebitset_bytes): Likewise.
	* lib/lbitset.c (lbitset_bytes): Likewise.

	* lib/abitset.c (abitset_ones, abitset_zero, abitset_empty_p,
	abitset_copy1, abitset_not, abitset_equal_p, abitset_subset_p,
	abitset_disjoint_p, abitset_and, abitset_and_cmp, abitset_andn,
	abitset_andn_cmp, abitset_or, abitset_or_cmp, abitset_xor,
	abitset_xor_cmp, abitset_and_or, abitset_and_or_cmp,
	abitset_andn_or, abitset_andn_or_cmp, abitset_or_and,
	abitset_or_and_cmp, abitset_copy): Supply prototype decls,
	to improve the type-checking that GCC can do.
	* lib/bitset.c (bitset_op4_cmp): Likewise.
	* lib/bitset_stats.c (bitset_stats_count,
	bitset_stats_empty_p, bitset_stats_ones, bitset_stats_zero,
	bitset_stats_copy, bitset_stats_disjoint_p,
	bitset_stats_equal_p, bitset_stats_not, bitset_stats_subset_p,
	bitset_stats_and, bitset_stats_and_cmp, bitset_stats_andn,
	bitset_stats_andn_cmp, bitset_stats_or, bitset_stats_or_cmp,
	bitset_stats_xor, bitset_stats_xor_cmp, bitset_stats_and_or,
	bitset_stats_and_or_cmp, bitset_stats_andn_or,
	bitset_stats_andn_or_cmp, bitset_stats_or_and,
	bitset_stats_or_and_cmp): Likewise.
	* lib/lbitset.c (lbitset_and, lbitset_and_cmp, lbitset_andn,
	lbitset_andn_cmp, lbitset_or, lbitset_or_cmp, lbitset_xor,
	lbitset_xor_cmp, lbitset_empty_p, lbitset_ones, lbitset_not,
	lbitset_subset_p, lbitset_disjoint_p, debug_lbitset): Likewise.

	* lib/abitset.h: Include bitset.h, not bbitset.h.
	* lib/ebitset.h: Likewise.
	* lib/lbitset.h: Likewise.

	* lib/bbitset.h: (enum_bitset_ops, enum_bitset_type): New types.
	All instances of parameters of type enum bitset_opts are now of
	type enum_bitset_opts, to conform to the C Standard, and similarly
	for enum_bitset_type.
	* lib/ebitset.c (enum_ebitset_find_mode): Likewise.
	* lib/lbitset.c (enum_lbitset_find_mode): Likewise.

	Do not use "struct bitset_struct" to mean different things in
	different modules.  Not only is this confusing, it violates
	the C Standard, which requires that structure types in different
	modules must be compatible if one is to be passed to the other.
	* lib/bbitset.h (bitset): Now points to a union, not to a struct.
	All instances of "struct bitset_struct *" replaced with "bitset".
	* lib/bitset.h (struct bitset_struct): Remove, replacing with....
	(union bitset_union, struct abitset_struct, struct ebitset_struct,
	struct lbitset_struct, struct bitset_stats_struct): New types.
	All uses of struct bitset_struct changed to union bitset_union,
	etc.
	* lib/abitset.c	(struct abitset_struct, abitset,
	struct bitset_struct): Remove.
	* lib/bitset_stats.c (struct bitset_stats_struct, bitset_stats,
	struct bitset_struct): Remove.
	* lib/ebitset.c (struct ebitset_struct, ebitset, struct
	bitset_struct): Remove.
	* lib/lbitset.c (struct lbitset_struct, lbitset, bitset_struct):
	Likewise.

	Do not call a function of type T using a call that assumes the
	function is of a different type U.  Standard C requires that a
	function must be called with a type that is compatible with its
	definition.
	* lib/bbitset.h (bitset_and_or_, bitset_andn_or_, bitset_or_and_):
	New decls.
	* lib/bitset.c (bitset_and_or_, bitset_andn_or_, bitset_or_and_):
	New functions.
	* lib/ebitset.c (PFV): Remove.
	* lib/lbitset.c (PFV): Likewise.
	* lib/ebitset.c (ebitset_and, ebitset_andn, ebitset_or,
	ebitset_xor, ebitset_copy, ebitset_ones, ebitset_empty_p): New
	decls.
	(ebitset_and, ebitset_andn, ebitset_or, ebitset_xor): New functions.
	(ebitset_vtable): Use them.
	* lib/lbitset.c (lbitset_and, lbitset_andn, lbitset_or,
	lbitset_xor): New functions.
	(lbitset_vtable): Use them.

	* lib/bitset.h (bitset_next, bitset_prev, bitset_only_set_p):
	Declare.

	* lib/bitsetv.c (bitsetv_alloc): Add a cast to (void *) to avoid a
	GCC warning.
	* lib/lbitset.c (LBITSET_CURRENT1): Likewise.
	Use offsetof, for simplicity.

2002-10-06  Paul Eggert  <eggert@twinsun.com>

	* lib/bitset.h (bitset_reset): Do not assume that bitset_word is
	the same width as int.  This reapplies a hunk of the 2002-08-12 patch
	<http://lists.gnu.org/archive/html/bison-patches/2002-08/msg00007.html>,
	which was inadvertently undone by the 2002-09-30 patch.
	* lib/lbitset.c (debug_lbitset): Do not assume that bitset_word is
	the same width as int.

2002-10-04  Paul Eggert  <eggert@twinsun.com>

	Version 1.50.

	* configure.ac (AC_INIT), NEWS: Increment version number.

	* doc/bison.texinfo: Minor spelling, grammar, and white space
	fixes.
	(Symbols): Mention that any negative value returned from yylex
	signifies end-of-input.  Warn about negative chars.  Mention
	the portable Standard C character set.

	The GNU coding standard says CFLAGS and YFLAGS are reserved
	for the installer to set.
	* lib/Makefile.am (AM_CFLAGS): Renamed from CFLAGS.
	* src/Makefile.am (AM_CFLAGS): Likewise.
	(AM_YFLAGS): Renamed from YFLAGS.

	Fix some MAX and MIN problems.
	* src/gram.h (ITEM_NUMBER_MIN): MIN_MAX -> INT_MIN.
	* src/lalr.h (GOTO_NUMBER_MAX): INT_MAX -> SHRT_MAX.
	* src/symtab.h (SYMBOL_NUMBER_MAX): New macro.
	* src/reader.c (reader): Use it.

	* tests/regression.at (Braces parsing): Use grep, not fgrep, as
	POSIX 1003.1-2001 has removed fgrep.

2002-10-04  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* lib/bbitset.h (BITSET_WINDEX_MAX): Redefine so that it cannot be
	interpreted as signed.
	* lib/ebitset.c (ebitset_list): Fix bug.

2002-10-01  Paul Eggert  <eggert@twinsun.com>

	More fixes for 64-bit hosts and large bitsets.

	* lib/abitset.c (struct abitset_struct.n_bits, abitset_small_list,
	abitset_size, abitset_list, abitset_list_reverse, abitset_list):
	Use bitset_bindex, not int or unsigned int or size_t, to count bits.
	* lib/bbitset.h (struct bitset_vtable.size, struct bitset_vtable.count,
	struct bitset_vtable.list, struct bitset_vtable.list_reverse,
	bitset_count_, bitset_next, bitset_prev, bitset_first, bitset_last,
	bitset_count_): Likewise.
	* lib/bitset.h (bitset_iterator.num, bitset_iterator.i,
	bitset_first, bitset_last): Likewise.
	* lib/bitset_stats.c (bitset_stats_size, bitset_stats_list,
	bitset_stats_list_reverse, bitset_stats_size,
	bitset_stats_count, bitset_stats_list, bitset_stat_list_reverse):
	Likewise.
	* lib/bitsetv-print.c (bitsetv_matrix_dump): Likewise.
	* lib/bitsetv.c (bitsetv_alloc, bitsetv_create, bitsetv_free,
	bitsetv_zero, bitsetv_ones, bitsetv_transitive_closure,
	bitsetv_reflexive_transitive_closure): Likewise.
	* lib/bitsetv.h (bitsetv_alloc, bitsetv_create): Likewise.
	* lib/ebitset.c (ebitset_size, ebitset_list, ebitset_list_reverse):
	Likewise.
	* lib/lbitset.c (lbitset_size, lbitset_list, lbitset_list_merge):
	Likewise.

	* lib/abitset.c (abitset_ones, abitset_zero, abitset_bytes):
	Use size_t, not unsigned int, to count bytes.
	* lib/abitset.h (abitset_bytes): Likewise.
	* lib/bitset.c (bitset_bytes, bitset_alloc, bitset_obstack_alloc):
	Likewise.
	* lib/bitset.h (bitset_bytes): Likewise.
	* lib/bitset_stats.c (bitset_stats_bytes, bitset_stats_init): Likewise.
	* lib/bitset_stats.h (bitset_stats_bytes): Likewise.
	* lib/bitsetv.c (bitsetv_alloc): Likewise.
	* lib/ebitset.c (ebitset_bytes): Likewise.
	* lib/ebitset.h (ebitset_bytes): Likewise.
	* lib/lbitset.c (lbitset_bytes): Likewise.
	* lib/lbitset.h (lbitset_bytes): Likewise.

	* lib/abitset.c (abitset_empty_p, abitset_not, abitset_equal_p,
	abitset_subset_p, abitset_disjoint_p, abitset_and,
	abitset_and_cmp, abitset_andn, abitset_andn_cmp, abitset_or,
	abitset_or_cmp, abitset_xor, abitset_xor_cmp, abitset_and_or,
	abitset_and_or_cmp, abitset_andn_or, abitset_andn_or_cmp,
	abitset_or_and, abitset_or_and_cmp):
	Use bitset_windex instead of unsigned int.
	* lib/bitsetv.c (bitsetv_dump, debug_bitsetv): Likewise.
	* lib/ebitset.c (struct ebitset_struct.size, ebitset_elts_grow,
	ebitset_elt_add, ebitset_elt_remove, ebitset_weed,
	ebitset_elt_find, ebitset_list_reverse, ebitset_list, ebitset_init):
	Likewise.
	* lib/lbitset.c (lbitset_ones, lbitset_not): Likewise.

	* lib/bitset.c (bitset_print):
	Use proper printf formats for widths of integer types.
	* lib/bitset_stats.c (bitset_percent_histogram_print,
	bitset_log_histogram_print, bitset_stats_print_1): Likewise.
	* lib/bitsetv-print.c (bitsetv_matrix_dump): Likewise.
	* lib/bitsetv.c (bitsetv_dump, debug_bitsetv): Likewise.
	* lib/lbitset.c (lbitset_bytes): Likewise.

	* lib/bbitset.h (BITSET_BINDEX_MAX, BITSET_WINDEX_MAX,
	BITSET_SIZE_MAX): New macros.
	(BITSET_INDEX_MAX): Remove.  It wasn't right, since it assumed that
	sizeof (bitset_word) == sizeof (bitset_windex).  All uses changed
	to BITSET_WINDEX_MAX.

	* lib/bitset.c (bitset_next, bitset_prev, bitset_first,
	bitset_last): Return BITSET_BINDEX_MAX (not -1) for no value,
	since we now return the bitset_bindex type (not int).

	* lib/bitsetv.c (bitsetv_alloc): Check for arithmetic overflow
	when computing sizes.
	* lib/ebitset.c (ebitset_elts_grow): Likewise.

	* lib/lbitset.c (lbitset_elt_find): Simplify windex calculation
	and avoid cast to unsigned.

2002-09-30  Akim Demaille  <akim@epita.fr>

	* lib/abitset.c, lib/bbitset.h, lib/bitset.c, lib/bitset.h,
	* lib/bitset_stats.c, lib/bitsetv.c, lib/ebitset.c, lib/lbitset.c:
	Updates from Michael Hayes.

2002-09-30  Art Haas  <ahaas@neosoft.com>

	* configure.ac: Update AC_OUTPUT and AM_CONFIG_HEADER
	invocations.
	* tests/cxx-type.at (declarator): Don't rely on NDEBUG being not
	defined.

2002-09-27  Akim Demaille  <akim@epita.fr>

	Version 1.49c.

2002-09-27  Akim Demaille  <akim@epita.fr>

	* configure.ac (AM_INIT_AUTOMAKE): We _need_ 1.7.
	(Because of AC_LIBSOURCE).

2002-09-27  Akim Demaille  <akim@epita.fr>

	Playing with Autoscan.

	* configure.ac: Remove the old LIBOBJ tweaks.
	(AC_REPLACE_FUNCS): Add strrchr and strtol.
	* lib/strrchr.c: New.
	* lib/strtol.c: New, from the Coreutils 4.5.1.

2002-09-27  Akim Demaille  <akim@epita.fr>

	Playing with Autoscan.

	* m4/prereq.m4 (jm_PREREQ_ARGMATCH, jm_FUNC_ARGMATCH): New.
	* lib/Makefile.am (libbison_a_SOURCES): No longer include
	argmatch.c and argmatch.h, since they are AC_LIBSOURCE'd.
	* lib/strcasecmp.c, lib/strncasecmp.c, lib/memcmp.c: New, from the
	Coreutils 4.5.1.

2002-09-24  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Stack Overflow): xref to Recursion.
	(Frequently Asked Questions, Parser Stack Overflow): New.

2002-09-13  Akim Demaille  <akim@epita.fr>

	Playing with autoscan.

	* src/reader.c (get_merge_function): Use xstrdup, not strdup.
	* src/files.c (skeleton_find): Remove, unused.
	* m4/memcmp.m4: New, from the Coreutils 4.5.1.
	* m4/prereq.m4 (jm_PREREQ_QUOTEARG): Run jm_FUNC_MEMCMP.

2002-09-13  Akim Demaille  <akim@epita.fr>

	* configure.ac (AM_INIT_AUTOMAKE): Require Automake 1.6.3.
	* Makefile.am (AUTOMAKE_OPTIONS): Don't.

2002-09-13  Akim Demaille  <akim@epita.fr>

	* configure.ac: Require 2.54.
	s/jm_FUNC_MALLOC/AC_FUNC_MALLOC/.
	s/jm_FUNC_REALLOC/AC_FUNC_REALLOC/.
	* m4/c-bs-a.m4, m4/malloc.m4, m4/mbstate_t.m4, m4/realloc.m4:
	Remove, provided by Autoconf macros.

2002-09-12  Akim Demaille  <akim@epita.fr>

	* m4/prereq.m4: Update, from Coreutils 4.5.1.

2002-09-12  Akim Demaille  <akim@epita.fr>

	* m4/prereq.m4: Update, from Fileutils 4.1.5.
	* configure.ac (jm_PREREQ_TEMPNAME): Invoke it.
	Reported by Martin Mokrejs.

2002-09-10  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y: Associate a human readable string to each
	token type.
	* tests/regression.at (Invalid inputs): Adjust.

2002-09-10  Gary V. Vaughan  <gary@gnu.org>

	* tests/Makefile.am ($(srcdir)/package.m4): Bison now ships
	with an Autoconf-2.5x style configure.ac.

2002-09-06  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo (Conditions): Make explicit that the GPL
	exception applies only to yacc.c.  This is a modification of a
	patch originally suggested by Akim Demaille.

2002-09-06  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_copyright): Move the GPL exception comment from
	here to...
	* data/yacc.c: here.

	* data/lalr1.cc (struct yyltype): Don't define it, since we use
	LocationType.
	(b4_ltype): Default to yy::Location from location.hh.

2002-09-04  Jim Meyering  <jim@meyering.net>

	* data/yacc.c: Guard the declaration of yytoknum also with
	`#ifdef YYPRINT', so it is declared only when used.

2002-09-04  Akim Demaille  <akim@epita.fr>

	* configure.in: Rename as...
	* configure.ac: this.
	Bump to 1.49c.

2002-09-04  Akim Demaille  <akim@epita.fr>

	* src/assoc.c, src/closure.c, src/gram.c, src/injections.c,
	* src/lalr.c, src/LR0.c, src/relation.c, src/tables.c: Don't
	translate maintainer only messages.

2002-08-12  Paul Eggert  <eggert@twinsun.com>

	Version 1.49b.

	* Makefile.am (SUBDIRS): Remove intl.
	(DISTCLEANFILES): Remove.
	* NEWS: Mention that GNU M4 is now required.  Clarify what is
	meant by "larger grammars".  Mention the pt_BR translation.
	* configure.in (AC_CHECK_DECLS): Add getenv, getopt.
	(AM_GNU_GETTEXT_VERSION): New macro, replacing GETTEXT_VERSION var.
	Bump version from 0.11.2 to 0.11.5.
	(BISON_PREREQ_STAGE): Remove.
	(AM_GNU_GETTEXT): Use external gettext.
	(AC_OUTPUT): Remove intl/Makefile.

	* config/depcomp, config/install-sh: Sync with Automake 1.6.3.

	* data/glr.c: Include string.h, for strlen.
	(yyreportParseError): Use size_t for yysize.
	(yy_yypstack): No longer nested inside yypstates, as nested
	functions are not portable.  Do not assume size_t is the
	same width as int.
	(yypstates): Do not assume that ptrdiff_t is the same width
	as int, and similarly for yyposn and YYINDEX.

	* data/yacc.c: Fix comment about `$$ = $1': it can copy garbage.

	* lib/Makefile.am (INCLUDES): Do not include from the intl
	directory, which has been removed.
	* src/Makefile.am (INCLUDES): Likewise.

	* lib/Makefile.am (libbison_a_SOURCES): Add unlocked-io.h.
	(bitsets_sources, additional_bitsets_sources, timevars_sources):
	New vars.

	* lib/Makefile.am (libbison_a_SOURCES): Avoid +=, a GNU make extension.
	* tests/Makefile.am (EXTRA_DIST): Likewise.

	* lib/abitset.c (abitset_reverse_list, ebitset_reverse_list):
	Do not assume that bitset_windex is the same width as unsigned.

	* lib/abitset.c (abitset_unused_clear): Do not assume that
	bitset_word is the same width as int.
	* lib/bbitset.h (BITSET_INDEX_MAX, BITSET_MSB): Likewise.
	* lib/bitset.h (bitset_set, bitset_reset): Likewise.
	* lib/bitset_stats.c (bitset_stats_set, bitset_stats_reset): Likewise.
	* lib/ebitset.c (ebitset_set, ebitset_reset): Likewise.
	* lib/lbitset.c (lbitset_set, lbitset_reset): Likewise.

	* lib/abitset.c (abitset_op1): Use -1, not ~0, as memset arg (for
	portability to one's complement hosts!).
	* lib/ebitset.c (ebitset_op1): Likewise.
	* lib/lbitset.c (lbitset_op1): Likewise.

	* lib/argmatch.c, lib/quotearg.c, quotearg.h: Sync with GNU tar.
	* lib/argmatch.h, lib/basename.c, lib/dirname.c, lib/dirname.h,
	lib/hash.c, lib/hash.h, lib/strnlen.c, lib/xmalloc.c:
	Sync with fileutils.
	* lib/error.c, lib/getopt.c, lib/getopt.h, lib/getopt1.c,
	lib/gettext.h: Sync with diffutils.

	* lib/memrchr.c, lib/mkstemp.c, lib/strchr.c, lib/strnlen.c,
	lib/strspn.c, lib/tempname.c: Use GPL, not LGPL.

	* lib/obstack.c, lib/obstack.h: Sync with fileutils, except use
	PROTOTYPES to check for prototypes, and "defined __STDC__" to
	check for void *.

	* lib/bbitset.h (BITSET_WORD_BITS): Now of type unsigned, not
	size_t; the old version tried to do this but casted improperly.
	(bitset_bindex, bitset_windex): Now size_t, not unsigned long.
	(bitset_test): Now returns int, not unsigned long.

	* lib/bitset_stats.c: Include "gettext.h".
	(_): New macro.
	(bitset_stats_set, bitset_stats_reset, bitset_stats_test): Don't
	name locals "index", as it generates unnecessary warnings on some
	hosts that have an "index" function.

	* lib/bitset_stats.c (bitset_stats_print_1, bitset_stats_print,
	bitset_stats_read, bitset_stats_write): Wrap strings in _() if
	they need translation.
	* src/LR0.c (state_list_append, new_itemsets, get_state,
	append_states, generate_states): Likewise.
	* src/assoc.c (assoc_to_string): Likewise.
	* src/closure.c (print_closure, set_firsts, closure): Likewise.
	* src/gram.c (grammar_dump): Likewise.
	* src/injections.c (injections_compute): Likewise.
	* src/lalr.c (lookaheads_print): Likewise.
	* src/relation.c (relation_transpose): Likewise.
	* src/scan-gram.l: Likewise.
	* src/tables.c (table_grow, pack_vector): Likewise.

	* m4/Makefile.am (EXTRA_DIST): Remove codeset.m4,
	glibc21.m4, isc-posix.m4 lcmessage.m4, stage.m4.
	* m4/malloc.m4, m4/realloc.m4: Sync with diffutils.
	* m4/mbstate_t.m4: Sync with fileutils.
	* m4/prereq.m4 (jm_PREREQ_QUOTEARG): AC_MBSTATE_T -> AC_TYPE_MBSTATE_T.

	* po/LINGUAS: Add pt_BR.
	* po/POTFILES.in: Add src/assoc.c, src/closure.c, src/gram.c,
	src/main.c, src/relation.c, src/state.c, lib/bitset_stats.c,
	lib/timevar.c.
	Use src/parse-gram.y instead of src/parse-gram.c, as the gettext
	manual recommends.
	Similarly, use src/scan-gram.l instead of src/scan-gram.c.

	* src/complain.c (strerror_r): Remove decl; not needed.
	(strerror): Use same pattern as ../lib/error.c.

	* src/files.c, src/files.h (compute_header_macro): Remove; unused.

	* src/gram.c (grammar_dump): Do not assume ptrdiff_t fits in int.

	* src/main.c (main): Cast result of bindtextdomain and textdomain
	to void, to avoid a GCC warning when --disable-nls is in effect.

	* src/scan-gram.l: Use strings rather than escapes when possible,
	to minimize the number of warnings from xgettext.
	(handle_action_dollar, handle_action_at): Don't use isdigit,
	as it mishandles negative chars and it may not work as expected
	outside the C locale.

	* src/symtab.c (symbol_get): Don't cast LHS of an assignment;
	this is a GCC extension and is not portable to other compilers.

	* src/system.h (alloca): Use same pattern as ../lib/error.c.
	Do not include <ctype.h>; no longer needed.
	Do not include <malloc.h>; no longer needed (and generates
	warnings on OpenBSD 3.0).

	* tests/cxx-type.at (yylex): Do not pass signed char to isupper;
	it's not portable.

	* tests/regression.at: Do not use 'cc -c input.c -o input';
	Sun C rejects this.  Instead, use 'cc -c input.c -o input.o'.

	* tests/synclines.at (AC_SYNCLINES_COMPILE): Accept any nonzero
	exit status as failure, not just exit status 1.  Sun C exits
	with status 2 sometimes.

	* tests/torture.at (AT_INCREASE_DATA_SIZE): New macro.
	Use it for the two large tests.

2002-08-02  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (conflicts_output): Don't output rules never
	reduced here, since anyway that computation doesn't work.
	* src/gram.h, src/gram.h (rule_filter_t, rule_useful_p)
	(rule_useless_p, rule_never_reduced_p): New.
	(grammar_rules_partial_print): Use a filter instead of a range.
	Display the title only if needed.
	(grammar_rules_print): Adjust.
	(grammar_rules_never_reduced_report): New.
	* src/tables.c (action_row): Move the computation of rules never
	reduced to...
	(token_actions): here.
	* src/main.c (main): Make the parser before making the report, so
	that rules never reduced are computed.
	Call grammar_rules_never_reduced_report.
	* src/print.c (print_results): Report rules never reduced.
	* tests/conflicts.at, tests/reduce.at: Adjust.

2002-08-01  Akim Demaille  <akim@epita.fr>

	Instead of attaching lookaheads and duplicating the rules being
	reduced by a state, attach the lookaheads to the reductions.

	* src/state.h (state_t): Remove the `lookaheads',
	`lookaheads_rule' member.
	(reductions_t): Add a `lookaheads' member.
	Use a regular array for the `rules'.
	* src/state.c (reductions_new): Initialize the lookaheads member
	to 0.
	(state_rule_lookaheads_print): Adjust.
	* src/state.h, src/state.c (state_reductions_find): New.
	* src/conflicts.c (resolve_sr_conflict, set_conflicts)
	(count_rr_conflicts): Adjust.
	* src/lalr.c (LArule): Remove.
	(add_lookback_edge): Adjust.
	(state_lookaheads_count): New.
	(states_lookaheads_initialize): Merge into...
	(initialize_LA): this.
	(lalr_free): Adjust.
	* src/main.c (main): Don't free nullable and derives too early: it
	is used by --verbose.
	* src/print.c, src/print_graph.c, src/tables.c: Adjust.

2002-08-01  Akim Demaille  <akim@epita.fr>

	* src/derives.h, src/derives.c (derives): A `rule_t***' instead of
	`rule_number_t**'.
	(set_derives, free_derives): Rename as...
	(derives_compute, derives_free): this.
	Adjust all dependencies.
	* src/nullable.c (set_nullable, free_nullable): Rename as...
	(nullable_compute, nullable_free): these.
	(rule_list_t): Store rule_t *, not rule_number_t.
	* src/state.c (state_rule_lookaheads_print): Directly compare rule
	pointers, instead of their numbers.
	* src/main.c (main): Call nullable_free, and derives_free earlier,
	as they were lo longer used.

2002-08-01  Akim Demaille  <akim@epita.fr>

	* lib/timevar.c (get_time): Include children time.
	* src/lalr.h (LA, LArule): Don't export them: used with the
	state_t.
	* src/lalr.c (LA, LArule): Static.
	* src/lalr.h, src/lalr.c (lalr_free): New.
	* src/main.c (main): Call it.
	* src/tables.c (pack_vector): Check whether loc is >= to the
	table_size, not >.
	(pack_tables): Don't free froms, tos, conflict_tos, and pos...
	(tables_generate): do it, since that's also it which allocates
	them.
	Don't free LA and LArule, main does.

2002-07-31  Akim Demaille  <akim@epita.fr>

	Separate parser tables computation and output.

	* src/output.c (nvectors, base_t, base, base_ninf, conflict_table)
	(conflict_list, conflict_list_cnt, table, check, table_ninf)
	(yydefgoto, yydefact, high): Move to...
	* src/tables.h, src/tables.c: here.
	* src/output.c (vector_number_t, VECTOR_NUMBER_MAX)
	(VECTOR_NUMBER_MIN, state_number_to_vector_number)
	(symbol_number_to_vector_number, nvectors, BASE_MAX, BASE_MIN)
	(froms, tos, conflict_tos, tally, width, action_t, ACTION_MAX)
	(ACTION_MIN, actrow, order, nentries, pos, conflrow)
	(conflict_list_free, table_size, lowzero, table_grow, conflict_row)
	(action_row, save_row, token_actions, save_column, default_goto)
	(goto_actions, sort_actions, matching_state, pack_vector)
	(table_ninf_remap, pack_table, prepare_actions): Move to...
	* src/tables.c: here.
	* src/tables.h, src/tables.c(tables_generate, tables_free): New.
	* src/output.c (token_actions, output_base, output_conflicts)
	(output_check): Merge into...
	(prepare_actions): this.
	(actions_output): Rename as...
	(user_actions_output): this.
	* src/main.c (main): Call tables_generate and tables_free.

2002-07-31  Akim Demaille  <akim@epita.fr>

	Steal GCC's --time-report support.

	* lib/timevar.c, lib/timevar.h, lib/timevar.def: New,
	stolen/adjusted from GCC.
	* m4/stage.m4: Remove time related checks.
	* m4/timevar.m4: New.
	* configure.in: Adjust.
	* src/system.h: Adjust to using timevar.h.
	* src/getargs.h, src/getargs.c: Support trace_time for
	--trace=time.
	* src/main.c (stage): Remove.
	(main): Replace `stage' invocations with timevar calls.
	* src/output.c: Insert pertinent timevar calls.

2002-07-31  Akim Demaille  <akim@epita.fr>

	Let --trace have arguments.

	* src/getargs.h (enum trace_e): New.
	* src/getargs.c (trace_args, trace_types, trace_argmatch): New.
	(long_options, short_options): --trace/-T takes an optional
	argument.
	Change all the uses of trace_flag to reflect the new flags.
	* tests/sets.at (Firsts, Nullable, Broken Closure): Use --trace=sets.

	Strengthen `stage' portability.

	* m4/stage.m4 (BISON_PREREQ_STAGE): New.
	* configure.in: Use it.
	Don't check for malloc.h and sys/times.h.
	* src/system.h: Include them when appropriate.
	* src/main.c (stage): Compile only when mallinfo, struct mallinfo,
	times and struct tms are available.

2002-07-30  Akim Demaille  <akim@epita.fr>

	In verbose parse error message, don't report `error' as an
	expected token.
	* tests/actions.at (Printers and Destructors): Adjust.
	* tests/calc.at (Calculator $1): Adjust.
	* data/yacc.c, data/glr.c, data/lalr1.c: When making the verbose
	error message, do not report the parser accepts the error token in
	that state.

2002-07-30  Akim Demaille  <akim@epita.fr>

	Normalize conflict related messages.

	* src/complain.h, src/complain.c (warn, complain): New.
	* src/conflicts.c (conflicts_print): Use them.
	(conflict_report_yacc): New, extracted from...
	(conflicts_print): here.
	* tests/conflicts.at, tests/existing.at: Adjust.

2002-07-30  Akim Demaille  <akim@epita.fr>

	Report rules which are never reduced by the parser: those hidden
	by conflicts.

	* src/LR0.c (save_reductions): Don't make the final state too
	different: save its reduction (accept) instead of having a state
	without any action (no shift or goto, no reduce).
	Note: the final state is now a ``regular'' state, i.e., the
	parsers now contain `reduce 0' as default reduction.
	Nevertheless, since they decide to `accept' when yystate =
	final_state, they still will not reduce rule 0.
	* src/print.c (print_actions, print_reduction): Adjust.
	* src/output.c (action_row): Track reduced rules.
	(token_actions): Report rules never reduced.
	* tests/conflicts.at, tests/regression.at: Adjust.

2002-07-30  Akim Demaille  <akim@epita.fr>

	`stage' was accidently included in a previous patch.
	Initiate its autoconfiscation.

	* configure.in: Look for malloc.h and sys/times.h.
	* src/main.c (stage): Adjust.
	Report only when trace_flag.

2002-07-29  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (transitions_t): Holds state_t*'s, not
	state_number_t.
	(errs_t): symbol_t*, not symbol_number_t.
	(reductions_t): rule_t*, not rule_number_t.
	(FOR_EACH_SHIFT): New.
	* src/LR0.c, src/conflicts.c, src/lalr.c, src/output.c
	* src/print.c, src/print_graph.c: Adjust.

2002-07-29  Akim Demaille  <akim@epita.fr>

	Use $accept and $end, as BYacc and BTYacc do, instead of $axiom and $.

	* src/symtab.h, src/symtab.c (eoftoken, axiom): Rename as...
	(endtoken, accept): these.
	* src/reader.c (reader): Set endtoken's default tag to "$end".
	Set undeftoken's tag to "$undefined" instead of "$undefined.".
	* doc/bison.texinfo (Table of Symbols): Mention $accept and $end.
	Adjust.

2002-07-29  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (reduce_grammar): When the language is empty,
	complain about the start symbol, not the axiom.
	Use its location.
	* tests/reduce.at (Empty Language): New.

2002-07-26  Akim Demaille  <akim@epita.fr>

	* src/reader.h, src/reader.c (gram_error): ... can't get
	yycontrol without making too strong assumptions on the parser
	itself.
	* src/output.c (prepare_tokens): Use the real 0th value of
	token_translations instead of `0'.
	* src/parse-gram.y (yyerror): Don't rely on yycontrol being
	visible here.
	* data/yacc.c (yyreport_parse_error): Rename yylocation as yylloc
	for the time being: %locations ought to provide it to yyerror.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare_tokens): Go up to ntokens, not ntokens + 1.
	* doc/bison.texinfo (Decl Summary): s/$illegal/$undefined./.
	* tests/regression.at (Web2c Actions): Adjust.

2002-07-25  Akim Demaille  <akim@epita.fr>

	Stop storing rules from 1 to nrules + 1.

	* src/LR0.c, src/closure.c, src/derives.c, src/gram.c, src/lalr.c
	* src/nullable.c, src/output.c, src/print.c, src/reader.c
	* src/reduce.c: Allocate and free from &rules[0], not &rules[1].
	Iterate from 0 to nrules.
	Use rule_number_as_item_number and item_number_as_rule_number.
	Adjust to `derive' now containing possibly 0.
	* src/gram.h (rule_number_as_item_number, item_number_as_rule_number):
	Handle the `- 1' part in rule numbers from/to item numbers.
	* src/conflicts.c (log_resolution): Fix the message which reversed
	shift and reduce.
	* src/output.c (action_row): Initialize default_rule to -1.
	(token_actions): Adjust.
	* tests/sets.at (Nullable, Firsts): Fix the previously bogus
	expected output.
	* tests/conflicts.at (Resolved SR Conflicts): Likewise.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_c_function, b4_c_ansi_args, b4_c_ansi_arg)
	(b4_c_knr_arg_names, b4_c_knr_arg_name, b4_c_knr_arg_decls)
	(b4_c_knr_arg_decl): New.
	* data/yacc.c: Use it to define yysymprint, yydestruct, and
	yyreport_parse_error.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (yyreport_parse_error): New, extracted from...
	(yyparse): here.
	(yydestruct, yysymprint): Move above yyparse.
	Be K&R compliant.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_ints_in, b4_int_type, b4_int_type_for): New,
	replace...
	(b4_sint_type, b4_uint_type): these.
	* data/yacc.c, data/glr.c, data/lalr1.cc: Use b4_int_type_for.
	* tests/regression.at (Web2c Actions): Adjust.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* src/gram.h (TIEM_NUMBER_MAX): New.
	(item_number_of_rule_number, rule_number_of_item_number): Rename
	as...
	(rule_number_as_item_number, item_number_as_rule_number): these.
	Adjust dependencies.
	* src/output.c (vector_number_t, VECTOR_NUMBER_MAX)
	(VECTOR_NUMBER_MIN, state_number_to_vector_number)
	(symbol_number_to_vector_number): New.
	(order): Of vector_number_t* type.
	(base_t, BASE_MAX, BASE_MIN): New.
	(froms, tos, width, pos, check): Of base_t type.
	(action_number_t, ACTION_MIN, ACTION_MAX): New.
	(actrow): Of action_number_t type.
	(conflrow): Of unsigned int type.
	(table_ninf, base_ninf): New.
	(GENERATE_MUSCLE_INSERT_TABLE): Also output the `*_min' value.
	(muscle_insert_int_table, muscle_insert_base_table)
	(muscle_insert_rule_number_table): New.
	(prepare_tokens): Output `toknum' as int_table.
	(action_row): Returns a rule_number_t.
	Use ACTION_MIN, not SHRT_MIN.
	(token_actions): yydefact is rule_number_t*.
	(table_ninf_remap): New.
	(pack_table): Use it for `base' and `table'.
	* data/yacc.c, data/glr.c, data/lalr1.cc (YYFLAG): Remove,
	replaced with...
	(YYPACT_NINF, YYTABLE_NINF): these.
	(yypact, yytable): Compute their types instead of hard-coded
	`short'.
	* tests/regression.at (Web2c Actions): Adjust.

2002-07-19  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (id): Can start with an underscore.

2002-07-16  Akim Demaille  <akim@epita.fr>

